﻿var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var AnalyticsKosgu;
(function (AnalyticsKosgu) {
    var AnalyticsDataTable = (function (_super) {
        __extends(AnalyticsDataTable, _super);
        function AnalyticsDataTable(id, _document) {
            var _this = _super.call(this, id) || this;
            _this._document = _document;
            _this._kosgu = null;
            _this._analyticCode = null;
            _this._analyticName = null;
            return _this;
        }
        Object.defineProperty(AnalyticsDataTable.prototype, "Kosgu", {
            get: function () {
                if (this._kosgu == null) {
                    this._kosgu = new ObasSprTableField(ObasTableCollection.KosguSprTable, this);
                }
                return this._kosgu;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnalyticsDataTable.prototype, "AnalyticCode", {
            get: function () {
                if (this._analyticCode == null) {
                    this._analyticCode = new ObasTableField("AnalyticCode", this);
                }
                return this._analyticCode;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnalyticsDataTable.prototype, "AnalyticName", {
            get: function () {
                if (this._analyticName == null) {
                    this._analyticName = new ObasTableField("AnalyticName", this);
                }
                return this._analyticName;
            },
            enumerable: true,
            configurable: true
        });
        AnalyticsDataTable.prototype.DeleteEventHandler = function (tableId) {
            for (var i = 0; i <= ObasStageSettings.YearsCount; i++) {
                var fieldId = "Y" + (i + 1);
                var oldValue = this.GetFieldValue(fieldId) || 0;
                var newValue = 0;
                this.SumChangeEventHandler(tableId, oldValue, newValue, fieldId);
            }
            if (this.IsSecondRow() && (this.RowCount > 2)) {
                this.Next();
                this.FillAnalyticsData(true);
                this.Prev();
            }
        };
        AnalyticsDataTable.prototype.KosguChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this.FillAnalyticsData();
        };
        AnalyticsDataTable.prototype.SumChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            var curKey = this.RecordKey.Value;
            if (this.RecordKey.Value != 1) {
                if (this.Locate(this.RecordKey.Id, 1)) {
                    var oldTotalValue = this.GetFieldValue(fieldId);
                    this.SetFieldValue(fieldId, oldTotalValue + (newValue - oldValue));
                }
            }
            this.Locate(this.RecordKey.Id, curKey);
        };
        AnalyticsDataTable.prototype.IsSecondRow = function () {
            var result = false;
            if (this.RowCount > 1) {
                this.Prev();
                result = (this.RecordKey.Value === 1);
                this.Next();
            }
            return result;
        };
        AnalyticsDataTable.prototype.FillAnalyticsData = function (needPrefix) {
            var kosguName = this.Kosgu.Name;
            this.AnalyticName.Value = kosguName.charAt(0).toLowerCase() + kosguName.slice(1);
            if (needPrefix == null) {
                needPrefix = this.IsSecondRow();
            }
            if (needPrefix) {
                this.AnalyticName.Value = "\u0432 \u0442\u043E\u043C \u0447\u0438\u0441\u043B\u0435:\n" + this.AnalyticName.Value;
            }
            this.AnalyticCode.Value = this.Kosgu.Code;
        };
        AnalyticsDataTable.prototype.CollectKosguData = function () {
            var kosguData = [];
            var reader = this.CreateReader();
            while (reader.Read()) {
                var record = {
                    Code: (this.RecordKey.Value === 1) ? "-" : this.Kosgu.Code,
                    Data: []
                };
                for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                    record.Data[j] = this.GetFieldValue("Y" + j) || 0;
                }
                kosguData.push(record);
            }
            return kosguData;
        };
        return AnalyticsDataTable;
    }(SprTable));
    AnalyticsKosgu.AnalyticsDataTable = AnalyticsDataTable;
    var AnalyticsRowsTable = (function (_super) {
        __extends(AnalyticsRowsTable, _super);
        function AnalyticsRowsTable(id, _document) {
            var _this = _super.call(this, id) || this;
            _this._document = _document;
            _this._parentKey = null;
            _this._kosgu = null;
            _this._analyticCode = null;
            _this._analyticName = null;
            _this._isAgr = null;
            _this._barsCode = null;
            _this._reverseKey = null;
            _this._isUnvisible = null;
            return _this;
        }
        Object.defineProperty(AnalyticsRowsTable.prototype, "ParentKey", {
            get: function () {
                if (this._parentKey == null) {
                    this._parentKey = new NumberObasTableField("ParentKey", this);
                }
                return this._parentKey;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnalyticsRowsTable.prototype, "Kosgu", {
            get: function () {
                if (this._kosgu == null) {
                    this._kosgu = new ObasSprTableField(ObasTableCollection.KosguSprTable, this);
                }
                return this._kosgu;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnalyticsRowsTable.prototype, "AnalyticCode", {
            get: function () {
                if (this._analyticCode == null) {
                    this._analyticCode = new ObasTableField("AnalyticCode", this);
                }
                return this._analyticCode;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnalyticsRowsTable.prototype, "AnalyticName", {
            get: function () {
                if (this._analyticName == null) {
                    this._analyticName = new ObasTableField("AnalyticName", this);
                }
                return this._analyticName;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnalyticsRowsTable.prototype, "IsAgr", {
            get: function () {
                if (this._isAgr == null) {
                    this._isAgr = new ObasTableField("IsAgr", this);
                }
                return this._isAgr;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnalyticsRowsTable.prototype, "BarsCode", {
            get: function () {
                if (this._barsCode == null) {
                    this._barsCode = new ObasTableField("BarsCode", this);
                }
                return this._barsCode;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnalyticsRowsTable.prototype, "ReverseKey", {
            get: function () {
                if (this._reverseKey == null) {
                    this._reverseKey = new NumberObasTableField("ReverseKey", this);
                }
                return this._reverseKey;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnalyticsRowsTable.prototype, "IsUnvisible", {
            get: function () {
                if (this._isUnvisible == null) {
                    this._isUnvisible = new ObasTableField("IsUnvisible", this);
                }
                return this._isUnvisible;
            },
            enumerable: true,
            configurable: true
        });
        return AnalyticsRowsTable;
    }(SprTable));
    AnalyticsKosgu.AnalyticsRowsTable = AnalyticsRowsTable;
    var AnalyticsValuesTable = (function (_super) {
        __extends(AnalyticsValuesTable, _super);
        function AnalyticsValuesTable(id, document, parent) {
            return _super.call(this, id, document, parent) || this;
        }
        Object.defineProperty(AnalyticsValuesTable.prototype, "ParentTable", {
            get: function () {
                return this.OwnerKey.SourceTable;
            },
            enumerable: true,
            configurable: true
        });
        AnalyticsValuesTable.prototype.SumChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            var curKey = this.RecordKey.Value;
            var reverseKey = this.ParentTable.ReverseKey.Value;
            var parentKey = this.ParentTable.ParentKey.Value;
            if (reverseKey !== null) {
                if (this.Locate(this.OwnerKey.Id, reverseKey)) {
                    var curValue = this.GetFieldValue(fieldId);
                    this.SetFieldValue(fieldId, curValue - (newValue - oldValue));
                }
            }
            if (parentKey !== null) {
                if (this.Locate(this.OwnerKey.Id, parentKey)) {
                    var curValue = this.GetFieldValue(fieldId);
                    this.SetFieldValue(fieldId, curValue + (newValue - oldValue));
                }
            }
            this.Locate(this.RecordKey.Id, curKey);
            if (this.RecordKey.Value != 1 && parentKey != 1) {
                if (this.Locate(this.RecordKey.Id, 1)) {
                    var oldTotalValue = this.GetFieldValue(fieldId);
                    this.SetFieldValue(fieldId, oldTotalValue + (newValue - oldValue));
                }
            }
            this.Locate(this.RecordKey.Id, curKey);
        };
        AnalyticsValuesTable.prototype.CollectKosguData = function () {
            var kosguData = [];
            var keys = [];
            var parentKeys = [];
            var levels = [];
            var parentTable = this.ParentTable;
            var reader = parentTable.CreateReader();
            while (reader.Read()) {
                keys.push(parentTable.RecordKey.Value);
                parentKeys.push(parentTable.ParentKey.Value);
                levels.push(0);
                var record = {
                    Code: parentTable.AnalyticCode.Value,
                    Data: []
                };
                var ownerKey = parentTable.RecordKey.Value;
                if (this.Locate(this.OwnerKey.Id, ownerKey) && ownerKey !== 1) {
                    levels[levels.length - 1] = 1;
                    for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                        record.Data[j] = this.GetFieldValue("Y" + j) || 0;
                    }
                }
                kosguData.push(record);
            }
            var level = 1;
            while (levels.indexOf(0) !== -1) {
                for (var i = 0; i < levels.length; i++) {
                    if (levels[i] === level) {
                        var parentKey = parentKeys[i];
                        var keyIndex = keys.indexOf(parentKey);
                        if (keyIndex !== -1) {
                            for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                                kosguData[keyIndex].Data[j] = (kosguData[keyIndex].Data[j] || 0) + (kosguData[i].Data[j] || 0);
                            }
                        }
                        levels[keyIndex] = level + 1;
                    }
                }
                level++;
            }
            return kosguData;
        };
        return AnalyticsValuesTable;
    }(ObasTableWithSimpleKeysParent));
    AnalyticsKosgu.AnalyticsValuesTable = AnalyticsValuesTable;
})(AnalyticsKosgu || (AnalyticsKosgu = {}));
