var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F02110;
(function (F02110) {
    var InterfaceRules = (function (_super) {
        __extends(InterfaceRules, _super);
        function InterfaceRules() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        InterfaceRules.prototype.ObjectDescSheetFormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 0:
                case 1:
                    return SheetFormatCollection.Related;
                case 2:
                    return SheetFormatCollection.Default;
                case 3:
                case 7:
                    return SheetFormatCollection.Spr;
                default:
                    return SheetFormatCollection.Free;
            }
        };
        InterfaceRules.prototype.ObjectDescSheetCalcEventHandler = function (sheetId, row, column, fieldId) {
            if (BaseObasTableFields.StrCodeField.Equal(fieldId)) {
                return ObasHelper.FillWithCharacter(row + 1, 6);
            }
            return undefined;
        };
        InterfaceRules.prototype.ObjectDescSheetCanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return column > 2;
        };
        InterfaceRules.prototype.ObjectDescSheetCanEditEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            var table = this._document.Sheets.getValue(sheetId).Table;
            if (column > 2) {
                return table.GetKeyBySourceTable(this._document.P3RefObjDescNpaTable) != null;
            } else {
                return false;
            }
        };
        InterfaceRules.prototype.ObjectDescSheetCanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return this.ObjectDescSheetCanEditEventHandler(sheetId, row, column, fieldId, rowLevel);
        };
        InterfaceRules.prototype.FilterOKPD = function () {
            var okpdCode = ObasTableCollection.OkpdSprTable.Code.Value || "";
            return okpdCode.length >= 5;
        };
        InterfaceRules.prototype.FilterNPAStatuses = function () {
            var npaStatusesTable = ObasTableCollection.NpaStatusesSprTable;
            return npaStatusesTable.RecordKey.Value === 1 || npaStatusesTable.RecordKey.Value === 2;
        };
        InterfaceRules.prototype.PurchaseObjectsEditorEditFieldEventHandler = function (sheetId, fieldId, newValue, oldValue) {
            var sourceTable = this._document.PurchaseObjectsSprTable;
            switch (fieldId) {
                case sourceTable.Name.Id:
                case sourceTable.NpaGroupKey.Id:
                    var result = 0;
                    var nameObj = sourceTable.Name.Value;
                    var npaGroupKey = sourceTable.NpaGroupKey.Value;
                    while (sourceTable.Locate([sourceTable.Name.Id, sourceTable.NpaGroupKey.Id], [nameObj, npaGroupKey], true)) {
                        result = result + 1;
                    }
                    sourceTable.ClearLocateFlag();
                    this._canAddPurchaseObject = (result === 1);
                    break;
            }
            return true;
        };
        InterfaceRules.prototype.PurchaseObjectsEditorOnCanCloseEventHandler = function (buttonResult) {
            var sourceTable = this._document.PurchaseObjectsSprTable;
            if (buttonResult === MessageResults.Cancel) {
                return true;
            }
            else {
                if (!this._canAddPurchaseObject) {
                    Client.ShowMessage("\u041E\u0448\u0438\u0431\u043A\u0430", "\u0423\u0436\u0435 \u0441\u0443\u0449\u0435\u0441\u0442\u0432\u0443\u0435\u0442 \u043E\u0431\u044A\u0435\u043A\u0442 \u0437\u0430\u043A\u0443\u043F\u043A\u0438 \u0441 \u0442\u0430\u043A\u0438\u043C \u043D\u0430\u0438\u043C\u0435\u043D\u043E\u0432\u0430\u043D\u0438\u0435\u043C \u0438 \u043F\u043E\u0434\u0433\u0440\u0443\u043F\u043F\u043E\u0439 \u043D\u043E\u0440\u043C\u0430\u0442\u0438\u0432\u043D\u044B\u0445 \u0437\u0430\u0442\u0440\u0430\u0442", MessageIcons.Error);
                }
                return (this._canAddPurchaseObject && buttonResult === MessageResults.Ok);
            }
        };
        InterfaceRules.prototype.NpaEditorOnCanCloseEventHandler = function (buttonResult) {
            if (buttonResult === MessageResults.Cancel) {
                return true;
            }
            else {
                var canAddNpa = ObasTableCollection.NpaSprTable.IsUniqueRow();
                if (!canAddNpa) {
                    Client.ShowMessage("\u041E\u0448\u0438\u0431\u043A\u0430", "\u0423\u0436\u0435 \u0441\u0443\u0449\u0435\u0441\u0442\u0432\u0443\u0435\u0442 \u0442\u0430\u043A\u043E\u0439 \u041D\u041F\u0410", MessageIcons.Error);
                }
                return (canAddNpa && buttonResult === MessageResults.Ok);
            }
        };
        InterfaceRules.prototype.AfterStartEventHandler = function () {
            ObasTableCollection.NpaSprTable.UpdateDataRows(this._document.P3RefObjDescNpaTable);
        };
        InterfaceRules.prototype.CheckChangeType = function () {
            var result = this._document.CommonRules.CheckChangeType();
            if (result) {
                result = this.CheckFormData();
                if (!result) {
                    Client.ShowMessage("\u041E\u0448\u0438\u0431\u043A\u0430", "\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435 \u0440\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435 \u043E\u0431\u044A\u0435\u043C\u0430 \u0440\u0430\u0441\u0445\u043E\u0434\u043E\u0432 \u043D\u0430 \u0437\u0430\u043A\u0443\u043F\u043A\u0443 \u0442\u043E\u0432\u0430\u0440\u043E\u0432, \u0440\u0430\u0431\u043E\u0442 \u0438 \u0443\u0441\u043B\u0443\u0433 \u043D\u0435 \u0440\u0430\u0432\u043D\u043E \u0440\u0430\u0441\u0445\u043E\u0434\u0430\u043C \u043D\u0430 \u0437\u0430\u043A\u0443\u043F\u043A\u0443 \u0442\u043E\u0432\u0430\u0440\u043E\u0432, \u0440\u0430\u0431\u043E\u0442 \u0438 \u0443\u0441\u043B\u0443\u0433.\n\u0424\u043E\u0440\u043C\u0430 \u043D\u0435 \u0431\u0443\u0434\u0435\u0442 \u0441\u043E\u0445\u0440\u0430\u043D\u0435\u043D\u0430", MessageIcons.Warning);
                }
            }
            return result;
        };
        InterfaceRules.prototype.CheckFormData = function () {
            var result = true;
            if (typeof this._document.AnalyticsDistributionDataTable === 'undefined') {
                return result;
            }
            var formTotalTable = this._document.FormParametersTable.TotalTable;
            var formAnalyticsTable = this._document.AnalyticsDistributionDataTable;
            if (formTotalTable.Locate([BaseObasTableFields.TotalRowFlagField.Id], [1])) {
                if (formAnalyticsTable.Locate([formAnalyticsTable.RecordKey.Id], [1])) {
                    for (var i = 1; i <= ObasStageSettings.YearsCount; i++) {
                        var fieldId = BaseObasTableFields.YearDataField.GenerateId(i);
                        result = ((formTotalTable.GetFieldValue(fieldId) || 0) === (formAnalyticsTable.GetFieldValue(fieldId) || 0));
                        if (!result) {
                            break;
                        }
                    }
                }
            }
            return result;
        };
        InterfaceRules.prototype.LoadDataFromProcurementMenuItemClickEventHandler = function () {
            this.ImportProcurementList();
            if (this._document.ShowEditor("ImportedProcurementListEditor")) {
                this.LoadDataFromProcurement();
            }
            this._document.ImportedProcurementTable.DeleteAllRow();
        };
        InterfaceRules.prototype.LoadDataFromProcurementMenuItemShowEventHandler = function () {
            var versionsTable = ObasTableCollection.RroObasVersionsTable;
            var canChange = false;
            if (versionsTable.LocateByKeys(this._document.ObasVersion)) {
                canChange = versionsTable.RroObasKey.SourceTable.RroDataKey.SourceTable.RroOutlayKey.SourceTable.IsDraft();
            }
            return (this._document.MainParametersTable.FileType.Value === 1) && canChange;
        };
        InterfaceRules.prototype.ImportedProcurementSprSheetCanEditEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return (column === 0);
        };
        InterfaceRules.prototype.ImportProcurementList = function () {
            var procurementPlanTable = ObasTableCollection.RroProcurementPlanTable;
            procurementPlanTable.Last();
            var procurementTable = ObasTableCollection.RroProcurementTable;
            var procurementKeys = new Array();
            while (procurementTable.Locate(procurementTable.ProcurementPlanKey.Id, procurementPlanTable.RecordKey.Value, true)) {
                procurementKeys.push(procurementTable.RecordKey.Value);
            }
            procurementTable.ClearLocateFlag();
            var procurementKBKTable = ObasTableCollection.RroProcurementKBKTable;
            var importedProcurementTable = this._document.ImportedProcurementTable;
            importedProcurementTable.DeleteAllRow();
            for (var i = 0; i < procurementKeys.length; i++) {
                var keyValues = this._document.MainParametersTable.GetKbkKeyFieldsValue();
                keyValues.push(procurementKeys[i]);
                var keyFieldIds = procurementKBKTable.GetKbkKeyFieldsId();
                keyFieldIds.push(procurementKBKTable.ProcurementKey.Id);
                while (procurementKBKTable.Locate(keyFieldIds, keyValues, true)) {
                    importedProcurementTable.AddRow();
                    importedProcurementTable.IsMarked.Value = false;
                    importedProcurementTable.ProcurementKBK.ForeignKey.Value = procurementKBKTable.RecordKey.Value;
                    importedProcurementTable.FullKBKCode.Value = procurementKBKTable.CalcFullKBKCode();
                    importedProcurementTable.PostRow();
                }
                procurementKBKTable.ClearLocateFlag();
            }
        };
        InterfaceRules.prototype.LoadDataFromProcurement = function () {
            var okvRubKey = ObasTableCollection.OkvSprTable.RubleKey;
            var procurementId = "Procurement_ID";
            var importedProcurementTable = this._document.ImportedProcurementTable;
            var reader = importedProcurementTable.CreateReader();
            while (reader.Read()) {
                if (importedProcurementTable.IsMarked.Value) {
                    var procurementKBKTable = ObasTableCollection.RroProcurementKBKTable;
                    procurementKBKTable.Locate(procurementKBKTable.RecordKey.Id, importedProcurementTable.ProcurementKBK.ForeignKey.Value);
                    var purchaseObjectsSprTable = this._document.PurchaseObjectsSprTable;
                    if (!purchaseObjectsSprTable.Locate([purchaseObjectsSprTable.Name.Id, procurementId], [procurementKBKTable.ObjectName.Value, procurementKBKTable.ProcurementKey.Value])) {
                        purchaseObjectsSprTable.AddRow();
                        purchaseObjectsSprTable.Name.Value = procurementKBKTable.ObjectName.Value;
                        purchaseObjectsSprTable.SetFieldValue(procurementId, procurementKBKTable.ProcurementKey.Value);
                        purchaseObjectsSprTable.PostRow();
                    }
                    if (!procurementKBKTable.IsForeignProcurement.Value) {
                        var p2sp1RefObjTable = this._document.P2sp1RefObjTable;
                        if (!p2sp1RefObjTable.Locate(p2sp1RefObjTable.ObjectKey.Id, purchaseObjectsSprTable.RecordKey.Value)) {
                            p2sp1RefObjTable.AddRow();
                            p2sp1RefObjTable.ObjectKey.Value = purchaseObjectsSprTable.RecordKey.Value;
                            p2sp1RefObjTable.PostRow();
                        }
                        var p2sp1RefOkpdTable = this._document.P2sp1RefOkpdTable;
                        if (!p2sp1RefOkpdTable.Locate([p2sp1RefOkpdTable.OwnerKey.Id, p2sp1RefOkpdTable.OKPDKey.Id], [p2sp1RefObjTable.RecordKey.Value, procurementKBKTable.OKPDKey.Value])) {
                            p2sp1RefOkpdTable.AddRow();
                            p2sp1RefOkpdTable.OwnerKey.Value = p2sp1RefObjTable.RecordKey.Value;
                            p2sp1RefOkpdTable.OKPDKey.Value = procurementKBKTable.OKPDKey.Value;
                            p2sp1RefOkpdTable.PostRow();
                        }
                        var p2sp1RefKosguTable = this._document.P2sp1RefKosguTable;
                        p2sp1RefKosguTable.AddRow();
                        p2sp1RefKosguTable.OwnerKey.Value = p2sp1RefOkpdTable.RecordKey.Value;
                        p2sp1RefKosguTable.Year.Value = procurementKBKTable.GetProcurementPlacementYear();
                        p2sp1RefKosguTable.PostRow();
                        for (var i = 0; i <= ObasStageSettings.YearsCount - 1; i++) {
                            var fieldId = "Y" + (i + 1);
                            p2sp1RefKosguTable.SetFieldValue(F02110.ObasTableFields.FnYearField.GenerateId(fieldId), procurementKBKTable.GetFieldValue(fieldId));
                        }
                    }
                    else {
                        var p2UniqueOrgs = this._document.P2UniqueOrgs;
                        if (!p2UniqueOrgs.Locate(procurementId, procurementKBKTable.ProcurementKey.Value)) {
                            p2UniqueOrgs.AddRow();
                            p2UniqueOrgs.SetFieldValue(procurementId, procurementKBKTable.ProcurementKey.Value);
                            p2UniqueOrgs.PostRow();
                        }
                        var p2sp2RefObjTable = this._document.P2sp2RefObjTable;
                        if (!p2sp2RefObjTable.Locate(p2sp2RefObjTable.ObjectKey.Id, purchaseObjectsSprTable.RecordKey.Value)) {
                            p2sp2RefObjTable.AddRow();
                            p2sp2RefObjTable.OwnerKey.Value = p2UniqueOrgs.RecordKey.Value;
                            p2sp2RefObjTable.ObjectKey.Value = purchaseObjectsSprTable.RecordKey.Value;
                            p2sp2RefObjTable.PostRow();
                        }
                        var p2sp2RefOkpdTable = this._document.P2sp2RefOkpdTable;
                        if (!p2sp2RefOkpdTable.Locate([p2sp2RefOkpdTable.OwnerKey.Id, p2sp2RefOkpdTable.OKPDKey.Id], [p2sp2RefObjTable.RecordKey.Value, procurementKBKTable.OKPDKey.Value])) {
                            p2sp2RefOkpdTable.AddRow();
                            p2sp2RefOkpdTable.OwnerKey.Value = p2sp2RefObjTable.RecordKey.Value;
                            p2sp2RefOkpdTable.OKPDKey.Value = procurementKBKTable.OKPDKey.Value;
                            p2sp2RefOkpdTable.PostRow();
                        }
                        var p2sp2RefKosguTable = this._document.P2sp2RefKosguTable;
                        p2sp2RefKosguTable.AddRow();
                        p2sp2RefKosguTable.OwnerKey.Value = p2sp2RefOkpdTable.RecordKey.Value;
                        p2sp2RefKosguTable.Year.Value = procurementKBKTable.GetProcurementPlacementYear();
                        p2sp2RefKosguTable.PostRow();
                        if (okvRubKey === procurementKBKTable.OKVKey.Value) {
                            for (var i = 0; i <= ObasStageSettings.YearsCount - 1; i++) {
                                var fieldId = "Y" + (i + 1);
                                p2sp2RefKosguTable.SetFieldValue(F02110.ObasTableFields.FnOtherRubField.GenerateId(fieldId), procurementKBKTable.GetFieldValue(fieldId));
                            }
                        }
                        else {
                            for (var i = 0; i <= ObasStageSettings.YearsCount - 1; i++) {
                                var fieldId = "Usd_Y" + (i + 1);
                                p2sp2RefKosguTable.SetFieldValue(F02110.ObasTableFields.FnUsdField.GenerateId(fieldId), procurementKBKTable.GetFieldValue(fieldId));
                            }
                        }
                    }
                }
            }
        };
        return InterfaceRules;
    }(BaseInterfaceRules));
    F02110.InterfaceRules = InterfaceRules;
    var AddYearsHelper = (function (_super) {
        __extends(AddYearsHelper, _super);
        function AddYearsHelper() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AddYearsHelper.prototype.GetAddDollarRateYearsFieldRangeEventHandler = function (sheetId) {
            if (sheetId === void 0) { sheetId = ""; }
            var result = [];
            var yearsCount = ObasStageSettings.YearsCount;
            for (var i = yearsCount; i < yearsCount + this._document.AddDataYearsCount; i++) {
                result.push(i);
            }
            return result;
        };
        AddYearsHelper.prototype.GetAddYearsFieldRangeEventHandler = function (sheetId) {
            if (sheetId === void 0) { sheetId = ""; }
            var result = [];
            var yearsCount = ObasStageSettings.YearsCount;
            for (var i = yearsCount; i < yearsCount + this._document.AddDataYearsCount; i++) {
                result.push(i);
            }
            return result;
        };
        return AddYearsHelper;
    }(AddYearsDocumentHelper));
    F02110.AddYearsHelper = AddYearsHelper;
    var P1SheetRelRows;
    (function (P1SheetRelRows) {
        P1SheetRelRows[P1SheetRelRows["Federal"] = 0] = "Federal";
        P1SheetRelRows[P1SheetRelRows["Foreign"] = 1] = "Foreign";
        P1SheetRelRows[P1SheetRelRows["Total"] = 2] = "Total";
    })(P1SheetRelRows = F02110.P1SheetRelRows || (F02110.P1SheetRelRows = {}));
    var P1Sheet = (function (_super) {
        __extends(P1Sheet, _super);
        function P1Sheet(id, _document) {
            var _this = _super.call(this, id, false) || this;
            _this._document = _document;
            return _this;
        }
        P1Sheet.prototype.IsFooterRow = function (row) {
            return this._document.CommonRules.IsFooterRow(this, row, P1Sheet._relRowCount);
        };
        P1Sheet.prototype.CalcRelRow = function (row) {
            return row % P1Sheet._relRowCount;
        };
        P1Sheet.prototype.IsDataColumn = function (column) {
            return column > P1Sheet._rowCodeColumn;
        };
        P1Sheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (!this.IsDataColumn(column)) {
                return SheetFormatCollection.Default;
            }
            else if (this.IsDataColumn(column) && (row === this.RowCount - 2)) {
                return SheetFormatCollection.Free;
            }
            else {
                return SheetFormatCollection.Calc;
            }
        };
        P1Sheet.prototype.EditingCellEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return (this.IsDataColumn(column) && (row === this.RowCount - 2));
        };
        return P1Sheet;
    }(Sheet));
    P1Sheet._relRowCount = ObasHelper.GetEnumLength(P1SheetRelRows);
    P1Sheet._rowCodeColumn = 1;
    P1Sheet._rowNameColumn = P1Sheet._rowCodeColumn - 1;
    P1Sheet._rowCodeLength = 3;
    F02110.P1Sheet = P1Sheet;
    var BaseHierarchySheet = (function (_super) {
        __extends(BaseHierarchySheet, _super);
        function BaseHierarchySheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        BaseHierarchySheet._totalRowName = "\u0412\u0441\u0435\u0433\u043E";
        BaseHierarchySheet._totalObjRowName = "\u0418\u0442\u043E\u0433\u043E \u043F\u043E \u043E\u0431\u044A\u0435\u043A\u0442\u0443 \u0437\u0430\u043A\u0443\u043F\u043A\u0438";
        BaseHierarchySheet._totalRowInfo = {
            IsCalculated: false,
            Name: BaseHierarchySheet._totalRowName,
            Format: SheetFormatCollection.Default
        };
        BaseHierarchySheet._totalObjRowInfo = {
            IsCalculated: false,
            Name: BaseHierarchySheet._totalObjRowName,
            Format: SheetFormatCollection.Default
        };
        BaseHierarchySheet._subTotalRowInfos = [
            BaseHierarchySheet._totalObjRowInfo
        ];
        BaseHierarchySheet.SprColConstAll = {
            Cell: { Type: SheetCellTypes.Spr },
            SubTotalRow: BaseHierarchySheet._subTotalRowInfos,
            TotalRow: BaseHierarchySheet._totalRowInfo
        };
        BaseHierarchySheet.RelatedColConstAll = {
            Cell: { Type: SheetCellTypes.Related },
            SubTotalRow: BaseHierarchySheet._subTotalRowInfos,
            TotalRow: BaseHierarchySheet._totalRowInfo
        };
        BaseHierarchySheet.FreeColConstAll = {
            Cell: { Type: SheetCellTypes.Free },
            SubTotalRow: BaseHierarchySheet._subTotalRowInfos,
            TotalRow: BaseHierarchySheet._totalRowInfo
        };
        BaseHierarchySheet.DefaultColConstAll = {
            Cell: { Type: SheetCellTypes.Default },
            SubTotalRow: BaseHierarchySheet._subTotalRowInfos,
            TotalRow: BaseHierarchySheet._totalRowInfo
        };
        BaseHierarchySheet._CodeInfo = {
            Column: 7,
            Length: 6,
            LevelIncs: [1000, 1],
            CalcTotalCode: function () {
                return "010000";
            }
        };
        return BaseHierarchySheet;
    }(HierarchyYearGroupSheet));
    F02110.BaseHierarchySheet = BaseHierarchySheet;
    var PurchaseObjectHierarchySheet = (function (_super) {
        __extends(PurchaseObjectHierarchySheet, _super);
        function PurchaseObjectHierarchySheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        PurchaseObjectHierarchySheet.prototype.GetYearsSumCaptionEventHandler = function (tableId, index, defaultCaption, fieldCaption) {
            return this.Document.CommonRules.CalcColumnCaption(index, 12, 2);
        };
        Object.defineProperty(PurchaseObjectHierarchySheet.prototype, "SheetInfo", {
            get: function () {
                return PurchaseObjectHierarchySheet._sheetInfo;
            },
            enumerable: true,
            configurable: true
        });
        PurchaseObjectHierarchySheet._sheetInfo = {
            MaxLevel: 2,
            CodeInfo: PurchaseObjectHierarchySheet._CodeInfo,
            ColumnsInfo: [
                SheetColumnInfoCollection.SprColDefaultTotal,
                SheetColumnInfoCollection.SprColDefaultTotal,
                SheetColumnInfoCollection.SprColAllDefault,
                SheetColumnInfoCollection.SprColAllDefault,
                SheetColumnInfoCollection.SprColAllDefault,
                SheetColumnInfoCollection.SprColAllDefault,
                PurchaseObjectHierarchySheet.FreeColConstAll,
                PurchaseObjectHierarchySheet.DefaultColConstAll,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc
            ]
        };
        return PurchaseObjectHierarchySheet;
    }(BaseHierarchySheet));
    F02110.PurchaseObjectHierarchySheet = PurchaseObjectHierarchySheet;
    var BaseHierarchySheet2 = (function (_super) {
        __extends(BaseHierarchySheet2, _super);
        function BaseHierarchySheet2() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        BaseHierarchySheet2.prototype.EditCellEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return column > 0;
        };
        BaseHierarchySheet2.TotalRecBudgFundRowName = "\u0418\u0442\u043E\u0433\u043E \u043F\u043E \u0441\u0442\u0440\u0430\u043D\u0435";
        BaseHierarchySheet2._totalRowName = "\u0412\u0441\u0435\u0433\u043E";
        BaseHierarchySheet2._totalObjRowName = "\u0418\u0442\u043E\u0433\u043E \u043F\u043E \u043E\u0431\u044A\u0435\u043A\u0442\u0443 \u0437\u0430\u043A\u0443\u043F\u043A\u0438";
        BaseHierarchySheet2._totalRowInfo = {
            IsCalculated: false,
            Name: BaseHierarchySheet2._totalRowName,
            Format: SheetFormatCollection.Default
        };
        BaseHierarchySheet2._totalObjRowInfo = {
            IsCalculated: false,
            Name: BaseHierarchySheet2._totalObjRowName,
            Format: SheetFormatCollection.Default
        };
        BaseHierarchySheet2._totalRecBudgFundRowInfo = {
            IsCalculated: false,
            Name: BaseHierarchySheet2.TotalRecBudgFundRowName,
            Format: SheetFormatCollection.Default
        };
        BaseHierarchySheet2._subTotalRowInfos = [
            BaseHierarchySheet2._totalRecBudgFundRowInfo, BaseHierarchySheet2._totalObjRowInfo
        ];
        BaseHierarchySheet2.SprDefaultTotalFirstSubtotal = {
            Cell: { Type: SheetCellTypes.Spr },
            SubTotalRow: [SheetRowInfoCollection.Default, SheetRowInfoCollection.SprOnlyFormatRow],
            TotalRow: SheetRowInfoCollection.Default
        };
        BaseHierarchySheet2.RelatedDefaultTotalFirstSubtotal = {
            Cell: { Type: SheetCellTypes.Related },
            SubTotalRow: [SheetRowInfoCollection.Default, SheetRowInfoCollection.SprOnlyFormatRow],
            TotalRow: SheetRowInfoCollection.Default
        };
        BaseHierarchySheet2.SprColConstAll = {
            Cell: { Type: SheetCellTypes.Spr },
            SubTotalRow: BaseHierarchySheet2._subTotalRowInfos,
            TotalRow: BaseHierarchySheet2._totalRowInfo
        };
        BaseHierarchySheet2.RelatedColConstAll = {
            Cell: { Type: SheetCellTypes.Related },
            SubTotalRow: BaseHierarchySheet2._subTotalRowInfos,
            TotalRow: BaseHierarchySheet2._totalRowInfo
        };
        BaseHierarchySheet2.FreeColConstAll = {
            Cell: { Type: SheetCellTypes.Free },
            SubTotalRow: BaseHierarchySheet2._subTotalRowInfos,
            TotalRow: BaseHierarchySheet2._totalRowInfo
        };
        BaseHierarchySheet2.DefaultColConstAll = {
            Cell: { Type: SheetCellTypes.Default },
            SubTotalRow: BaseHierarchySheet2._subTotalRowInfos,
            TotalRow: BaseHierarchySheet2._totalRowInfo
        };
        BaseHierarchySheet2._CodeInfo = {
            Column: 9,
            Length: 6,
            LevelIncs: [10000, 100, 1],
            CalcTotalCode: function () {
                return 900000;
            }
        };
        return BaseHierarchySheet2;
    }(HierarchyYearGroupSheet));
    F02110.BaseHierarchySheet2 = BaseHierarchySheet2;
    var PurchaseObjectUsdHierarchySheet = (function (_super) {
        __extends(PurchaseObjectUsdHierarchySheet, _super);
        function PurchaseObjectUsdHierarchySheet(document) {
            return _super.call(this, document, 10) || this;
        }
        Object.defineProperty(PurchaseObjectUsdHierarchySheet.prototype, "SheetInfo", {
            get: function () {
                return PurchaseObjectUsdHierarchySheet._sheetInfo;
            },
            enumerable: true,
            configurable: true
        });
        PurchaseObjectUsdHierarchySheet.prototype.GetYearsSumUsdCaptionEventHandler = function (tableId, index, defaultCaption, fieldCaption) {
            return this.Document.CommonRules.CalcColumnCaption(index, 14, 2);
        };
        PurchaseObjectUsdHierarchySheet.prototype.GetYearsSumRubCaptionEventHandler = function (tableId, index, defaultCaption, fieldCaption) {
            return this.Document.CommonRules.CalcColumnCaption(index, 23, 2);
        };
        PurchaseObjectUsdHierarchySheet.prototype.GetYearsSumOtherRubCaptionEventHandler = function (tableId, index, defaultCaption, fieldCaption) {
            return this.Document.CommonRules.CalcColumnCaption(index, 32, 2);
        };
        PurchaseObjectUsdHierarchySheet.prototype.GetYearsTotalSumUsdCaptionEventHandler = function (tableId, index, defaultCaption, fieldCaption) {
            return this.Document.CommonRules.CalcColumnCaption(index, 41, 2);
        };
        PurchaseObjectUsdHierarchySheet._sheetInfo = {
            MaxLevel: 3,
            CodeInfo: PurchaseObjectUsdHierarchySheet._CodeInfo,
            ColumnsInfo: [
                SheetColumnInfoCollection.SprColDefaultTotal,
                SheetColumnInfoCollection.SprColDefaultTotal,
                PurchaseObjectUsdHierarchySheet.SprDefaultTotalFirstSubtotal,
                PurchaseObjectUsdHierarchySheet.SprDefaultTotalFirstSubtotal,
                SheetColumnInfoCollection.SprColAllDefault,
                SheetColumnInfoCollection.SprColAllDefault,
                SheetColumnInfoCollection.SprColAllDefault,
                SheetColumnInfoCollection.SprColAllDefault,
                PurchaseObjectUsdHierarchySheet.FreeColConstAll,
                PurchaseObjectUsdHierarchySheet.DefaultColConstAll,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc
            ]
        };
        return PurchaseObjectUsdHierarchySheet;
    }(BaseHierarchySheet2));
    F02110.PurchaseObjectUsdHierarchySheet = PurchaseObjectUsdHierarchySheet;
    var AnalyticsDistributionSheet = (function (_super) {
        __extends(AnalyticsDistributionSheet, _super);
        function AnalyticsDistributionSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AnalyticsDistributionSheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (column > AnalyticsDistributionSheet._strCodeColumn) {
                if (this.IsTotal(row)) {
                    return SheetFormatCollection.Calc;
                }
                else {
                    return SheetFormatCollection.Free;
                }
            }
            else {
                return SheetFormatCollection.Default;
            }
        };
        AnalyticsDistributionSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (column > AnalyticsDistributionSheet._strCodeColumn) {
                if (this.IsTotal(row)) {
                    var result = new SheetCalcResult(BaseFormulas.SUM);
                    if (row === 0) {
                        for (var i = row + 1; i < this.RowCount; i++) {
                            if (!this.IsTotal(i)) {
                                result.AddCoordinates(new CellCoordinate(i, column));
                            }
                        }
                    }
                    else {
                        var i = row + 1;
                        while (!this.IsTotal(i) && i < this.RowCount) {
                            result.AddCoordinates(new CellCoordinate(i, column));
                            i++;
                        }
                    }
                    return result.ToArray();
                }
            }
            return undefined;
        };
        AnalyticsDistributionSheet.prototype.CanEditCellEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return ((column > AnalyticsDistributionSheet._strCodeColumn) && !this.IsTotal(row));
        };
        AnalyticsDistributionSheet.prototype.IsTotal = function (row) {
            return (row === 0);
        };
        AnalyticsDistributionSheet._strCodeColumn = 1;
        return AnalyticsDistributionSheet;
    }(Sheet));
    F02110.AnalyticsDistributionSheet = AnalyticsDistributionSheet;
})(F02110 || (F02110 = {}));
