var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F02140;
(function (F02140) {
    var TableRules = (function (_super) {
        __extends(TableRules, _super);
        function TableRules(document) {
            return _super.call(this, document) || this;
        }
        return TableRules;
    }(F02110.TableRules));
    F02140.TableRules = TableRules;
    var ObasTableFields = (function (_super) {
        __extends(ObasTableFields, _super);
        function ObasTableFields() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(ObasTableFields, "CostYearDataField", {
            get: function () {
                if (this._costYearDataField == null) {
                    this._costYearDataField = new BaseGenericObasTableField("Cost_Y");
                }
                return this._costYearDataField;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ObasTableFields, "OkeiKeyYearField", {
            get: function () {
                if (this._okeiKeyYearField == null) {
                    this._okeiKeyYearField = new BaseGenericObasTableField("OKEI_ID_Y");
                }
                return this._okeiKeyYearField;
            },
            enumerable: true,
            configurable: true
        });
        ObasTableFields._costYearDataField = null;
        ObasTableFields._okeiKeyYearField = null;
        return ObasTableFields;
    }(BaseObasTableFields));
    F02140.ObasTableFields = ObasTableFields;
    var PartObjectDataTable = (function (_super) {
        __extends(PartObjectDataTable, _super);
        function PartObjectDataTable(id, _document, _descTable) {
            var _this = _super.call(this, id) || this;
            _this._document = _document;
            _this._descTable = _descTable;
            _this._objectKey = null;
            _this._object = _this._document.PurchaseObjectsSprTable;
            _this._okpd = null;
            _this._deletedObjKey = 0;
            return _this;
        }
        Object.defineProperty(PartObjectDataTable.prototype, "ObjectKey", {
            get: function () {
                if (this._objectKey == null) {
                    this._objectKey = new NumberObasTableField("PurchaseObjects_ID", this);
                }
                return this._objectKey;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartObjectDataTable.prototype, "Okpd", {
            get: function () {
                if (this._okpd == null) {
                    this._okpd = new ObasSprTableField(ObasTableCollection.OkpdSprTable, this);
                }
                return this._okpd;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartObjectDataTable.prototype, "ObjectName", {
            get: function () {
                this._object.LocateByKeys(this.ObjectKey.Value);
                return this._object.Name;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartObjectDataTable.prototype, "ObjectNumber", {
            get: function () {
                this._object.LocateByKeys(this.ObjectKey.Value);
                return this._object.Number;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartObjectDataTable.prototype, "ObjectNpaGroupCode", {
            get: function () {
                this._object.LocateByKeys(this.ObjectKey.Value);
                return this._object.NpaGroup.Code;
            },
            enumerable: true,
            configurable: true
        });
        PartObjectDataTable.prototype.CalcSubgroupNormativeExpensesName = function () {
            this._object.LocateByKeys(this.ObjectKey.Value);
            return this._object.NpaGroup.Name || "";
        };
        PartObjectDataTable.prototype.ObjectChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this.AfterDeleteEventHandler(this.Id, oldValue);
            this._descTable.AddObject(newValue);
        };
        PartObjectDataTable.prototype.DeleteEventHandler = function (tableId) {
            this._deletedObjKey = this.ObjectKey.Value;
        };
        PartObjectDataTable.prototype.AfterDeleteEventHandler = function (tableId, objKey) {
            if (objKey === void 0) { objKey = this._deletedObjKey; }
            this._descTable.DeleteObject(objKey);
        };
        return PartObjectDataTable;
    }(ObasTable));
    F02140.PartObjectDataTable = PartObjectDataTable;
    var PartKosguTable = (function (_super) {
        __extends(PartKosguTable, _super);
        function PartKosguTable(id, document, parent, _totalTable, _totalRowKey) {
            var _this = _super.call(this, id, document, parent) || this;
            _this._totalTable = _totalTable;
            _this._totalRowKey = _totalRowKey;
            _this._kosgu = null;
            _this._analysisFeature = null;
            _this._year = null;
            return _this;
        }
        Object.defineProperty(PartKosguTable.prototype, "Kosgu", {
            get: function () {
                if (this._kosgu == null) {
                    this._kosgu = new ObasSprTableField(ObasTableCollection.KosguSprTable, this);
                }
                return this._kosgu;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartKosguTable.prototype, "AnalysisFeature", {
            get: function () {
                if (this._analysisFeature == null) {
                    this._analysisFeature = new ObasSprTableField(ObasTableCollection.AddAnalysisFeatureSprtable, this);
                }
                return this._analysisFeature;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartKosguTable.prototype, "Year", {
            get: function () {
                if (this._year == null) {
                    this._year = new NumberObasTableField(BaseObasTableFields.YearField.Id, this);
                }
                return this._year;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartKosguTable.prototype, "OkeiName", {
            get: function (yearIndex) {
                var okeyKey = this.GetFieldValue(ObasTableFields.OkeiKeyYearField.GenerateId(yearIndex));
                if (ObasTableCollection.OkeiSprTable.LocateByKeys(okeyKey)) {
                    return ObasTableCollection.OkeiSprTable.Name.Value;
                }
                return "";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartKosguTable.prototype, "OkeiCode", {
            get: function (yearIndex) {
                var okeyKey = this.GetFieldValue(ObasTableFields.OkeiKeyYearField.GenerateId(yearIndex));
                if (ObasTableCollection.OkeiSprTable.LocateByKeys(okeyKey)) {
                    return ObasTableCollection.OkeiSprTable.Code.Value;
                }
                return "";
            },
            enumerable: true,
            configurable: true
        });
        PartKosguTable.prototype.SumPartsChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            var countFieldId = BaseObasTableFields.CountYearDataField.GenerateId(fieldId);
            var costFieldId = ObasTableFields.CostYearDataField.GenerateId(fieldId);
            var yearFieldId = BaseObasTableFields.YearDataField.GenerateId(fieldId);
            this.SetFieldValue(yearFieldId, this.GetFieldValue(countFieldId) * this.GetFieldValue(costFieldId));
        };
        PartKosguTable.prototype.SumChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this._totalTable.SetSumByKeys(fieldId, this._totalTable.GetKeys(this._totalRowKey), oldValue, newValue);
        };
        PartKosguTable.prototype.AfterDeleteChildsEventHandler = function (tableId) {
            for (var i = 1; i <= this._document.Settings.YearsCount; i++) {
                this.SetFieldValue(BaseObasTableFields.YearDataField.GenerateId(i), 0);
            }
        };
        return PartKosguTable;
    }(ObasTableWithSimpleKeysParent));
    F02140.PartKosguTable = PartKosguTable;
})(F02140 || (F02140 = {}));
