var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F02300;
(function (F02300) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(_document) {
            var _this = _super.call(this, _document) || this;
            _this._document = _document;
            return _this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetP1Data("\u0418\u0422\u041E\u0413\u0418"));
            result.push(this.GetP2Sp2Data("\u0420\u0430\u0441\u0447\u0435\u0442_\u041E\u0411\u0410\u0421_1"));
            result.push(this.GetPxExpenseValuesData("\u041E\u0431\u044A\u0435\u043C_\u0440\u0430\u0441\u0445\u043E\u0434\u043E\u0432_1", this._document.P2ExpenseDataTable));
            result.push(this.GetPxSp1Data("\u0420\u0430\u0441\u0447\u0435\u0442_\u041E\u0411\u0410\u0421_2", this._document.P3Sp1RowsTable, this._document.P3Sp1DataTable));
            result.push(this.GetPxExpenseValuesData("\u041E\u0431\u044A\u0435\u043C_\u0440\u0430\u0441\u0445\u043E\u0434\u043E\u0432_2", this._document.P3ExpenseDataTable));
            result.push(this.GetPxSp1Data("\u0420\u0430\u0441\u0447\u0435\u0442_\u041E\u0411\u0410\u0421_3", this._document.P4Sp1RowsTable, this._document.P4Sp1DataTable));
            result.push(this.GetPxExpenseValuesData("\u041E\u0431\u044A\u0435\u043C_\u0440\u0430\u0441\u0445\u043E\u0434\u043E\u0432_3", this._document.P4ExpenseDataTable));
            result.push(this.GetP2Sp1Data("\u0421\u043F\u0440\u0430\u0432\u043E\u0447\u043D\u0438\u043A_1"));
            result.push(this.GetP2Sp2Sp1Data("\u0421\u043F\u0440\u0430\u0432\u043E\u0447\u043D\u0438\u043A_2"));
            result.push(this.GetP5NpaData("\u041D\u041F\u0410"));
            result.push(this.GetPriorityProjectData("\u041F\u0440\u0438\u043E\u0440\u0438\u0442\u0435\u0442\u043D\u044B\u0439\u041F\u0440\u043E\u0435\u043A\u0442"));
            var kosguData = this._document.AnalyticsDataTable.CollectKosguData();
            result.push(this.GetAnalyticKosguData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423", kosguData));
            result.push(this.GetP2Sp2Sp3Data("\u041E\u0431\u043E\u0441\u043D\u043E\u0432\u0430\u043D\u0438\u0435\u041F\u0440\u0438\u0447\u0438\u043D"));
            result.push(this.GetInfoUZData("\u0421\u0432\u0435\u0434\u0435\u043D\u0438\u044F_\u0423\u0417", this._document.P6RefKosguTable));
            result.push(this.GetRationaleUZData("\u041E\u0431\u043E\u0441\u043D\u043E\u0432\u0430\u043D\u0438\u0435_\u0423\u0417"));
            result.push(this.GetNpaUZData("\u041D\u041F\u0410_\u0423\u0417", this._document.P6RefObjDescNpaTable, this._document.P6RefObjTable));
            return result;
        };
        ExportRules.prototype.GetP1Data = function (barsTableId) {
            var rowsTable = this._document.P1RowsTable;
            var srcTable = this._document.P1TotalTable;
            var P1StrKeys = F02300.P1TableStrKeys;
            var keys = [P1StrKeys.Total, P1StrKeys.P2, P1StrKeys.P3, P1StrKeys.P4, 100];
            var srcData = [];
            for (var i = 0; i < keys.length; i++) {
                var template = "<a ID=\"" + ((keys[i] === 100) ? "100" : ObasHelper.FillWithCharacter((i + 1).toString(), 2)) + "\" ";
                template += "b2=\"" + (rowsTable.Locate(rowsTable.RecordKey.Id, keys[i]) ? rowsTable.Name.Value : "") + "\" ";
                if (srcTable.Locate(srcTable.StrKeyField.Id, keys[i])) {
                    for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                        template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                    }
                }
                else {
                    template += "b3=\"0\" b4=\"0\" b5=\"0\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2Sp2Data = function (barsTableId) {
            var srcTable = this._document.P2Sp1DataTable;
            var keys = [F02300.P2Sp1RowsKeys.C0110, F02300.P2Sp1RowsKeys.C0120];
            var yearsCount = ObasStageSettings.YearsCount;
            var FillDataArr = function (arr, fieldId, startIndex) {
                for (var j = 0; j < yearsCount; j++) {
                    arr[startIndex + j] = srcTable.GetFieldValue(fieldId + (j + 1).toString());
                }
            };
            var GenYearData = function (arr, startIndex) {
                var result = "";
                for (var j = 0; j < yearsCount; j++) {
                    result += "b" + (startIndex + j) + "=\"" + (arr[startIndex + j] || 0) + "\" ";
                }
                return result;
            };
            var srcDataArr = new Array(keys.length + 1);
            for (var i = 0; i < srcDataArr.length - 1; i++) {
                srcDataArr[i] = new Array(15);
                if (srcTable.Locate(srcTable.StrKeyField.Id, keys[i])) {
                    FillDataArr(srcDataArr[i], srcTable.PlannedCount.Id, 3);
                    FillDataArr(srcDataArr[i], srcTable.StandardExpens.Id, 6);
                    FillDataArr(srcDataArr[i], srcTable.PlannedDeviation.Id, 9);
                    FillDataArr(srcDataArr[i], BaseObasTableFields.YearDataField.Id, 12);
                }
            }
            var indexTotal = srcDataArr.length - 1;
            srcDataArr[indexTotal] = new Array(15);
            for (var i = 0; i < indexTotal; i++) {
                for (var j = 3; j < srcDataArr[i].length; j++) {
                    if ([9, 10, 11].indexOf(j) === -1) {
                        srcDataArr[indexTotal][j] = Math.round(((srcDataArr[indexTotal][j] || 0) + (srcDataArr[i][j] || 0)) * 100) / 100;
                    }
                }
            }
            var srcData = [];
            for (var i = 0; i < srcDataArr.length; i++) {
                var template = "<a ID=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 2) + "\" ";
                template += GenYearData(srcDataArr[i], 3);
                template += GenYearData(srcDataArr[i], 6);
                template += GenYearData(srcDataArr[i], 9);
                template += GenYearData(srcDataArr[i], 12);
                template += "/>";
                srcData.push(template);
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetPxExpenseValuesData = function (barsTableId, srcTable) {
            var keys = [F02300.ExpenseRowsKeys.Insurance, F02300.ExpenseRowsKeys.Obas];
            var fieldsId = ["YP3", "YP2", "YP1", "Y0", "Y1", "Y2", "Y3"];
            var srcData = [];
            for (var i = 0; i < keys.length; i++) {
                var template = "<a ID=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 2) + "\" ";
                if (srcTable.Locate(srcTable.StrKeyField.Id, keys[i])) {
                    for (var j = 0; j < fieldsId.length; j++) {
                        template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue(fieldsId[j]) || 0) + "\" ";
                    }
                }
                else {
                    template += "b3=\"0\" b4=\"0\" b5=\"0\" b6=\"0\" b7=\"0\" b8=\"0\" b9=\"0\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetPxSp1Data = function (barsTableId, rowsTable, srcTable) {
            var fieldsPostfixes = ["P3", "P2", "P1", "1", "2", "3"];
            var yearsCount = fieldsPostfixes.length;
            var GenYearData = function (srcTable, fieldId, startIndex) {
                var result = "";
                for (var j = 0; j < yearsCount; j++) {
                    result += "b" + (startIndex + j) + "=\"" + (srcTable.GetFieldValue(fieldId + fieldsPostfixes[j]) || 0) + "\" ";
                }
                return result;
            };
            var srcData = [];
            var i = 0;
            var reader = rowsTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 2) + "\" ";
                if (srcTable.Locate(srcTable.StrKeyField.Id, rowsTable.RecordKey.Value)) {
                    template += GenYearData(srcTable, srcTable.Count.Id, 3);
                    template += GenYearData(srcTable, srcTable.InsuranceCount.Id, 9);
                    template += GenYearData(srcTable, BaseObasTableFields.YearDataField.Id, 15);
                    template += GenYearData(srcTable, srcTable.Salary.Id, 21);
                    template += "b27=\"" + ((srcTable.Coefficient.Value || 0)) + "\" ";
                }
                else {
                    for (var j = 3; j <= 27; j++) {
                        template += "b" + j + "=\"0\" ";
                    }
                }
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2Sp1Data = function (barsTableId) {
            var rowsTable = this._document.P2Sp1RowsTable;
            var srcTable = this._document.P2Sp1DataTable;
            var srcData = [];
            var i = 0;
            var reader = rowsTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 2) + "\" ";
                if (srcTable.Locate(srcTable.StrKeyField.Id, rowsTable.RecordKey.Value)) {
                    var fieldsPostfixes = ["P3", "P2", "P1"];
                    template += "b3=\"" + (srcTable.GetFieldValue(srcTable.Count.Id + fieldsPostfixes[0]) || 0) + "\" ";
                    for (var j = 0; j < fieldsPostfixes.length; j++) {
                        template += "b" + (4 + j) + "=\"" + (srcTable.GetFieldValue(srcTable.PaymentP1.Id + fieldsPostfixes[j]) || 0) + "\" ";
                    }
                    fieldsPostfixes = ["P2", "P1"];
                    template += "b7=\"" + (srcTable.GetFieldValue(srcTable.Count.Id + fieldsPostfixes[0]) || 0) + "\" ";
                    for (var j = 0; j < fieldsPostfixes.length; j++) {
                        template += "b" + (8 + j) + "=\"" + (srcTable.GetFieldValue(srcTable.PaymentP2.Id + fieldsPostfixes[j]) || 0) + "\" ";
                    }
                    template += "b10=\"" + (srcTable.GetFieldValue(srcTable.Count.Id + "P1") || 0) + "\" ";
                    template += "b11=\"" + (srcTable.GetFieldValue(srcTable.PaymentP3.Id + "P1") || 0) + "\" ";
                }
                else {
                    for (var j = 3; j <= 11; j++) {
                        template += "b" + j + "=\"0\" ";
                    }
                }
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2Sp2Sp1Data = function (barsTableId) {
            var srcTable = this._document.IndexTransposedTable;
            var yearsCount = this._document.FullYearsCount;
            var srcData = [];
            var template = "<a ID=\"01\" ";
            for (var j = 0; j < yearsCount; j++) {
                template += "b" + (1 + j) + "=\"" + (srcTable.GetFieldValue("Value" + j.toString()) || 0) + "\" ";
            }
            template += "/>";
            srcData.push(template);
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP5NpaData = function (barsTableId) {
            var srcTable = this._document.NpaTable;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + (srcTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "b2=\"" + (ObasHelper.ConvertToString(srcTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b3=\"" + (srcTable.NpaFields.NpaNumber.Value || "") + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaFields.NpaName.Value || "") + "\" ";
                template += "b5=\"" + (srcTable.NpaStatus.Code || "") + "\" ";
                template += "b6=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetPriorityProjectData = function (barsTableId) {
            var srcData = [];
            srcData.push("<a ID=\"0\" b2=\"\u041E\u0431\u044A\u0435\u043C \u0431\u044E\u0434\u0436\u0435\u0442\u043D\u044B\u0445 \u0430\u0441\u0441\u0438\u0433\u043D\u043E\u0432\u0430\u043D\u0438\u0439, \u0432\u0441\u0435\u0433\u043E\" b3=\"0\" b4=\"0\" b5=\"0\" b6=\"0\" />");
            srcData.push("<a ID=\"1\" b2=\"\u041E\u0431\u044A\u0435\u043C \u0431\u044E\u0434\u0436\u0435\u0442\u043D\u044B\u0445 \u0430\u0441\u0441\u0438\u0433\u043D\u043E\u0432\u0430\u043D\u0438\u0439 \u043D\u0435 \u043E\u0442\u043D\u0435\u0441\u0435\u043D\u043D\u044B\u0445 \u043A \u043F\u0440\u0438\u043E\u0440\u0438\u0442\u0435\u0442\u043D\u044B\u043C \u043F\u0440\u043E\u0435\u043A\u0442\u0430\u043C:\" b3=\"0\" b4=\"0\" b5=\"0\" b6=\"0\" />");
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticKosguData = function (id, kosguData) {
            var kosguTable = ObasTableCollection.KosguSprTable;
            var srcData = [];
            for (var i = 1; i < kosguData.length; i++) {
                var template = "<a ID=\"" + (kosguData[i].Code || "") + "\" ";
                for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                    template += "b" + (3 + j) + "=\"" + (kosguData[i].Data[j] || 0) + "\" ";
                }
                template += "b1=\"" + (kosguTable.Locate(kosguTable.Code.Id, kosguData[i].Code) ? kosguTable.Name.Value : "") + "\" ";
                template += "/>";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetP2Sp2Sp3Data = function (barsTableId) {
            var srcTable = this._document.P2Sp2Sp3Table;
            var srcData = [];
            srcData.push("<a ID=\"01\" b1=\"" + (srcTable.GetFieldValue("Info") || "") + "\" />");
            return { Id: barsTableId, Data: srcData };
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F02300.ExportRules = ExportRules;
})(F02300 || (F02300 = {}));
