var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F03108;
(function (F03108) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(_document) {
            var _this = _super.call(this, _document) || this;
            _this._document = _document;
            return _this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetTotalData("\u041E\u0431\u044A\u0435\u043C\u0411\u044E\u0434\u0436\u0435\u0442\u043D\u044B\u0445\u0410\u0441\u0441\u0438\u0433\u043D\u043E\u0432\u0430\u043D\u0438\u0439"));
            result.push(this.GetP3Data("\u0420\u0430\u0441\u0447\u0435\u0442\u041E\u0431\u044A\u0435\u043C\u0430\u0411\u0410\u043F\u043E\u0418\u043D\u044B\u043C\u041F\u041D\u041E"));
            result.push(this.GetP2SpxData("\u041F\u041D\u041E\u0432\u0427\u0430\u0441\u0442\u0438\u0415\u0436\u0435\u043C\u0435\u0441\u044F\u0447\u043D\u044B\u0445\u0412\u044B\u043F\u043B\u0430\u0442", this._document.P2Sp1RecipientDataTable, this._document.P2Sp1RecipientDataTransTable));
            result.push(this.GetP4NpaData("\u041D\u041F\u0410"));
            result.push(this.GetSecretData("\u0413\u043E\u0441\u0442\u0430\u0439\u043D\u0430"));
            result.push(this.GetAnalyticRaspredelenieData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435"));
            var kosguData = this._document.AnalyticsDataTable.CollectKosguData();
            result.push(this.GetAnalyticKosguData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423", kosguData));
            result.push(this.GetP2SpxData("\u041F\u041D\u041E\u0432\u0427\u0430\u0441\u0442\u0438\u0415\u0434\u0438\u043D\u043E\u0432\u0440\u0435\u043C\u0435\u043D\u043D\u044B\u0445\u0412\u044B\u043F\u043B\u0430\u0442", this._document.P2Sp2RecipientDataTable, this._document.P2Sp2RecipientDataTransTable));
            result.push(this.GetP5Data("\u041A\u043E\u044D\u0444\u0418\u043D\u0434\u0435\u043A\u0441\u0430\u0446\u0438\u0438"));
            return result;
        };
        ExportRules.prototype.GenYearData = function (srcTable, fieldId, startIndex) {
            var result = "";
            for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                result += "b" + (startIndex + j) + "=\"" + (srcTable.GetFieldValue(fieldId + j.toString()) || 0) + "\" ";
            }
            return result;
        };
        ExportRules.prototype.GetTotalData = function (id) {
            var srcTable = this._document.P1OrgDataTable;
            var dataTable = this._document.P3RecipientDataTable;
            var p2Sp1Table = this._document.P2Sp1RecipientDataTransTable;
            var p2Sp2Table = this._document.P2Sp2RecipientDataTransTable;
            var p3Table = this._document.P3RecipientDataTransTable;
            var yearsCount = ObasStageSettings.YearsCount;
            var srcDataArr = [];
            var srcPnoArr = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var orgKey = srcTable.GetFieldValue(dataTable.Org.ForeignKey.Id);
                var pnoKey = srcTable.StrKeyField.Value;
                if (p2Sp1Table.Locate([dataTable.Org.ForeignKey.Id, dataTable.Pno.ForeignKey.Id], [orgKey, pnoKey]) ||
                    p2Sp2Table.Locate([dataTable.Org.ForeignKey.Id, dataTable.Pno.ForeignKey.Id], [orgKey, pnoKey]) ||
                    p3Table.Locate([dataTable.Org.ForeignKey.Id, dataTable.Pno.ForeignKey.Id], [orgKey, pnoKey])) {
                    var pnoName = srcTable.GetFieldValue("StrName");
                    i = srcPnoArr.indexOf(pnoName);
                    if (i === -1) {
                        srcPnoArr.push(pnoName);
                        i = srcPnoArr.indexOf(pnoName);
                        srcDataArr[i] = new Array(16);
                    }
                }
                while (p2Sp1Table.Locate([dataTable.Org.ForeignKey.Id, dataTable.Pno.ForeignKey.Id], [orgKey, pnoKey], true)) {
                    for (var j = 0; j < yearsCount; j++) {
                        srcDataArr[i][j] = (srcDataArr[i][j] || 0) + (p2Sp1Table.GetFieldValue(dataTable.TotalObas.Id + (j).toString()) || 0);
                        srcDataArr[i][j + (yearsCount + 1)] = (srcDataArr[i][j + (yearsCount + 1)] || 0) + (p2Sp1Table.GetFieldValue(dataTable.TotalObas.Id + (j).toString()) || 0);
                    }
                }
                p2Sp1Table.ClearLocateFlag();
                while (p2Sp2Table.Locate([dataTable.Org.ForeignKey.Id, dataTable.Pno.ForeignKey.Id], [orgKey, pnoKey], true)) {
                    for (var j = 0; j < yearsCount; j++) {
                        srcDataArr[i][j] = (srcDataArr[i][j] || 0) + (p2Sp2Table.GetFieldValue(dataTable.TotalObas.Id + (j).toString()) || 0);
                        srcDataArr[i][j + (yearsCount + 1) * 2] = (srcDataArr[i][j + (yearsCount + 1) * 2] || 0) + (p2Sp2Table.GetFieldValue(dataTable.TotalObas.Id + (j).toString()) || 0);
                    }
                }
                p2Sp2Table.ClearLocateFlag();
                while (p3Table.Locate([dataTable.Org.ForeignKey.Id, dataTable.Pno.ForeignKey.Id], [orgKey, pnoKey], true)) {
                    for (var j = 0; j < yearsCount; j++) {
                        srcDataArr[i][j] = (srcDataArr[i][j] || 0) + (p3Table.GetFieldValue(dataTable.TotalObas.Id + (j).toString()) || 0);
                        srcDataArr[i][j + (yearsCount + 1) * 3] = (srcDataArr[i][j + (yearsCount + 1) * 3] || 0) + (p3Table.GetFieldValue(dataTable.TotalObas.Id + (j).toString()) || 0);
                    }
                }
                p3Table.ClearLocateFlag();
            }
            var srcData = [];
            for (i = 0; i < srcDataArr.length; i++) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + (srcPnoArr[i] || "") + "\" ";
                for (var j = 0; j < srcDataArr[i].length; j++) {
                    template += "b" + (2 + j) + "=\"" + (srcDataArr[i][j] || 0) + "\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetP2SpxData = function (id, dataTable, srcTable) {
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                dataTable.Locate([dataTable.Org.ForeignKey.Id, dataTable.Pno.ForeignKey.Id, dataTable.Recipient.ForeignKey.Id], [srcTable.GetFieldValue(dataTable.Org.ForeignKey.Id),
                    srcTable.GetFieldValue(dataTable.Pno.ForeignKey.Id), srcTable.GetFieldValue(dataTable.Recipient.ForeignKey.Id)]);
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((dataTable.Org.Name || "")) + "\" ";
                template += "b2=\"" + ((dataTable.Pno.Name || "")) + "\" ";
                template += "b3=\"" + ((dataTable.Recipient.Name || "")) + "\" ";
                template += this.GenYearData(srcTable, "PaymentByNpa", 4);
                template += this.GenYearData(srcTable, dataTable.RecipientsCount.Id, 8);
                template += this.GenYearData(srcTable, dataTable.Pay.Id, 12);
                template += this.GenYearData(srcTable, dataTable.PayWithCoef1.Id, 16);
                template += this.GenYearData(srcTable, dataTable.PayWithCoef2.Id, 20);
                template += this.GenYearData(srcTable, dataTable.SumWithCoef1.Id, 24);
                template += this.GenYearData(srcTable, dataTable.SumWithCoef2.Id, 28);
                template += this.GenYearData(srcTable, dataTable.SumAdd.Id, 32);
                template += this.GenYearData(srcTable, "g11", 36);
                template += this.GenYearData(srcTable, dataTable.TotalObas.Id, 40);
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetP3Data = function (id) {
            var dataTable = this._document.P3RecipientDataTable;
            var srcTable = this._document.P3RecipientDataTransTable;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                dataTable.Locate([dataTable.Org.ForeignKey.Id, dataTable.Pno.ForeignKey.Id, dataTable.Recipient.ForeignKey.Id], [srcTable.GetFieldValue(dataTable.Org.ForeignKey.Id),
                    srcTable.GetFieldValue(dataTable.Pno.ForeignKey.Id), srcTable.GetFieldValue(dataTable.Recipient.ForeignKey.Id)]);
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((dataTable.Org.Name || "")) + "\" ";
                template += "b2=\"" + ((dataTable.Pno.Name || "")) + "\" ";
                template += "b3=\"" + ((dataTable.Recipient.Name || "")) + "\" ";
                template += this.GenYearData(srcTable, dataTable.RecipientsCount.Id, 4);
                template += this.GenYearData(srcTable, dataTable.Pay.Id, 8);
                template += this.GenYearData(srcTable, dataTable.TotalObas.Id, 12);
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetP4NpaData = function (id) {
            var srcTable = this._document.NpaTable;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                var uniqRecipientTable = this._document.UniqRecipientsTable;
                var existsUniqRecipient = uniqRecipientTable.LocateByKeys(srcTable.UniqRecipient.ForeignKey.Value);
                template += "b1=\"" + (existsUniqRecipient ? uniqRecipientTable.Org.Name : "") + "\" ";
                template += "b2=\"" + (existsUniqRecipient ? uniqRecipientTable.Pno.Name : "") + "\" ";
                template += "b3=\"" + (existsUniqRecipient ? uniqRecipientTable.Recipient.Name : "") + "\" ";
                template += "b8=\"" + (srcTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "b9=\"" + (ObasHelper.ConvertToString(srcTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b10=\"" + (srcTable.NpaFields.NpaNumber.Value || "") + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaFields.NpaName.Value || "") + "\" ";
                template += "b11=\"" + (srcTable.NpaStatus.Code || "") + "\" ";
                template += "b13=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetP5Data = function (id) {
            var srcTable = this._document.IndexationTransposedTable;
            var srcData = [];
            var template = "<a ID=\"0\" b1=\"\u041A\u043E\u044D\u0444\u0444\u0438\u0446\u0438\u0435\u043D\u0442 \u0438\u043D\u0434\u0435\u043A\u0441\u0430\u0446\u0438\u0438 \u0432\u044B\u043F\u043B\u0430\u0442, \u043F\u043E\u0441\u043E\u0431\u0438\u0439 \u0438 \u043A\u043E\u043C\u043F\u0435\u043D\u0441\u0430\u0446\u0438\u0439 \u0432 \u0441\u043E\u043E\u0442\u0432\u0435\u0442\u0441\u0442\u0432\u0438\u0438 \u0441 \u0424\u0417 \u043E \u0424\u0411\" " +
                this.GenYearData(srcTable, "Coef1", 2) + "bCoefType=\"10\" />";
            srcData.push(template);
            template = "<a ID=\"1\" b1=\"\u041A\u043E\u044D\u0444\u0444\u0438\u0446\u0438\u0435\u043D\u0442 \u0438\u043D\u0434\u0435\u043A\u0441\u0430\u0446\u0438\u0438 \u0432\u044B\u043F\u043B\u0430\u0442, \u043F\u043E\u0441\u043E\u0431\u0438\u0439 \u0438 \u043A\u043E\u043C\u043F\u0435\u043D\u0441\u0430\u0446\u0438\u0439 \u0438\u0441\u0445\u043E\u0434\u044F \u0438\u0437 \u0438\u043D\u0434\u0435\u043A\u0441\u0430 \u0440\u043E\u0441\u0442\u0430 \u043F\u043E\u0442\u0440\u0435\u0431\u0438\u0442\u0435\u043B\u044C\u0441\u043A\u0438\u0445 \u0446\u0435\u043D\" " +
                this.GenYearData(srcTable, "Coef2", 2) + "bCoefType=\"20\" />";
            srcData.push(template);
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetSecretData = function (id) {
            var srcData = [];
            srcData.push("<a ID=\"01\" b1=\"0\" b2=\"0\" b3=\"0\" b4=\"0\" />");
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticKosguData = function (id, kosguData) {
            var srcData = [];
            for (var i = 1; i < kosguData.length; i++) {
                var template = "<a ID=\"" + (i - 1) + "\" ";
                template += "b2=\"" + (kosguData[i].Code || "") + "\" ";
                for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                    template += "b" + (3 + j) + "=\"" + (kosguData[i].Data[j] || 0) + "\" ";
                }
                template += "b7=\"0\" b8=\"0\" b9=\"0\" b10=\"0\" b11=\"0\" b12=\"0\" b13=\"0\" b14=\"0\" b15=\"0\" b16=\"0\" b17=\"0\" b18=\"0\" />";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticRaspredelenieData = function (id) {
            var srcData = [];
            for (var i = 1; i <= 8; i++) {
                srcData.push("<a ID=\"" + ObasHelper.FillWithCharacter(i.toString(), 2) + "\" b3=\"0\" b4=\"0\" b5=\"0\" b6=\"0\" />");
            }
            return { Id: id, Data: srcData };
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F03108.ExportRules = ExportRules;
})(F03108 || (F03108 = {}));
