var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F03108;
(function (F03108) {
    var TableRules = (function () {
        function TableRules(_document) {
            this._document = _document;
        }
        return TableRules;
    }());
    F03108.TableRules = TableRules;
    var StrKeysP1Total;
    (function (StrKeysP1Total) {
        StrKeysP1Total[StrKeysP1Total["Total"] = 1] = "Total";
    })(StrKeysP1Total = F03108.StrKeysP1Total || (F03108.StrKeysP1Total = {}));
    var P1TotalTable = (function (_super) {
        __extends(P1TotalTable, _super);
        function P1TotalTable() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P1TotalTable.prototype.GetTotalKey = function () {
            return StrKeysP1Total.Total;
        };
        return P1TotalTable;
    }(P1TotalObasTable));
    F03108.P1TotalTable = P1TotalTable;
    var P1OrgDataTable = (function (_super) {
        __extends(P1OrgDataTable, _super);
        function P1OrgDataTable() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P1OrgDataTable.prototype.SumChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this.ParentTable.SetSumByKeys(fieldId, this.ParentTable.GetKeys(StrKeysP1Total.Total), oldValue, newValue);
        };
        P1OrgDataTable.prototype.AfterDeleteChildsEventHandler = function (tableId) {
            var _this = this;
            var yearField = BaseObasTableFields.YearDataField;
            this.Document.IterateByYears(function (yearIndex) {
                var fieldId = yearField.GenerateId(yearIndex);
                _this.SetFieldValue(fieldId, 0);
            });
        };
        P1OrgDataTable.prototype.ResetData = function (keys) {
            this.Document.CommonRules.ResetTableDataWithKeys(this, keys, BaseObasTableFields.YearDataField);
        };
        return P1OrgDataTable;
    }(ObasTableWithOrgStrKeysParent));
    F03108.P1OrgDataTable = P1OrgDataTable;
    var ObasTablePnoYearKeys = (function (_super) {
        __extends(ObasTablePnoYearKeys, _super);
        function ObasTablePnoYearKeys(orgKey, year, PnoKey) {
            var _this = _super.call(this, orgKey, year) || this;
            _this.PnoKey = PnoKey;
            return _this;
        }
        return ObasTablePnoYearKeys;
    }(OrgYearObasTableKeys));
    F03108.ObasTablePnoYearKeys = ObasTablePnoYearKeys;
    var PnoDataTable = (function (_super) {
        __extends(PnoDataTable, _super);
        function PnoDataTable(id, document, parent) {
            var _this = _super.call(this, id, parent.KeyFieldIds.concat(["PNO_ID"]), document, parent) || this;
            _this._pno = null;
            _this._year = null;
            return _this;
        }
        Object.defineProperty(PnoDataTable.prototype, "ParentTable", {
            get: function () {
                return this.OwnerKey.SourceTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PnoDataTable.prototype, "Year", {
            get: function () {
                return this.ParentTable.Year;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PnoDataTable.prototype, "Org", {
            get: function () {
                return this.ParentTable.Org;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PnoDataTable.prototype, "YearOffset", {
            get: function () {
                return this.Year.Value - this.Document.Settings.StartYear;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PnoDataTable.prototype, "Pno", {
            get: function () {
                if (this._pno == null) {
                    this._pno = new ObasSprTableField(ObasTableCollection.PnoSprTable, this);
                }
                return this._pno;
            },
            enumerable: true,
            configurable: true
        });
        PnoDataTable.prototype.GetKeys = function (pnoKey, year, orgKey) {
            if (pnoKey === void 0) { pnoKey = this.Pno.ForeignKey.Value; }
            if (year === void 0) { year = this.Year.Value; }
            if (orgKey === void 0) { orgKey = this.Org.ForeignKey.Value; }
            if (this._keys == null) {
                this._keys = new ObasTablePnoYearKeys(orgKey, year, pnoKey);
            }
            else {
                this._keys.PnoKey = pnoKey;
                this._keys.Year = year;
                this._keys.OrgKey = orgKey;
            }
            return this._keys;
        };
        PnoDataTable.prototype.DeleteEventHandler = function (tableId) {
            var uniqRecipientTable = this._document.UniqRecipientsTable;
            var sumTable = this._document.P1OrgDataTable;
            if (!uniqRecipientTable.Locate([uniqRecipientTable.Org.ForeignKey.Id, uniqRecipientTable.Pno.ForeignKey.Id], [this.Org.ForeignKey.Value, this.Pno.ForeignKey.Value])) {
                if (sumTable.Locate([sumTable.OrgTable.Org.ForeignKey.Id, sumTable.StrKeyField.Id], [this.Org.ForeignKey.Value, this.Pno.ForeignKey.Value])) {
                    sumTable.DeleteRow();
                }
            }
        };
        PnoDataTable.prototype.PnoChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this.Pno.ForeignKey.DoFieldChange(oldValue, newValue);
        };
        PnoDataTable.prototype.GetRecordKey = function (keys, addIfNotExists) {
            if (addIfNotExists === void 0) { addIfNotExists = false; }
            var parentTable = this.ParentTable;
            var ownerKey = parentTable.GetRecordKey(parentTable.GetKeys(keys.OrgKey, keys.Year), addIfNotExists);
            return this.Document.CommonRules.GetValueByKeys(this, [this.OwnerKey.Id, this.Pno.ForeignKey.Id], [ownerKey, keys.PnoKey], this.RecordKey.Id, addIfNotExists);
        };
        return PnoDataTable;
    }(ObasTableWithKeysParent));
    F03108.PnoDataTable = PnoDataTable;
    var UniqRecipientsTable = (function (_super) {
        __extends(UniqRecipientsTable, _super);
        function UniqRecipientsTable(id, _document) {
            var _this = _super.call(this, id) || this;
            _this._document = _document;
            _this._org = null;
            _this._pno = null;
            _this._recipient = null;
            _this._childs = [];
            return _this;
        }
        Object.defineProperty(UniqRecipientsTable.prototype, "Org", {
            get: function () {
                if (this._org == null) {
                    this._org = new ObasSprTableField(ObasTableCollection.OrganizationTable, this);
                }
                return this._org;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UniqRecipientsTable.prototype, "Pno", {
            get: function () {
                if (this._pno == null) {
                    this._pno = new ObasSprTableField(ObasTableCollection.PnoSprTable, this);
                }
                return this._pno;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UniqRecipientsTable.prototype, "Recipient", {
            get: function () {
                if (this._recipient == null) {
                    this._recipient = new ObasSprTableField(ObasTableCollection.RecipientCategorySprTable, this);
                }
                return this._recipient;
            },
            enumerable: true,
            configurable: true
        });
        UniqRecipientsTable.prototype.AddChild = function (child) {
            var childId = child.Id;
            if (this._childs.indexOf(childId) === -1) {
                this._childs.push(childId);
            }
        };
        UniqRecipientsTable.prototype.AddObject = function (orgKey, pnoKey, recipientKey) {
            this._document.CommonRules.AddNewLink(this.Id, [this.Org.ForeignKey.Id, this.Pno.ForeignKey.Id, this.Recipient.ForeignKey.Id], [orgKey, pnoKey, recipientKey]);
        };
        UniqRecipientsTable.prototype.DeleteObject = function (orgKey, pnoKey, recipientKey) {
            this._document.CommonRules.DeleteOldLink(this.Id, this._childs, [this.Org.ForeignKey.Id, this.Pno.ForeignKey.Id, this.Recipient.ForeignKey.Id], [orgKey, pnoKey, recipientKey]);
        };
        return UniqRecipientsTable;
    }(ObasTable));
    F03108.UniqRecipientsTable = UniqRecipientsTable;
    var ObasTablePnoRecipientYearKeys = (function (_super) {
        __extends(ObasTablePnoRecipientYearKeys, _super);
        function ObasTablePnoRecipientYearKeys(orgKey, year, pnoKey, RecipientKey) {
            var _this = _super.call(this, orgKey, year, pnoKey) || this;
            _this.RecipientKey = RecipientKey;
            return _this;
        }
        return ObasTablePnoRecipientYearKeys;
    }(ObasTablePnoYearKeys));
    F03108.ObasTablePnoRecipientYearKeys = ObasTablePnoRecipientYearKeys;
    var PxRecipientsDataTable = (function (_super) {
        __extends(PxRecipientsDataTable, _super);
        function PxRecipientsDataTable(id, parentTable, _sumTable, _uniqRecipientTable) {
            var _this = _super.call(this, id, parentTable.KeyFieldIds.concat("RecipientCategory_ID"), parentTable.Document, parentTable) || this;
            _this._sumTable = _sumTable;
            _this._uniqRecipientTable = _uniqRecipientTable;
            _this._recipient = null;
            _this._recipientsCount = null;
            _this._recipientKey = null;
            _this._pnoKey = null;
            _this._orgKey = null;
            _this._pay = null;
            _this._totalObas = null;
            _this._isCopied = null;
            _this._copyData = null;
            _this._uniqRecipientTable.AddChild(_this);
            parentTable.Pno.ForeignKey.AddFieldChangeListener(function (table, oldValue, newValue, fieldId) {
                _this.PnoChangeEventHandler(table, oldValue, newValue, fieldId);
            });
            return _this;
        }
        Object.defineProperty(PxRecipientsDataTable.prototype, "CopyFieldsInfo", {
            get: function () {
                if (this._copyData == null) {
                    this._copyData = this.InitCopyFieldsInfo();
                }
                return this.CollectTableRecordData(this._copyData);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PxRecipientsDataTable.prototype, "IsCopied", {
            get: function () {
                if (this._isCopied == null) {
                    this._isCopied = new ObasTableField(BaseObasTableFields.CopiedRowFlagField.Id, this);
                }
                return this._isCopied;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PxRecipientsDataTable.prototype, "Recipient", {
            get: function () {
                if (this._recipient == null) {
                    this._recipient = new ObasSprTableField(ObasTableCollection.RecipientCategorySprTable, this);
                }
                return this._recipient;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PxRecipientsDataTable.prototype, "Pay", {
            get: function () {
                if (this._pay == null) {
                    this._pay = new NumberObasTableField("g4", this);
                }
                return this._pay;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PxRecipientsDataTable.prototype, "RecipientsCount", {
            get: function () {
                if (this._recipientsCount == null) {
                    this._recipientsCount = new NumberObasTableField("g3", this);
                }
                return this._recipientsCount;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PxRecipientsDataTable.prototype, "TotalObas", {
            get: function () {
                if (this._obas == null) {
                    this._obas = new NumberObasTableField("g5", this);
                }
                return this._obas;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PxRecipientsDataTable.prototype, "ParentTable", {
            get: function () {
                return this.OwnerKey.SourceTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PxRecipientsDataTable.prototype, "Year", {
            get: function () {
                return this.ParentTable.Year;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PxRecipientsDataTable.prototype, "YearOffset", {
            get: function () {
                return this.ParentTable.YearOffset;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PxRecipientsDataTable.prototype, "Pno", {
            get: function () {
                return this.ParentTable.Pno;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PxRecipientsDataTable.prototype, "Org", {
            get: function () {
                return this.ParentTable.Org;
            },
            enumerable: true,
            configurable: true
        });
        PxRecipientsDataTable.prototype.RecipientChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            var orgField = this.Org.ForeignKey;
            var pnoField = this.Pno.ForeignKey;
            var recipientField = this.Recipient.ForeignKey;
            var orgKey = orgField.Value;
            var pnoKey = pnoField.Value;
            var recipientKey = recipientField.Value;
            var oldOrgKey = fieldId === orgField.Id ? oldValue : orgKey;
            var oldPnoKey = fieldId === pnoField.Id ? oldValue : pnoKey;
            var oldRecipientKey = fieldId === recipientField.Id ? oldValue : recipientKey;
            this.AfterDeleteEventHandler(tableId, oldOrgKey, oldPnoKey, oldRecipientKey);
            if (orgKey != null && pnoKey != null && recipientKey != null) {
                this._uniqRecipientTable.AddObject(orgKey, pnoKey, recipientKey);
            }
        };
        PxRecipientsDataTable.prototype.PnoChangeEventHandler = function (table, oldValue, newValue, fieldId) {
            var recordKey = table.RecordKey.Value;
            while (this.OwnerKey.Locate(recordKey, true)) {
                this.RecipientChangeEventHandler(table.Id, oldValue, newValue, fieldId);
            }
            this.ClearLocateFlag();
        };
        PxRecipientsDataTable.prototype.DeleteEventHandler = function (tableId) {
            this._orgKey = this.Org.ForeignKey.Value;
            this._pnoKey = this.Pno.ForeignKey.Value;
            this._recipientKey = this.Recipient.ForeignKey.Value;
            this.TotalObas.NValue = 0;
        };
        PxRecipientsDataTable.prototype.AfterDeleteEventHandler = function (tableId, orgKey, pnoKey, recipientKey) {
            if (orgKey === void 0) { orgKey = this._orgKey; }
            if (pnoKey === void 0) { pnoKey = this._pnoKey; }
            if (recipientKey === void 0) { recipientKey = this._recipientKey; }
            this._uniqRecipientTable.DeleteObject(orgKey, pnoKey, recipientKey);
        };
        PxRecipientsDataTable.prototype.ObasChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            var yearIndex = this.Year.Value - ObasStageSettings.CurrentYear;
            var fieldId = BaseObasTableFields.YearDataField.GenerateId(yearIndex + 1);
            var orgTable = this._sumTable.OrgTable;
            var orgKey = orgTable.Lookup(orgTable.KeyFieldIds, this.Org.ForeignKey.Value, orgTable.RecordKey.Id);
            this._sumTable.SetSumByKeys(fieldId, this._sumTable.GetKeys(orgKey, this.Pno.ForeignKey.Value), oldValue, newValue);
        };
        PxRecipientsDataTable.prototype.AfterDeleteChildsEventHandler = function (tableId) {
            this.TotalObas.NValue = 0;
        };
        PxRecipientsDataTable.prototype.GetKeys = function (pnoKey, year, recipientKey, orgKey) {
            if (pnoKey === void 0) { pnoKey = this.Pno.ForeignKey.Value; }
            if (year === void 0) { year = this.Year.Value; }
            if (recipientKey === void 0) { recipientKey = this.Recipient.ForeignKey.Value; }
            if (orgKey === void 0) { orgKey = this.Org.ForeignKey.Value; }
            if (this._keys == null) {
                this._keys = new ObasTablePnoRecipientYearKeys(orgKey, year, pnoKey, recipientKey);
            }
            else {
                this._keys.PnoKey = pnoKey;
                this._keys.Year = year;
                this._keys.RecipientKey = recipientKey;
                this._keys.OrgKey = orgKey;
            }
            return this._keys;
        };
        PxRecipientsDataTable.prototype.InnerCopyData = function (recordKey, endYear) {
            if (this.Locate(this.RecordKey.Id, recordKey)) {
                this.IsCopied.Value = true;
                var copyData = this.CopyFieldsInfo;
                var keys = this.GetKeys();
                var parentTable = this.ParentTable;
                var ownerField = copyData.getValue(this.OwnerKey.Id);
                for (var year = keys.Year + 1; year <= endYear; year++) {
                    var ownerKey = parentTable.GetRecordKey(parentTable.GetKeys(keys.PnoKey, year, keys.OrgKey), true);
                    ownerField.Value = ownerKey;
                    keys.Year = year;
                    this.SetupTableRecordData(copyData, this.RecordKey.LookupByKeys(keys.ToArray()), true);
                }
                this.RecordKey.Locate(recordKey);
            }
        };
        PxRecipientsDataTable.prototype.CopyData = function (srcYear, destYear) {
            var _this = this;
            var endYear = ObasStageSettings.CurrentYear + ObasStageSettings.YearsCount;
            if (srcYear == null) {
                srcYear = endYear - 2;
            }
            if (destYear == null) {
                destYear = endYear - 1;
            }
            if (srcYear && destYear) {
                var copyHandler = function (table, recordKey) {
                    if (_this.Year.Value === srcYear) {
                        _this.InnerCopyData(recordKey, destYear);
                    }
                };
                this.Iterate(copyHandler);
            }
        };
        PxRecipientsDataTable.prototype.EditEventHandler = function (tableId) {
            if (this.Document.NotOnUpdate && !this.IsCopied.Value && this.IsRedyForCopy()) {
//                this.InnerCopyData(this.RecordKey.Value, ObasStageSettings.CurrentYear + ObasStageSettings.YearsCount - 1);
            }
        };
        PxRecipientsDataTable.prototype.IsRedyForCopy = function () {
            return ObasHelper.CheckIsReadyForCopy(this.CopyFieldsInfo);
        };
        PxRecipientsDataTable.prototype.CollectUserData = function () {
            return this.CollectTableData(this.InitCopyFieldsInfo());
        };
        return PxRecipientsDataTable;
    }(ObasTableWithKeysParent));
    F03108.PxRecipientsDataTable = PxRecipientsDataTable;
    var P3RecipientsDataTable = (function (_super) {
        __extends(P3RecipientsDataTable, _super);
        function P3RecipientsDataTable() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P3RecipientsDataTable.prototype.ObasPartsChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this.TotalObas.Value = this.RecipientsCount.NValue * this.Pay.NValue;
        };
        P3RecipientsDataTable.prototype.ResetData = function (keys) {
            var _this = this;
            var resetHandler = function () {
                _this.RecipientsCount.Value = 0;
                _this.Pay.Value = 0;
                _this.TotalObas.Value = 0;
            };
            if (keys) {
                if (this.LocateByKeys(keys.ToArray())) {
                    resetHandler();
                }
            }
            else {
                this.Iterate(resetHandler);
            }
        };
        P3RecipientsDataTable.prototype.InitCopyFieldsInfo = function () {
            var result = new collections.Dictionary();
            result.setValue(this.IsCopied.Id, {
                Id: this.IsCopied.Id,
                IsData: false
            });
            result.setValue(this.OwnerKey.Id, {
                Id: this.OwnerKey.Id,
                IsData: false
            });
            result.setValue(this.Recipient.ForeignKey.Id, {
                Id: this.Recipient.ForeignKey.Id,
                IsData: false
            });
            result.setValue(this.RecipientsCount.Id, {
                Id: this.RecipientsCount.Id,
                IsData: true
            });
            result.setValue(this.Pay.Id, {
                Id: this.Pay.Id,
                IsData: true
            });
            return result;
        };
        return P3RecipientsDataTable;
    }(PxRecipientsDataTable));
    F03108.P3RecipientsDataTable = P3RecipientsDataTable;
    var P2RecipientsDataTable = (function (_super) {
        __extends(P2RecipientsDataTable, _super);
        function P2RecipientsDataTable() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._payWithCoef1 = null;
            _this._payWithCoef2 = null;
            _this._sumWithCoef1 = null;
            _this._sumWithCoef2 = null;
            _this._sumAdd = null;
            return _this;
        }
        Object.defineProperty(P2RecipientsDataTable.prototype, "PayWithCoef1", {
            get: function () {
                if (this._payWithCoef1 == null) {
                    this._payWithCoef1 = new NumberObasTableField("g6", this);
                }
                return this._payWithCoef1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(P2RecipientsDataTable.prototype, "PayWithCoef2", {
            get: function () {
                if (this._payWithCoef2 == null) {
                    this._payWithCoef2 = new NumberObasTableField("g7", this);
                }
                return this._payWithCoef2;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(P2RecipientsDataTable.prototype, "SumWithCoef1", {
            get: function () {
                if (this._sumWithCoef1 == null) {
                    this._sumWithCoef1 = new NumberObasTableField("g8", this);
                }
                return this._sumWithCoef1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(P2RecipientsDataTable.prototype, "SumWithCoef2", {
            get: function () {
                if (this._sumWithCoef2 == null) {
                    this._sumWithCoef2 = new NumberObasTableField("g9", this);
                }
                return this._sumWithCoef2;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(P2RecipientsDataTable.prototype, "SumAdd", {
            get: function () {
                if (this._sumAdd == null) {
                    this._sumAdd = new NumberObasTableField("g10", this);
                }
                return this._sumAdd;
            },
            enumerable: true,
            configurable: true
        });
        P2RecipientsDataTable.prototype.ObasPartsChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this.CalcSums();
            this.TotalObas.Value = (this.SumWithCoef1.Value + this.SumWithCoef2.Value + this.SumAdd.Value);
        };
        P2RecipientsDataTable.prototype.ResetData = function (keys) {
            var _this = this;
            var resetHandler = function () {
                _this.RecipientsCount.Value = 0;
                _this.Pay.Value = 0;
                _this.PayWithCoef1.Value = 0;
                _this.PayWithCoef2.Value = 0;
                _this.SumWithCoef1.Value = 0;
                _this.SumWithCoef2.Value = 0;
                _this.SumAdd.Value = 0;
                _this.TotalObas.Value = 0;
            };
            if (keys) {
                if (this.LocateByKeys(keys.ToArray())) {
                    resetHandler();
                }
            }
            else {
                this.Iterate(resetHandler);
            }
        };
        P2RecipientsDataTable.prototype.InitCopyFieldsInfo = function () {
            var result = new collections.Dictionary();
            result.setValue(this.IsCopied.Id, {
                Id: this.IsCopied.Id,
                IsData: false
            });
            result.setValue(this.OwnerKey.Id, {
                Id: this.OwnerKey.Id,
                IsData: false
            });
            result.setValue(this.Recipient.ForeignKey.Id, {
                Id: this.Recipient.ForeignKey.Id,
                IsData: false
            });
            result.setValue(this.RecipientsCount.Id, {
                Id: this.RecipientsCount.Id,
                IsData: true
            });
            result.setValue(this.Pay.Id, {
                Id: this.Pay.Id,
                IsData: true
            });
            result.setValue(this.SumAdd.Id, {
                Id: this.SumAdd.Id,
                IsData: true
            });
            return result;
        };
        return P2RecipientsDataTable;
    }(PxRecipientsDataTable));
    F03108.P2RecipientsDataTable = P2RecipientsDataTable;
    var P2Sp1RecipientsDataTable = (function (_super) {
        __extends(P2Sp1RecipientsDataTable, _super);
        function P2Sp1RecipientsDataTable() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P2Sp1RecipientsDataTable.prototype.CalcSums = function () {
            var indexationTable = this._document.IndexationTransposedTable;
            this.PayWithCoef1.Value = this.Pay.Value * indexationTable.GetCoef1(this.Year.Value);
            this.PayWithCoef2.Value = this.Pay.Value * indexationTable.GetCoef2(this.Year.Value);
            this.SumWithCoef1.Value = this.RecipientsCount.Value * this.PayWithCoef1.Value * 12;
            this.SumWithCoef2.Value = (this.RecipientsCount.Value * this.PayWithCoef2.Value * 11) + (this.RecipientsCount.Value * this.Pay.Value);
        };
        return P2Sp1RecipientsDataTable;
    }(P2RecipientsDataTable));
    F03108.P2Sp1RecipientsDataTable = P2Sp1RecipientsDataTable;
    var P2Sp2RecipientsDataTable = (function (_super) {
        __extends(P2Sp2RecipientsDataTable, _super);
        function P2Sp2RecipientsDataTable() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P2Sp2RecipientsDataTable.prototype.CalcSums = function () {
            var indexationTable = this._document.IndexationTransposedTable;
            this.PayWithCoef1.Value = this.Pay.Value * indexationTable.GetCoef1(this.Year.Value);
            this.PayWithCoef2.Value = this.Pay.Value * indexationTable.GetCoef2(this.Year.Value);
            this.SumWithCoef1.Value = this.RecipientsCount.Value * this.PayWithCoef1.Value;
            this.SumWithCoef2.Value = this.RecipientsCount.Value * this.PayWithCoef2.Value;
        };
        return P2Sp2RecipientsDataTable;
    }(P2RecipientsDataTable));
    F03108.P2Sp2RecipientsDataTable = P2Sp2RecipientsDataTable;
    var NpaTable = (function (_super) {
        __extends(NpaTable, _super);
        function NpaTable(id, _document) {
            var _this = _super.call(this, id) || this;
            _this._document = _document;
            _this._uniqRecipient = null;
            return _this;
        }
        Object.defineProperty(NpaTable.prototype, "UniqRecipient", {
            get: function () {
                if (this._uniqRecipient == null) {
                    this._uniqRecipient = new ObasSprTableField(this._document.UniqRecipientsTable, this, "RecipientData");
                }
                return this._uniqRecipient;
            },
            enumerable: true,
            configurable: true
        });
        return NpaTable;
    }(ExtendedNpaObasTable));
    F03108.NpaTable = NpaTable;
    var IndexationTable = (function (_super) {
        __extends(IndexationTable, _super);
        function IndexationTable(id, _document) {
            var _this = _super.call(this, id) || this;
            _this._document = _document;
            return _this;
        }
        IndexationTable.prototype.CoefChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            var srcTable = this._document.P2Sp1RecipientDataTable;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                srcTable.ObasPartsChangeEventHandler(srcTable.Id, srcTable.Pay.Value, srcTable.Pay.Value, srcTable.Pay.Id);
            }
            srcTable = this._document.P2Sp2RecipientDataTable;
            reader = srcTable.CreateReader();
            while (reader.Read()) {
                srcTable.ObasPartsChangeEventHandler(srcTable.Id, srcTable.Pay.Value, srcTable.Pay.Value, srcTable.Pay.Id);
            }
        };
        return IndexationTable;
    }(SprTable));
    F03108.IndexationTable = IndexationTable;
    var IndexationTransposedTable = (function (_super) {
        __extends(IndexationTransposedTable, _super);
        function IndexationTransposedTable() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        IndexationTransposedTable.prototype.GetCoef1 = function (year) {
            return this.GetFieldValue("Coef1" + (year - ObasStageSettings.CurrentYear).toString());
        };
        IndexationTransposedTable.prototype.GetCoef2 = function (year) {
            return this.GetFieldValue("Coef2" + (year - ObasStageSettings.CurrentYear).toString());
        };
        return IndexationTransposedTable;
    }(YearTransposedObasTable));
    F03108.IndexationTransposedTable = IndexationTransposedTable;
})(F03108 || (F03108 = {}));
