﻿var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F03211;
(function (F03211) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(_document) {
            var _this = _super.call(this, _document) || this;
            _this._document = _document;
            return _this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetP1Data("\u041E\u0411\u0410\u0421"));
            var kosguData = this._document.AnalyticsDataTable.CollectKosguData();
            result.push(this.GetAnalyticKosguData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423", kosguData));
            result.push(this.GetP2Data("\u0420\u0430\u0441\u0447\u0435\u0442\u041E\u0411\u0410\u0421"));
            result.push(this.GetP2DetailData("\u0424\u0430\u043A\u0442\u043E\u0440\u044B\u0420\u0430\u0441\u0447\u0435\u0442\u0430"));
            result.push(this.GetP3NpaData("\u041D\u041F\u0410"));
            result.push(this.GetSecretData("\u0413\u043E\u0441\u0442\u0430\u0439\u043D\u0430"));
            result.push(this.GetRaspredelenieKosguData("\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041F\u043E\u041A\u041E\u0421\u0413\u0423"));
            return result;
        };
        ExportRules.prototype.GenYearData = function (srcTable, fieldId, startIndex) {
            var result = "";
            for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                result += "b" + (startIndex + j) + "=\"" + (srcTable.GetFieldValue(fieldId + j.toString()) || 0) + "\" ";
            }
            return result;
        };
        ExportRules.prototype.GetP1Data = function (barsTableId) {
            var srcTable = this._document.P1TotalTable;
            var keys = [1, 100, 2];
            var strCodes = ["01", "100", "02"];
            var yearsCount = ObasStageSettings.YearsCount;
            var srcData = [];
            for (var i = 0; i < keys.length; i++) {
                var template = "<a ID=\"" + strCodes[i] + "\" ";
                if (srcTable.Locate(srcTable.StrKeyField.Id, keys[i])) {
                    for (var j = 0; j < yearsCount; j++) {
                        template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                    }
                }
                else {
                    template += "b3=\"0\" b4=\"0\" b5=\"0\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticKosguData = function (id, kosguData) {
            var kosguTable = ObasTableCollection.KosguSprTable;
            var srcData = [];
            for (var i = 1; i < kosguData.length; i++) {
                var template = "<a ID=\"" + (i - 1) + "\" ";
                if (kosguTable.Locate(kosguTable.Code.Id, kosguData[i].Code)) {
                    template += "b1=\"" + (kosguTable.Name.Value || "") + "\" ";
                }
                else {
                    template += "b1=\"\" ";
                }
                template += "b2=\"" + (kosguData[i].Code || "") + "\" ";
                for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                    template += "b" + (3 + j) + "=\"" + (kosguData[i].Data[j] || 0) + "\" ";
                }
                template += "b7=\"0\" b8=\"0\" b9=\"0\" b10=\"0\" b11=\"0\" b12=\"0\" b13=\"0\" b14=\"0\" b15=\"0\" />";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetP2Data = function (barsTableId) {
            var dataTable = this._document.RecipientDataTable;
            var srcTable = this._document.RecipientDataTransTable;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                dataTable.Locate(dataTable.Pno.ForeignKey.Id, srcTable.GetFieldValue(dataTable.Pno.ForeignKey.Id));
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((dataTable.Pno.Code || "")) + "\" ";
                template += "b1_clone=\"" + ((dataTable.Pno.Code || "")) + "\" ";
                template += this.GenYearData(srcTable, dataTable.Obas.Id, 3);
                template += this.GenYearData(srcTable, dataTable.TotalObas.Id, 7);
                template += this.GenYearData(srcTable, dataTable.AddObas.Id, 11);
                template += this.GenYearData(srcTable, dataTable.RecipientsCount.Id, 15);
                template += "bFILTERINGCOLUMN=\"" + (dataTable.OwnerKey.Value) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2DetailData = function (barsTableId) {
            var dataTable = this._document.RecipientDataTable;
            var srcTable = this._document.RecipientDataTransTable;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                dataTable.Locate([dataTable.Pno.ForeignKey.Id, dataTable.Recipient.ForeignKey.Id], [srcTable.GetFieldValue(dataTable.Pno.ForeignKey.Id), srcTable.GetFieldValue(dataTable.Recipient.ForeignKey.Id)]);
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((dataTable.Pno.Code || "")) + "\" ";
                template += "b2=\"" + ((dataTable.Recipient.Code || "")) + "\" ";
                template += this.GenYearData(srcTable, dataTable.RecipientsCount.Id, 4);
                template += this.GenYearData(srcTable, dataTable.Pay.Id, 8);
                template += this.GenYearData(srcTable, dataTable.Obas.Id, 12);
                template += this.GenYearData(srcTable, dataTable.AddObas.Id, 16);
                template += this.GenYearData(srcTable, dataTable.TotalObas.Id, 20);
                template += "bFILTERINGCOLUMN=\"" + (dataTable.OwnerKey.Value) + "\" ";
                template += "b23=\"0\" b24=\"0\" b25=\"0\" b26=\"0\" b27=\"0\" b28=\"0\" />";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP3NpaData = function (barsTableId) {
            var srcTable = this._document.TableP3Npa;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + (srcTable.Pno.Code || "") + "\" ";
                template += "b2=\"" + (srcTable.Recipient.Code || "") + "\" ";
                template += "b7=\"" + ((srcTable.NpaStatus.Code === "1") ? "true" : "fasle") + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "b8=\"" + (srcTable.NpaType.Code || "") + "\" ";
                template += "b9=\"" + (ObasHelper.ConvertToString(srcTable.NpaDate.Value) || "") + "\" ";
                template += "b10=\"" + (srcTable.NpaNumber.Value || "") + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaName.Value || "") + "\" ";
                template += "b11=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetRaspredelenieKosguData = function (id) {
            var strCodes = ["261", "262", "263", "290", "total"];
            var srcData = [];
            for (var i = 0; i < strCodes.length; i++) {
                srcData.push("<a ID=\"" + strCodes[i] + "\" b3=\"0\" b4=\"0\" b5=\"0\" b6=\"0\" />");
            }
            return { Id: id, Data: srcData };
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F03211.ExportRules = ExportRules;
})(F03211 || (F03211 = {}));
