var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F04111;
(function (F04111) {
    var InterfaceRules = (function (_super) {
        __extends(InterfaceRules, _super);
        function InterfaceRules(document) {
            return _super.call(this, document) || this;
        }
        InterfaceRules.prototype.SheetP2Sp4NpaFormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 0:
                case 1:
                    return SheetFormatCollection.Related;
                case 2:
                case 6:
                    return SheetFormatCollection.Spr;
                default:
                    return SheetFormatCollection.Free;
            }
        };
        InterfaceRules.prototype.SheetP2Sp4NpaCanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return column > 1;
        };
        InterfaceRules.prototype.SheetP2Sp4NpaCanEditEventHandler = function (sheetId, row, column, fieldId, levelRow) {
            var table = this._document.Sheets.getValue(sheetId).Table;
            if (column < 2) {
                return false;
            }
            else if (column > 1 && column < 8) {
                return table.GetKeyBySourceTable(this._document.P2Sp4NpaTable) != null;
            }
            else {
                return table.GetKeyBySourceTable(this._document.P2Sp4DecisionCoordinatingBodyTable) != null;
            }
        };
        InterfaceRules.prototype.SheetP2Sp4NpaCanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return this.SheetP2Sp4NpaCanEditEventHandler(sheetId, row, column, fieldId, rowLevel);
        };
        return InterfaceRules;
    }(F08410.InterfaceRules));
    F04111.InterfaceRules = InterfaceRules;
    var P1Sheet = (function (_super) {
        __extends(P1Sheet, _super);
        function P1Sheet(id, _document) {
            return _super.call(this, id, _document, 3, 5) || this;
        }
        P1Sheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (this.IsDataColumn(column)) {
                if (this.IsFooterRow(row)) {
                    return SheetFormatCollection.Calc;
                }
                else {
                    return SheetFormatCollection.Related;
                }
            }
            else {
                if (column < this.RowNameColumn) {
                    if (this.IsFooterRow(row)) {
                        return SheetFormatCollection.Default;
                    }
                    else {
                        return SheetFormatCollection.Related;
                    }
                }
            }
            return SheetFormatCollection.Default;
        };
        return P1Sheet;
    }(YearsSheetTyped));
    F04111.P1Sheet = P1Sheet;
    var P2GroupSheet = (function (_super) {
        __extends(P2GroupSheet, _super);
        function P2GroupSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(P2GroupSheet.prototype, "SheetInfo", {
            get: function () {
                return P2GroupSheet._sheetInfo;
            },
            enumerable: true,
            configurable: true
        });
        P2GroupSheet.prototype.GetRowLevel = function (param, row) {
            var sheet = this.GetSheetFromParam(param);
            var result = sheet.GetRowLevel(row);
            if (sheet.GetCellValue(row, sheet.ColumnCount, false)) {
                result++;
            }
            return result;
        };
        P2GroupSheet.prototype.StandardCalcStrCode = function (param, row, column, info) {
            var sheet = this.GetSheetFromParam(param);
            var curLvl = this.GetRowLevel(param, row) - 1;
            var lvlInc = curLvl > 0 ? info.LevelIncs[curLvl - 1] : 0;
            var prevLvl = -1;
            var prevCode = 0;
            var curCode;
            if (row > 0) {
                prevLvl = this.GetRowLevel(param, row - 1) - 1;
                prevCode = parseInt(sheet.GetCellValue(row - 1, column), 10);
            }
            if (prevLvl === curLvl) {
                curCode = prevCode + lvlInc;
            }
            else if (curLvl === 0) {
                curCode = info.CalcTotalCode(sheet, row, column);
            }
            else {
                if (lvlInc === 0) {
                    curCode = 0;
                }
                else {
                    curCode = (((prevCode / lvlInc) | 0) + 1) * lvlInc;
                }
            }
            return ObasHelper.FillWithCharacter(curCode.toString(), info.Length);
        };
        P2GroupSheet.prototype.InitCustomStandardcalcResult = function (row, cellInfo) {
            var result = new SheetCalcResult(cellInfo.FormulaId);
            var columns = cellInfo.SourceColumns;
            for (var i = 0; i < columns.length; i++) {
                result.AddCoordinates(new CellCoordinate(row, columns[i]));
            }
            return result.ToArray();
        };
        P2GroupSheet.prototype.StandardCalc = function (param, row, column, info) {
            var sheet = this.GetSheetFromParam(param);
            if (column === info.CodeInfo.Column) {
                return this.StandardCalcStrCode(sheet, row, column, info.CodeInfo);
            }
            else {
                var curLvl = this.GetRowLevel(param, row, info) - 1;
                var columnInfo = info.ColumnsInfo[column];
                if (columnInfo != null) {
                    var cellInfo = columnInfo.Cell;
                    var result = void 0;
                    if (curLvl === info.MaxLevel) {
                        if (cellInfo.FormulaId != null) {
                            return this.InitCustomStandardcalcResult(row, cellInfo);
                        }
                    }
                    else {
                        var rowInfo = void 0;
                        if (curLvl === 0) {
                            rowInfo = columnInfo.TotalRow;
                        }
                        else {
                            if (columnInfo.SubTotalRow instanceof Array) {
                                rowInfo = columnInfo.SubTotalRow[curLvl - 1];
                            }
                            else {
                                var temp = columnInfo.SubTotalRow;
                                rowInfo = temp;
                            }
                        }
                        if (!rowInfo.IsCalculated && rowInfo.Name != null) {
                            return rowInfo.Name;
                        }
                        else if (rowInfo.IsCalculated) {
                            if (cellInfo.FormulaId) {
                                return this.InitCustomStandardcalcResult(row, cellInfo);
                            }
                            else {
                                if (rowInfo.IsCalculated) {
                                    if (curLvl === 0) {
                                        var result_1 = new SheetCalcResult(BaseFormulas.SUM);
                                        for (var i = 0; i < sheet.RowCount; i++) {
                                            var code = parseInt(sheet.GetCellValue(i, info.CodeInfo.Column));
                                            if (code % info.CodeInfo.LevelIncs[curLvl] === 0) {
                                                result_1.AddCoordinates(new CellCoordinate(i, column));
                                            }
                                        }
                                        return result_1.ToArray();
                                    }
                                    else if (curLvl === 1) {
                                        var result_2 = new SheetCalcResult(BaseFormulas.SUM);
                                        var code = (row > 0) ? parseInt(sheet.GetCellValue(row - 1, info.CodeInfo.Column)) : 0;
                                        var i = row - 1;
                                        while (i >= 0 && code > 0 && code % info.CodeInfo.LevelIncs[curLvl - 1] !== 0) {
                                            var prevCode = (i > 0) ? parseInt(sheet.GetCellValue(i - 1, info.CodeInfo.Column)) : -1;
                                            if (code !== prevCode) {
                                                result_2.AddCoordinates(new CellCoordinate(i, column));
                                            }
                                            code = prevCode;
                                            i--;
                                        }
                                        return result_2.ToArray();
                                    }
                                }
                            }
                        }
                    }
                }
            }
            return undefined;
        };
        P2GroupSheet.prototype.StandardFormat = function (param, row, column, info) {
            var sheet = this.GetSheetFromParam(param);
            var curLvl = this.GetRowLevel(param, row) - 1;
            var columnInfo = info.ColumnsInfo[column];
            if (columnInfo != null) {
                if (curLvl === info.MaxLevel) {
                    var cellInfo = columnInfo.Cell;
                    if (cellInfo.Format != null) {
                        return cellInfo.Format;
                    }
                    else {
                        return SheetFormatCollection.GetFormat(cellInfo.Type);
                    }
                }
                var rowInfo = void 0;
                if (curLvl === 0) {
                    rowInfo = columnInfo.TotalRow;
                }
                else {
                    if (columnInfo.SubTotalRow instanceof Array) {
                        rowInfo = columnInfo.SubTotalRow[curLvl - 1];
                    }
                    else {
                        var temp = columnInfo.SubTotalRow;
                        rowInfo = temp;
                    }
                }
                if (rowInfo.Format != null) {
                    return rowInfo.Format;
                }
                else {
                    return SheetFormatCollection.Calc;
                }
            }
            return SheetFormatCollection.Default;
        };
        P2GroupSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            return this.StandardCalc(sheetId, row, column, this.SheetInfo);
        };
        P2GroupSheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            return this.StandardFormat(sheetId, row, column, this.SheetInfo);
        };
        P2GroupSheet._totalRowInfo = {
            IsCalculated: false,
            Name: "\u0412\u0441\u0435\u0433\u043E",
            Format: SheetFormatCollection.Default
        };
        P2GroupSheet._totalCustomerRowInfo = {
            IsCalculated: false,
            Name: "\u0418\u0442\u043E\u0433\u043E \u043F\u043E \u0437\u0430\u0441\u0442\u0440\u043E\u0439\u0449\u0438\u043A\u0443 / \u0437\u0430\u043A\u0430\u0437\u0447\u0438\u043A\u0443",
            Format: SheetFormatCollection.Default
        };
        P2GroupSheet._relatedColAllConst = {
            Cell: { Type: SheetCellTypes.Related },
            SubTotalRow: P2GroupSheet._totalCustomerRowInfo,
            TotalRow: P2GroupSheet._totalRowInfo
        };
        P2GroupSheet._codeInfo = {
            Column: 2,
            Length: 4,
            LevelIncs: [100, 1],
            CalcTotalCode: function () {
                return 9000;
            }
        };
        P2GroupSheet._sheetInfo = {
            MaxLevel: 2,
            CodeInfo: P2GroupSheet._codeInfo,
            ColumnsInfo: [
                SheetColumnInfoCollection.RelatedColDefaultTotal,
                P2GroupSheet._relatedColAllConst,
                SheetColumnInfoCollection.AllDefault,
                SheetColumnInfoCollection.RelatedColAllX,
                SheetColumnInfoCollection.RelatedColAllX,
                SheetColumnInfoCollection.RelatedColAllCalc,
                SheetColumnInfoCollection.RelatedColAllCalc,
                SheetColumnInfoCollection.RelatedColAllCalc,
                SheetColumnInfoCollection.RelatedColAllCalc
            ]
        };
        return P2GroupSheet;
    }(YearGroupSheet));
    F04111.P2GroupSheet = P2GroupSheet;
    var P2Sp4Sp1GroupSheet = (function (_super) {
        __extends(P2Sp4Sp1GroupSheet, _super);
        function P2Sp4Sp1GroupSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(P2Sp4Sp1GroupSheet.prototype, "SheetInfo", {
            get: function () {
                return P2Sp4Sp1GroupSheet._sheetInfo;
            },
            enumerable: true,
            configurable: true
        });
        P2Sp4Sp1GroupSheet.prototype.CanEditEventHandler = function (sheetId, row, column, fieldId, levelRow) {
            var sheet = this._document.Sheets.getValue(sheetId);
            var code = parseInt(sheet.GetCellValue(row, this.SheetInfo.CodeInfo.Column));
            if (code !== 900) {
                var table = this._document.Sheets.getValue(sheetId).Table;
                if (column > 2 && column <= 11) {
                    return table.GetKeyBySourceTable(this._document.P2Sp4InvestInfoTable) != null;
                }
                else if (column > 11) {
                    return table.GetKeyBySourceTable(this._document.P2Sp4PowerInfoTable) != null;
                }
            }
        };
        P2Sp4Sp1GroupSheet._totalActionRowInfo = {
            IsCalculated: false,
            Name: "\u0418\u0442\u043E\u0433\u043E \u043F\u043E \u043C\u0435\u0440\u043E\u043F\u0440\u0438\u044F\u0442\u0438\u044E",
            Format: SheetFormatCollection.Default
        };
        P2Sp4Sp1GroupSheet._freeColAllConst = {
            Cell: { Type: SheetCellTypes.Free },
            SubTotalRow: P2Sp4Sp1GroupSheet._totalActionRowInfo,
            TotalRow: F08410.P2SpxSp1GroupSheet._totalRowInfo
        };
        P2Sp4Sp1GroupSheet._codeInfo = {
            Column: 6,
            Length: 3,
            LevelIncs: [100, 1],
            CalcTotalCode: function () {
                return 900;
            }
        };
        P2Sp4Sp1GroupSheet._sheetInfo = {
            MaxLevel: 2,
            CodeInfo: P2Sp4Sp1GroupSheet._codeInfo,
            ColumnsInfo: [
                SheetColumnInfoCollection.SprColDefaultTotal,
                SheetColumnInfoCollection.SprColDefaultTotal,
                SheetColumnInfoCollection.FreeColDefaultTotal,
                F08410.P2SpxSp1GroupSheet._sprColAllDefault,
                F08410.P2SpxSp1GroupSheet._sprColAllDefault,
                P2Sp4Sp1GroupSheet._freeColAllConst,
                SheetColumnInfoCollection.AllDefault,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.SprColAllX,
                SheetColumnInfoCollection.SprColAllX,
                SheetColumnInfoCollection.FreeColAllX,
                SheetColumnInfoCollection.FreeColAllX
            ]
        };
        return P2Sp4Sp1GroupSheet;
    }(F08410.P2SpxSp1GroupSheet));
    F04111.P2Sp4Sp1GroupSheet = P2Sp4Sp1GroupSheet;
})(F04111 || (F04111 = {}));
