var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F04111;
(function (F04111) {
    var TableRules = (function (_super) {
        __extends(TableRules, _super);
        function TableRules(document) {
            return _super.call(this, document) || this;
        }
        return TableRules;
    }(F08410.TableRules));
    F04111.TableRules = TableRules;
    var StrKeysP1;
    (function (StrKeysP1) {
        StrKeysP1[StrKeysP1["Total"] = 1] = "Total";
        StrKeysP1[StrKeysP1["P2Sp1"] = 2] = "P2Sp1";
        StrKeysP1[StrKeysP1["P2Sp2"] = 3] = "P2Sp2";
        StrKeysP1[StrKeysP1["P2Sp3"] = 4] = "P2Sp3";
        StrKeysP1[StrKeysP1["P2Sp4"] = 5] = "P2Sp4";
    })(StrKeysP1 = F04111.StrKeysP1 || (F04111.StrKeysP1 = {}));
    var P1TotalTable = (function (_super) {
        __extends(P1TotalTable, _super);
        function P1TotalTable() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P1TotalTable.prototype.GetTotalKey = function () {
            return StrKeysP1.Total;
        };
        return P1TotalTable;
    }(P1TotalObasTable));
    F04111.P1TotalTable = P1TotalTable;
    var P1Table = (function (_super) {
        __extends(P1Table, _super);
        function P1Table() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P1Table.prototype.SumChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            if (this.StrKey != StrKeysP1.Total) {
                _super.prototype.SumChangeEventHandler.call(this, tableId, oldValue, newValue, fieldId);
            }
        };
        return P1Table;
    }(ObasTableP1));
    F04111.P1Table = P1Table;
    var P2TotalTable = (function (_super) {
        __extends(P2TotalTable, _super);
        function P2TotalTable(id, _document, _uniqCustomerTableId) {
            var _this = _super.call(this, id) || this;
            _this._document = _document;
            _this._uniqCustomerTableId = _uniqCustomerTableId;
            _this._objCode = null;
            _this._objName = null;
            _this._customer = null;
            _this._objectTableIds = [];
            _this._investObjectTables = [];
            return _this;
        }
        Object.defineProperty(P2TotalTable.prototype, "ObjCode", {
            get: function () {
                if (this._objCode == null) {
                    this._objCode = new NumberObasTableField("ObjCode", this);
                }
                return this._objCode;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(P2TotalTable.prototype, "ObjName", {
            get: function () {
                if (this._objName == null) {
                    this._objName = new NumberObasTableField("ObjName", this);
                }
                return this._objName;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(P2TotalTable.prototype, "Customer", {
            get: function () {
                if (this._customer == null) {
                    this._customer = new ObasSprTableField(this._document.CustomersSprTable, this);
                }
                return this._customer;
            },
            enumerable: true,
            configurable: true
        });
        P2TotalTable.prototype.AddObjectTableId = function (child) {
            var childId = child.Id;
            if (this._objectTableIds.indexOf(childId) === -1) {
                this._objectTableIds.push(childId);
            }
        };
        P2TotalTable.prototype.AddDataRow = function (customerKey, objCode, objName) {
            if (customerKey != null) {
                this._document.CommonRules.AddNewLink(this._uniqCustomerTableId, [this.Customer.ForeignKey.Id], [customerKey]);
            }
            if (customerKey != null && objCode != null && objName != null) {
                this._document.CommonRules.AddNewLink(this.Id, [this.Customer.ForeignKey.Id, this.ObjCode.Id, this.ObjName.Id], [customerKey, objCode, objName]);
            }
            this.RecalcSums(customerKey, objCode, objName);
        };
        P2TotalTable.prototype.DeleteDataRow = function (customerKey, objCode, objName) {
            this._document.CommonRules.DeleteOldLink(this.Id, this._objectTableIds, [this.Customer.ForeignKey.Id, this.ObjCode.Id, this.ObjName.Id], [customerKey, objCode, objName]);
            this._document.CommonRules.DeleteOldLink(this._uniqCustomerTableId, [this.Id], [this.Customer.ForeignKey.Id], [customerKey]);
            this.RecalcSums(customerKey, objCode, objName);
        };
        P2TotalTable.prototype.AddInvestTableId = function (child, parent) {
            if (this._objectTableIds.indexOf(parent.Id) !== -1) {
                var childId = child.Id;
                if (this._investObjectTables.indexOf(child) === -1) {
                    this._investObjectTables.push(child);
                }
            }
        };
        P2TotalTable.prototype.ChangeSum = function (tableId, oldValue, newValue, fieldId) {
            var investTable = this._document.Tables.getValue(tableId);
            if (this.Locate([this.Customer.ForeignKey.Id, this.ObjCode.Id, this.ObjName.Id], [investTable.GetFieldValue(this.Customer.ForeignKey.Id),
                investTable.GetFieldValue(this.ObjCode.Id), investTable.GetFieldValue(this.ObjName.Id)])) {
                this.SetFieldValue(fieldId, this.GetFieldValue(fieldId) + (newValue - oldValue));
            }
        };
        P2TotalTable.prototype.RecalcSums = function (customerKey, objCode, objName) {
            if (customerKey != null && objCode != null && objName != null) {
                if (this.Locate([this.Customer.ForeignKey.Id, this.ObjCode.Id, this.ObjName.Id], [customerKey, objCode, objName])) {
                    var yearsCount = this._document.Settings.YearsCount;
                    var yearField = BaseObasTableFields.YearDataField;
                    for (var i = 0; i < yearsCount; i++) {
                        this.SetFieldValue(yearField.GenerateId(i + 1), 0);
                    }
                    for (var i = 0; i < this._investObjectTables.length; i++) {
                        var investTable = this._investObjectTables[i];
                        var reader = investTable.CreateReader();
                        while (reader.Read()) {
                            if ((investTable.ParentTable.GetFieldValue(this.Customer.ForeignKey.Id) === customerKey) &&
                                (investTable.ParentTable.GetFieldValue(this.ObjCode.Id) === objCode) &&
                                (investTable.ParentTable.GetFieldValue(this.ObjName.Id) === objName)) {
                                for (var j = 0; j < yearsCount; j++) {
                                    var fieldId = yearField.GenerateId(j + 1);
                                    this.SetFieldValue(fieldId, this.GetFieldValue(fieldId) + investTable.GetFieldValue(fieldId));
                                }
                            }
                        }
                    }
                }
            }
        };
        return P2TotalTable;
    }(ObasTable));
    F04111.P2TotalTable = P2TotalTable;
    var ObjectInfoTable = (function (_super) {
        __extends(ObjectInfoTable, _super);
        function ObjectInfoTable() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._customerKey = null;
            _this._objCode = null;
            _this._objName = null;
            return _this;
        }
        ObjectInfoTable.prototype.CustomerChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this.AfterDeleteEventHandler(this.Id, oldValue, this.Object.Code, this.Object.Name);
            this._sumTable.AddDataRow(newValue, this.Object.Code, this.Object.Name);
        };
        ObjectInfoTable.prototype.ObjectChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            var objectTable = this._document.ObjectsSprTable;
            this.AfterDeleteEventHandler(this.Id, this.Customer.ForeignKey.Value, objectTable.Code.LookupByKeys(oldValue), objectTable.Name.LookupByKeys(oldValue));
            this._sumTable.AddDataRow(this.Customer.ForeignKey.Value, this.Object.Code, this.Object.Name);
        };
        ObjectInfoTable.prototype.DeleteEventHandler = function (tableId) {
            this._customerKey = this.Customer.ForeignKey.Value;
            this._objCode = this.Object.Code;
            this._objName = this.Object.Name;
        };
        ObjectInfoTable.prototype.AfterDeleteEventHandler = function (tableId, customerKey, objCode, objName) {
            if (customerKey === void 0) { customerKey = this._customerKey; }
            if (objCode === void 0) { objCode = this._objCode; }
            if (objName === void 0) { objName = this._objName; }
            this._sumTable.DeleteDataRow(customerKey, objCode, objName);
        };
        return ObjectInfoTable;
    }(F08410.ObjectInfoTable));
    F04111.ObjectInfoTable = ObjectInfoTable;
    var InvestInfoTable = (function (_super) {
        __extends(InvestInfoTable, _super);
        function InvestInfoTable(id, _document, _parentTable, _totalTable, _totalRowKey, _sumTable) {
            var _this = _super.call(this, id, _document, _parentTable) || this;
            _this._document = _document;
            _this._parentTable = _parentTable;
            _this._totalTable = _totalTable;
            _this._totalRowKey = _totalRowKey;
            _this._sumTable = _sumTable;
            _this._investigationType = null;
            _this._okved = null;
            _this._startUseDate = null;
            if (_this.IsExistsSumTable) {
                _this._sumTable.AddInvestTableId(_this, _parentTable);
            }
            return _this;
        }
        Object.defineProperty(InvestInfoTable.prototype, "IsExistsSumTable", {
            get: function () {
                return this._sumTable != null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InvestInfoTable.prototype, "ParentTable", {
            get: function () {
                return this.OwnerKey.SourceTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InvestInfoTable.prototype, "InvestigationType", {
            get: function () {
                if (this._investigationType == null) {
                    this._investigationType = new ObasSprTableField(ObasTableCollection.InvestigationTypesSprTable, this, "Investigation");
                }
                return this._investigationType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InvestInfoTable.prototype, "Okved", {
            get: function () {
                if (this._okved == null) {
                    this._okved = new ObasSprTableField(ObasTableCollection.OkvedSprTable, this);
                }
                return this._okved;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InvestInfoTable.prototype, "StartUseDate", {
            get: function () {
                if (this._startUseDate == null) {
                    this._startUseDate = new ObasTableField("StartUseDate", this);
                }
                return this._startUseDate;
            },
            enumerable: true,
            configurable: true
        });
        InvestInfoTable.prototype.SumChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            var pbsKey = ObasTableCollection.SelectedFoivTable.RecordKey.Value;
            this._totalTable.SetSumByKeys(fieldId, this._totalTable.GetKeys(this._totalRowKey, pbsKey), oldValue, newValue, true);
            this._totalTable.SetSumByKeys(fieldId, this._totalTable.GetKeys(StrKeysP1.Total, pbsKey), oldValue, newValue, true);
            if (this.IsExistsSumTable) {
                this._sumTable.ChangeSum(tableId, oldValue, newValue, fieldId);
            }
        };
        InvestInfoTable.prototype.AfterDeleteChildsEventHandler = function (tableId) {
            var _this = this;
            var yearField = BaseObasTableFields.YearDataField;
            this.Document.IterateByYears(function (yearIndex) {
                var fieldId = yearField.GenerateId(yearIndex);
                _this.SetFieldValue(fieldId, 0);
            });
        };
        return InvestInfoTable;
    }(ObasTableWithSimpleKeysParent));
    F04111.InvestInfoTable = InvestInfoTable;
    var InvestProjectInfoTable = (function (_super) {
        __extends(InvestProjectInfoTable, _super);
        function InvestProjectInfoTable(id, _document) {
            var _this = _super.call(this, id) || this;
            _this._document = _document;
            _this._action = null;
            _this._okved = null;
            _this._cost = null;
            _this._startUseDate = null;
            return _this;
        }
        Object.defineProperty(InvestProjectInfoTable.prototype, "Action", {
            get: function () {
                if (this._action == null) {
                    this._action = new ObasSprTableField(this._document.ActionsSprTable, this);
                }
                return this._action;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InvestProjectInfoTable.prototype, "Okved", {
            get: function () {
                if (this._okved == null) {
                    this._okved = new ObasSprTableField(ObasTableCollection.OkvedSprTable, this);
                }
                return this._okved;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InvestProjectInfoTable.prototype, "Cost", {
            get: function () {
                if (this._cost == null) {
                    this._cost = new NumberObasTableField("Cost", this);
                }
                return this._cost;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InvestProjectInfoTable.prototype, "StartUseDate", {
            get: function () {
                if (this._startUseDate == null) {
                    this._startUseDate = new ObasTableField("StartUseDate", this);
                }
                return this._startUseDate;
            },
            enumerable: true,
            configurable: true
        });
        return InvestProjectInfoTable;
    }(ObasTable));
    F04111.InvestProjectInfoTable = InvestProjectInfoTable;
    var ObjectInfoTableWithParent = (function (_super) {
        __extends(ObjectInfoTableWithParent, _super);
        function ObjectInfoTableWithParent(id, _document, parent, _sumTable) {
            var _this = _super.call(this, id, _document, parent) || this;
            _this._document = _document;
            _this._sumTable = _sumTable;
            _this._object = null;
            _this._customer = null;
            _this._oktmo = null;
            _this._address = null;
            _this._cost = null;
            _this._customerKey = null;
            _this._objCode = null;
            _this._objName = null;
            _this._sumTable.AddObjectTableId(_this);
            return _this;
        }
        Object.defineProperty(ObjectInfoTableWithParent.prototype, "ParentTable", {
            get: function () {
                return this.OwnerKey.SourceTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ObjectInfoTableWithParent.prototype, "Object", {
            get: function () {
                if (this._object == null) {
                    this._object = new ObasSprTableField(this._document.ObjectsSprTable, this);
                }
                return this._object;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ObjectInfoTableWithParent.prototype, "Customer", {
            get: function () {
                if (this._customer == null) {
                    this._customer = new ObasSprTableField(this._document.CustomersSprTable, this);
                }
                return this._customer;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ObjectInfoTableWithParent.prototype, "Oktmo", {
            get: function () {
                if (this._oktmo == null) {
                    this._oktmo = new ObasSprTableField(this._document.OktmoSprTable, this);
                }
                return this._oktmo;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ObjectInfoTableWithParent.prototype, "Address", {
            get: function () {
                if (this._address == null) {
                    this._address = new NumberObasTableField("Address", this);
                }
                return this._address;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ObjectInfoTableWithParent.prototype, "Cost", {
            get: function () {
                if (this._cost == null) {
                    this._cost = new NumberObasTableField("Cost", this);
                }
                return this._cost;
            },
            enumerable: true,
            configurable: true
        });
        ObjectInfoTableWithParent.prototype.CustomerChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this.AfterDeleteEventHandler(this.Id, oldValue, this.Object.Code, this.Object.Name);
            this._sumTable.AddDataRow(newValue, this.Object.Code, this.Object.Name);
        };
        ObjectInfoTableWithParent.prototype.ObjectChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            var objectTable = this._document.ObjectsSprTable;
            this.AfterDeleteEventHandler(this.Id, this.Customer.ForeignKey.Value, objectTable.Code.LookupByKeys(oldValue), objectTable.Name.LookupByKeys(oldValue));
            this._sumTable.AddDataRow(this.Customer.ForeignKey.Value, this.Object.Code, this.Object.Name);
        };
        ObjectInfoTableWithParent.prototype.DeleteEventHandler = function (tableId) {
            this._customerKey = this.Customer.ForeignKey.Value;
            this._objCode = this.Object.Code;
            this._objName = this.Object.Name;
        };
        ObjectInfoTableWithParent.prototype.AfterDeleteEventHandler = function (tableId, customerKey, objCode, objName) {
            if (customerKey === void 0) { customerKey = this._customerKey; }
            if (objCode === void 0) { objCode = this._objCode; }
            if (objName === void 0) { objName = this._objName; }
            this._sumTable.DeleteDataRow(customerKey, objCode, objName);
        };
        return ObjectInfoTableWithParent;
    }(ObasTableWithSimpleKeysParent));
    F04111.ObjectInfoTableWithParent = ObjectInfoTableWithParent;
    var ActionInfoTable = (function (_super) {
        __extends(ActionInfoTable, _super);
        function ActionInfoTable(id, _document) {
            var _this = _super.call(this, id) || this;
            _this._document = _document;
            _this._action = null;
            _this._customer = null;
            _this._countSpecialRanks = null;
            return _this;
        }
        Object.defineProperty(ActionInfoTable.prototype, "Action", {
            get: function () {
                if (this._action == null) {
                    this._action = new ObasSprTableField(this._document.ActionsSprTable, this);
                }
                return this._action;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ActionInfoTable.prototype, "Customer", {
            get: function () {
                if (this._customer == null) {
                    this._customer = new ObasSprTableField(this._document.CustomersSprTable, this);
                }
                return this._customer;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ActionInfoTable.prototype, "CountSpecialRanks", {
            get: function () {
                if (this._countSpecialRanks == null) {
                    this._countSpecialRanks = new NumberObasTableField("CountSpecialRanks", this);
                }
                return this._countSpecialRanks;
            },
            enumerable: true,
            configurable: true
        });
        return ActionInfoTable;
    }(ObasTable));
    F04111.ActionInfoTable = ActionInfoTable;
    var P2Sp2ObjectInfoTable = (function (_super) {
        __extends(P2Sp2ObjectInfoTable, _super);
        function P2Sp2ObjectInfoTable() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P2Sp2ObjectInfoTable.prototype.AddEventHandler = function (tableId) {
            var investTable = this._document.P2Sp2InvestInfoTable;
            investTable.AddRow();
            investTable.PostRow();
        };
        return P2Sp2ObjectInfoTable;
    }(ObjectInfoTable));
    F04111.P2Sp2ObjectInfoTable = P2Sp2ObjectInfoTable;
    var P2Sp3InvestProjectInfoTable = (function (_super) {
        __extends(P2Sp3InvestProjectInfoTable, _super);
        function P2Sp3InvestProjectInfoTable() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P2Sp3InvestProjectInfoTable.prototype.AddEventHandler = function (tableId) {
            var investTable = this._document.P2Sp3Sp1InvestInfoTable;
            investTable.AddRow();
            investTable.PostRow();
        };
        return P2Sp3InvestProjectInfoTable;
    }(InvestProjectInfoTable));
    F04111.P2Sp3InvestProjectInfoTable = P2Sp3InvestProjectInfoTable;
})(F04111 || (F04111 = {}));
