var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F04120;
(function (F04120) {
    var InterfaceRules = (function (_super) {
        __extends(InterfaceRules, _super);
        function InterfaceRules(_document) {
            var _this = this;
            _this._document = _document;
            return _this;
        }
        InterfaceRules.prototype.SheetP1FormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 0:
                    return SheetFormatCollection.Default;
                default:
                    return SheetFormatCollection.Related;
            }
        };
        InterfaceRules.prototype.SheetP2Sp2NpaFormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 0:
                case 1:
                    return SheetFormatCollection.Related;
                case 2:
                case 6:
                    return SheetFormatCollection.Spr;
                default:
                    return SheetFormatCollection.Free;
            }
        };
        InterfaceRules.prototype.SheetP2Sp2NpaCanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return column > 1;
        };
        InterfaceRules.prototype.SheetP2Sp2NpaCanEditEventHandler = function (sheetId, row, column, fieldId, levelRow) {
            var table = this._document.Sheets.getValue(sheetId).Table;
            if (column < 2) {
                return false;
            }
            else {
                return table.GetKeyBySourceTable(this._document.P2Sp2NpaTable) != null;
            }
        };
        InterfaceRules.prototype.SheetP2Sp2NpaCanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return this.SheetP2Sp2NpaCanEditEventHandler(sheetId, row, column, fieldId, rowLevel);
        };
        InterfaceRules.prototype.SheetP2Sp3NpaFormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 0:
                case 1:
                    return SheetFormatCollection.Related;
                case 2:
                case 6:
                    return SheetFormatCollection.Spr;
                default:
                    return SheetFormatCollection.Free;
            }
        };
        InterfaceRules.prototype.SheetP2Sp3NpaCanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return column > 1;
        };
        InterfaceRules.prototype.SheetP2Sp3NpaCanEditEventHandler = function (sheetId, row, column, fieldId, levelRow) {
            var table = this._document.Sheets.getValue(sheetId).Table;
            if (column < 2) {
                return false;
            }
            else {
                return table.GetKeyBySourceTable(this._document.P2Sp3NpaTable) != null;
            }
        };
        InterfaceRules.prototype.SheetP2Sp3NpaCanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return this.SheetP2Sp3NpaCanEditEventHandler(sheetId, row, column, fieldId, rowLevel);
        };
        return InterfaceRules;
    }(BaseInterfaceRules));
    F04120.InterfaceRules = InterfaceRules;
    var P1Sheet = (function (_super) {
        __extends(P1Sheet, _super);
        function P1Sheet(id, _document) {
            return _super.call(this, id, _document, 3, 3) || this;
        }
        P1Sheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (this.IsDataColumn(column)) {
                if (this.IsFooterRow(row)) {
                    return SheetFormatCollection.Calc;
                }
                else {
                    return SheetFormatCollection.Related;
                }
            }
            else {
                if (column < this.RowNameColumn) {
                    if (this.IsFooterRow(row)) {
                        return SheetFormatCollection.Default;
                    }
                    else {
                        return SheetFormatCollection.Related;
                    }
                }
            }
            return SheetFormatCollection.Default;
        };
        return P1Sheet;
    }(YearsSheetTyped));
    F04120.P1Sheet = P1Sheet;
    var P2Sp1Sp1GroupSheet = (function (_super) {
        __extends(P2Sp1Sp1GroupSheet, _super);
        function P2Sp1Sp1GroupSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(P2Sp1Sp1GroupSheet.prototype, "SheetInfo", {
            get: function () {
                return P2Sp1Sp1GroupSheet._sheetInfo;
            },
            enumerable: true,
            configurable: true
        });
        P2Sp1Sp1GroupSheet.prototype.GetRowLevel = function (param, row) {
            var sheet = this.GetSheetFromParam(param);
            var result = sheet.GetRowLevel(row);
            if (sheet.GetCellValue(row, sheet.ColumnCount, false)) {
        	result++;
            }
            return result;
        };
        P2Sp1Sp1GroupSheet.prototype.StandardCalcStrCode = function (param, row, column, info) {
            var sheet = this.GetSheetFromParam(param);
            var curLvl = this.GetRowLevel(param, row) - 1;
            var lvlInc = curLvl > 0 ? info.LevelIncs[curLvl - 1] : 0;
            var prevLvl = -1;
            var prevCode = 0;
            var curCode;
            if (row > 0) {
                prevLvl = this.GetRowLevel(param, row - 1) - 1;
                prevCode = parseInt(sheet.GetCellValue(row - 1, column), 10);
            }
            if (prevLvl === curLvl) {
                curCode = prevCode + lvlInc;
            }
            else if (curLvl === 0) {
                curCode = info.CalcTotalCode(sheet, row, column);
            }
            else {
                if (lvlInc === 0) {
                    curCode = 0;
                }
                else {
                    curCode = (((prevCode / lvlInc) | 0) + 1) * lvlInc;
                }
            }
            return ObasHelper.FillWithCharacter(curCode.toString(), info.Length);
        };
        P2Sp1Sp1GroupSheet.prototype.StandardCalc = function (param, row, column, info) {
            var sheet = this.GetSheetFromParam(param);
            if (column === info.CodeInfo.Column) {
                return this.StandardCalcStrCode(sheet, row, column, info.CodeInfo);
            }
            else {
                var curLvl = this.GetRowLevel(param, row, info) - 1;
                var columnInfo = info.ColumnsInfo[column];
                if (columnInfo != null) {
                    var cellInfo = columnInfo.Cell;
                    var result = void 0;
                    if (curLvl === info.MaxLevel) {
                        if (cellInfo.FormulaId != null) {
                            return this.InitCustomStandardcalcResult(row, cellInfo);
                        }
                    }
                    else {
                        var rowInfo = void 0;
                        if (curLvl === 0) {
                            rowInfo = columnInfo.TotalRow;
                        }
                        else {
                            if (columnInfo.SubTotalRow instanceof Array) {
                                rowInfo = columnInfo.SubTotalRow[curLvl - 1];
                            }
                            else {
                                var temp = columnInfo.SubTotalRow;
                                rowInfo = temp;
                            }
                        }
                        if (!rowInfo.IsCalculated && rowInfo.Name != null) {
                            return rowInfo.Name;
                        }
                        else if (rowInfo.IsCalculated) {
                            if (cellInfo.FormulaId) {
                                return this.InitCustomStandardcalcResult(row, cellInfo);
                            }
                            else {
                                if (rowInfo.IsCalculated) {
                                    if (curLvl === 0) {
                                        var result_1 = new SheetCalcResult(BaseFormulas.SUM);
                                        for (var i = 0; i < sheet.RowCount; i++) {
                                            var code = parseInt(sheet.GetCellValue(i, info.CodeInfo.Column));
                                            if (code % info.CodeInfo.LevelIncs[curLvl] === 0) {
                                                result_1.AddCoordinates(new CellCoordinate(i, column));
                                            }
                                        }
                                        return result_1.ToArray();
                                    }
                                    else if (curLvl === 1) {
                                        var result_2 = new SheetCalcResult(BaseFormulas.SUM);
                                        var code = (row > 0) ? parseInt(sheet.GetCellValue(row - 1, info.CodeInfo.Column)) : 0;
                                        var i = row - 1;
                                        while (i >= 0 && code > 0 && code % info.CodeInfo.LevelIncs[curLvl - 1] !== 0) {
                                            var prevCode = (i > 0) ? parseInt(sheet.GetCellValue(i - 1, info.CodeInfo.Column)) : -1;
                                            if (code !== prevCode) {
                                                result_2.AddCoordinates(new CellCoordinate(i, column));
                                            }
                                            code = prevCode;
                                            i--;
                                        }
                                        return result_2.ToArray();
                                    }
                                }
                            }
                        }
                    }
                }
            }
            return undefined;
        };
        P2Sp1Sp1GroupSheet.prototype.StandardFormat = function (param, row, column, info) {
            var sheet = this.GetSheetFromParam(param);
            var curLvl = this.GetRowLevel(param, row) - 1;
            var columnInfo = info.ColumnsInfo[column];
            if (columnInfo != null) {
                if (curLvl === info.MaxLevel) {
                    var cellInfo = columnInfo.Cell;
                    if (cellInfo.Format != null) {
                        return cellInfo.Format;
                    }
                    else {
                        return SheetFormatCollection.GetFormat(cellInfo.Type);
                    }
                }
                var rowInfo = void 0;
                if (curLvl === 0) {
                    rowInfo = columnInfo.TotalRow;
                }
                else {
                    if (columnInfo.SubTotalRow instanceof Array) {
                        rowInfo = columnInfo.SubTotalRow[curLvl - 1];
                    }
                    else {
                        var temp = columnInfo.SubTotalRow;
                        rowInfo = temp;
                    }
                }
                if (rowInfo.Format != null) {
                    return rowInfo.Format;
                }
                else {
                    return SheetFormatCollection.Calc;
                }
            }
            return SheetFormatCollection.Default;
        };
        P2Sp1Sp1GroupSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            return this.StandardCalc(sheetId, row, column, this.SheetInfo);
        };
        P2Sp1Sp1GroupSheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            return this.StandardFormat(sheetId, row, column, this.SheetInfo);
        };
        P2Sp1Sp1GroupSheet._totalRowInfo = {
            IsCalculated: false,
            Name: "\u0412\u0441\u0435\u0433\u043E",
            Format: SheetFormatCollection.Default
        };
        P2Sp1Sp1GroupSheet._totalCustomerRowInfo = {
            IsCalculated: false,
            Name: "\u0418\u0442\u043E\u0433\u043E \u043F\u043E \u0437\u0430\u0441\u0442\u0440\u043E\u0439\u0449\u0438\u043A\u0443 / \u0437\u0430\u043A\u0430\u0437\u0447\u0438\u043A\u0443",
            Format: SheetFormatCollection.Default
        };
        P2Sp1Sp1GroupSheet._relatedColAllConst = {
            Cell: { Type: SheetCellTypes.Related },
            SubTotalRow: P2Sp1Sp1GroupSheet._totalCustomerRowInfo,
            TotalRow: P2Sp1Sp1GroupSheet._totalRowInfo
        };
        P2Sp1Sp1GroupSheet._codeInfo = {
            Column: 2,
            Length: 4,
            LevelIncs: [100, 1],
            CalcTotalCode: function () {
                return 9000;
            }
        };
        P2Sp1Sp1GroupSheet._sheetInfo = {
            MaxLevel: 2,
            CodeInfo: P2Sp1Sp1GroupSheet._codeInfo,
            ColumnsInfo: [
                SheetColumnInfoCollection.RelatedColDefaultTotal,
                P2Sp1Sp1GroupSheet._relatedColAllConst,
                SheetColumnInfoCollection.AllDefault,
                SheetColumnInfoCollection.RelatedColAllX,
                SheetColumnInfoCollection.RelatedColAllX,
                SheetColumnInfoCollection.RelatedColAllCalc,
                SheetColumnInfoCollection.RelatedColAllCalc,
                SheetColumnInfoCollection.RelatedColAllCalc,
                SheetColumnInfoCollection.RelatedColAllCalc
            ]
        };
        return P2Sp1Sp1GroupSheet;
    }(YearGroupSheet));
    F04120.P2Sp1Sp1GroupSheet = P2Sp1Sp1GroupSheet;
    var P2SpxSp1GroupSheet = (function (_super) {
        __extends(P2SpxSp1GroupSheet, _super);
        function P2SpxSp1GroupSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P2SpxSp1GroupSheet.prototype.StandardCalcStrCode = function (param, row, column, info) {
            var sheet = this.GetSheetFromParam(param);
            var curLvl = sheet.GetRowLevel(row) - 1;
            var lvlInc = curLvl > 0 ? info.LevelIncs[curLvl - 1] : 0;
            var prevLvl = -1;
            var prevCode = 0;
            var curCode;
            if (row > 0) {
                prevLvl = sheet.GetRowLevel(row - 1) - 1;
                prevCode = parseInt(sheet.GetCellValue(row - 1, column), 10);
            }
            if (prevLvl === curLvl && curLvl === this.SheetInfo.MaxLevel) {
                curCode = prevCode + lvlInc;
            }
            else if (curLvl === 0) {
                curCode = info.CalcTotalCode(sheet, row, column);
            }
            else {
                curCode = lvlInc;
            }
            return ObasHelper.FillWithCharacter(curCode.toString(), info.Length);
        };
        P2SpxSp1GroupSheet.prototype.StandardCalc = function (param, row, column, info) {
            var sheet = this.GetSheetFromParam(param);
            var curLvl = sheet.GetRowLevel(row) - 1;
            if (column === info.CodeInfo.Column) {
                if (curLvl === info.MaxLevel) {
                    var prevInvestKey = sheet.GetCellValue(row - 1, sheet.ColumnCount, false) || 0;
                    var curInvestKey = sheet.GetCellValue(row, sheet.ColumnCount, false) || 0;
                    var prevCode = (row > 0) ? parseInt(sheet.GetCellValue(row - 1, info.CodeInfo.Column)) : 0;
                    if ((curInvestKey > 0 || prevInvestKey > 0) && curInvestKey === prevInvestKey && prevCode > 0 && prevCode !== info.CodeInfo.LevelIncs[curLvl - 2]) {
                        return sheet.GetCellValue(row - 1, info.CodeInfo.Column);
                    }
                }
                return this.StandardCalcStrCode(sheet, row, column, info.CodeInfo);
            }
            else {
                var columnInfo = info.ColumnsInfo[column];
                if (curLvl === 0) {
                    var rowInfo = columnInfo.TotalRow;
                    if (rowInfo.IsCalculated) {
                        var result = new SheetCalcResult(BaseFormulas.SUM);
                        for (var i = 0; i < sheet.RowCount; i++) {
                            var code = parseInt(sheet.GetCellValue(i, info.CodeInfo.Column));
                            if (code === info.CodeInfo.LevelIncs[curLvl]) {
                                result.AddCoordinates(new CellCoordinate(i, column));
                            }
                        }
                        return result.ToArray();
                    }
                }
                else if (curLvl === 1) {
                    var rowInfo = columnInfo.SubTotalRow;
                    if (rowInfo.IsCalculated) {
                        var result = new SheetCalcResult(BaseFormulas.SUM);
                        var code = (row > 0) ? parseInt(sheet.GetCellValue(row - 1, info.CodeInfo.Column)) : 0;
                        var i = row - 1;
                        while (i >= 0 && code > 0 && code !== info.CodeInfo.LevelIncs[curLvl - 1]) {
                            var prevCode = (i > 0) ? parseInt(sheet.GetCellValue(i - 1, info.CodeInfo.Column)) : -1;
                            if (code !== prevCode) {
                                result.AddCoordinates(new CellCoordinate(i, column));
                            }
                            code = prevCode;
                            i--;
                        }
                        return result.ToArray();
                    }
                }
            }
            return _super.prototype.StandardCalc.call(this, param, row, column, info);
        };
        P2SpxSp1GroupSheet.prototype.CanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return this.CanEditEventHandler(sheetId, row, column, fieldId, rowLevel);
        };
        P2SpxSp1GroupSheet._totalRowInfo = {
            IsCalculated: false,
            Name: "\u0412\u0441\u0435\u0433\u043E",
            Format: SheetFormatCollection.Default
        };
        P2SpxSp1GroupSheet._totalObjectRowInfo = {
            IsCalculated: false,
            Name: "\u0418\u0442\u043E\u0433\u043E \u043E\u0431\u044A\u0435\u043A\u0442\u0443",
            Format: SheetFormatCollection.Default
        };
        P2SpxSp1GroupSheet._calcColAllDefault = {
            Cell: { Type: SheetCellTypes.Calc },
            SubTotalRow: SheetRowInfoCollection.CalcOnlyFormatRow,
            TotalRow: SheetRowInfoCollection.Default
        };
        P2SpxSp1GroupSheet._sprColAllDefault = {
            Cell: { Type: SheetCellTypes.Spr },
            SubTotalRow: [SheetRowInfoCollection.Default, SheetRowInfoCollection.Default],
            TotalRow: SheetRowInfoCollection.Default
        };
        P2SpxSp1GroupSheet._freeColAllConst = {
            Cell: { Type: SheetCellTypes.Free },
            SubTotalRow: P2SpxSp1GroupSheet._totalObjectRowInfo,
            TotalRow: P2SpxSp1GroupSheet._totalRowInfo
        };
        return P2SpxSp1GroupSheet;
    }(HierarchyYearGroupSheet));
    F04120.P2SpxSp1GroupSheet = P2SpxSp1GroupSheet;
    var P2Sp2Sp1GroupSheet = (function (_super) {
        __extends(P2Sp2Sp1GroupSheet, _super);
        function P2Sp2Sp1GroupSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(P2Sp2Sp1GroupSheet.prototype, "SheetInfo", {
            get: function () {
                return P2Sp2Sp1GroupSheet._sheetInfo;
            },
            enumerable: true,
            configurable: true
        });
        P2Sp2Sp1GroupSheet.prototype.CanEditEventHandler = function (sheetId, row, column, fieldId, levelRow) {
            var sheet = this._document.Sheets.getValue(sheetId);
            var code = parseInt(sheet.GetCellValue(row, this.SheetInfo.CodeInfo.Column));
            if (code !== 900) {
                var table = this._document.Sheets.getValue(sheetId).Table;
                if (column > 11 && column <= 36) {
                    return table.GetKeyBySourceTable(this._document.P2Sp2InvestInfoTable) != null;
                }
                else if (column > 36) {
                    return table.GetKeyBySourceTable(this._document.P2Sp2PowerInfoTable) != null;
                }
            }
        };
        P2Sp2Sp1GroupSheet._codeInfo = {
            Column: 15,
            Length: 3,
            LevelIncs: [800, 1],
            CalcTotalCode: function () {
                return 900;
            }
        };
        P2Sp2Sp1GroupSheet._sheetInfo = {
            MaxLevel: 2,
            CodeInfo: P2Sp2Sp1GroupSheet._codeInfo,
            ColumnsInfo: [
                SheetColumnInfoCollection.SprColDefaultTotal,
                SheetColumnInfoCollection.SprColDefaultTotal,
                SheetColumnInfoCollection.SprColDefaultTotal,
                SheetColumnInfoCollection.SprColDefaultTotal,
                SheetColumnInfoCollection.SprColDefaultTotal,
                SheetColumnInfoCollection.SprColDefaultTotal,
                SheetColumnInfoCollection.FreeColDefaultTotal,
                SheetColumnInfoCollection.FreeColDefaultTotal,
                SheetColumnInfoCollection.FreeColDefaultTotal,
                SheetColumnInfoCollection.FreeColDefaultTotal,
                SheetColumnInfoCollection.FreeColDefaultTotal,
                P2SpxSp1GroupSheet._calcColAllDefault,
                P2SpxSp1GroupSheet._sprColAllDefault,
                P2SpxSp1GroupSheet._sprColAllDefault,
                P2SpxSp1GroupSheet._freeColAllConst,
                SheetColumnInfoCollection.AllDefault,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllX,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllX,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllX,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllX,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.SprColAllX,
                SheetColumnInfoCollection.SprColAllX,
                SheetColumnInfoCollection.FreeColAllX,
                SheetColumnInfoCollection.FreeColAllX
            ]
        };
        return P2Sp2Sp1GroupSheet;
    }(P2SpxSp1GroupSheet));
    F04120.P2Sp2Sp1GroupSheet = P2Sp2Sp1GroupSheet;
    var P2SpxSp1Sheet = (function (_super) {
        __extends(P2SpxSp1Sheet, _super);
        function P2SpxSp1Sheet(id, _document) {
            var _this = _super.call(this, id) || this;
            _this._document = _document;
            _this._totalRowCode = "900";
            _this._totalRowName = "\u0412\u0441\u0435\u0433\u043E";
            return _this;
        }
        P2SpxSp1Sheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (BaseObasTableFields.StrCodeField.Equal(fieldId)) {
                if (this._document.CommonRules.IsFooterRow(sheetId, row)) {
                    return this._totalRowCode;
                }
                else {
                    var sheet = this._document.Sheets.getValue(sheetId);
                    var prevInvestKey = sheet.GetCellValue(row - 1, sheet.ColumnCount, false) || 0;
                    var curInvestKey = sheet.GetCellValue(row, sheet.ColumnCount, false) || 0;
                    var prevCode = (row > 0) ? parseInt(sheet.GetCellValue(row - 1, column)) : 0;
                    if ((curInvestKey > 0 || prevInvestKey > 0) && curInvestKey === prevInvestKey && prevCode > 0) {
                        return sheet.GetCellValue(row - 1, column);
                    }
                    else {
                        return ObasHelper.FillWithCharacter(prevCode + 1, 3);
                    }
                }
            }
            if (this._document.CommonRules.IsFooterRow(sheetId, row)) {
                if (column === this.GetStrCodeColumn() - 1) {
                    return this._totalRowName;
                }
                else if (this.IsCalculatedColumn(column)) {
                    var sheet = this._document.Sheets.getValue(sheetId);
                    var result = new SheetCalcResult(BaseFormulas.SUM);
                    var code = (row > 0) ? parseInt(sheet.GetCellValue(row - 1, this.GetStrCodeColumn())) : 0;
                    var i = row - 1;
                    while (i >= 0 && code > 0) {
                        var prevCode = (i > 0) ? parseInt(sheet.GetCellValue(i - 1, this.GetStrCodeColumn())) : -1;
                        if (code !== prevCode) {
                            result.AddCoordinates(new CellCoordinate(i, column));
                        }
                        code = prevCode;
                        i--;
                    }
                    return result.ToArray();
                }
                else if (column > this.GetStrCodeColumn() && !this.IsCalculatedColumn(column)) {
                    return ObasHelper.X;
                }
            }
            return undefined;
        };
        return P2SpxSp1Sheet;
    }(Sheet));
    F04120.P2SpxSp1Sheet = P2SpxSp1Sheet;
    var P2Sp3Sp1Sheet = (function (_super) {
        __extends(P2Sp3Sp1Sheet, _super);
        function P2Sp3Sp1Sheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P2Sp3Sp1Sheet.prototype.GetStrCodeColumn = function () {
            return 15;
        };
        P2Sp3Sp1Sheet.prototype.IsCalculatedColumn = function (column) {
            return column > 15 && column < 36 && !([17, 22, 27, 32].indexOf(column) != -1);
        };
        P2Sp3Sp1Sheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (this._document.CommonRules.IsFooterRow(sheetId, row)) {
                if (this.IsCalculatedColumn(column)) {
                    return SheetFormatCollection.Calc;
                }
                else {
                    return SheetFormatCollection.Default;
                }
            }
            else {
                switch (column) {
                    case 0:
                    case 1:
                    case 2:
                    case 3:
                    case 4:
                    case 5:
                    case 12:
                    case 13:
                    case 36:
                    case 37:
                        return SheetFormatCollection.Spr;
                    case 15:
                        return SheetFormatCollection.Default;
                    case 11:
                    case 20:
                    case 25:
                    case 30:
                    case 35:
                        return SheetFormatCollection.Calc;
                    default:
                        return SheetFormatCollection.Free;
                }
            }
        };
        P2Sp3Sp1Sheet.prototype.CanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            if (this._document.CommonRules.IsFooterRow(sheetId, row)) {
                return true;
            }
            else {
                return column < 12 || column > 35;
            }
        };
        P2Sp3Sp1Sheet.prototype.CanEditEventHandler = function (sheetId, row, column, fieldId, levelRow) {
            if (!this._document.CommonRules.IsFooterRow(sheetId, row)) {
                var table = this._document.Sheets.getValue(sheetId).Table;
                if (column < 12) {
                    return table.GetKeyBySourceTable(this._document.P2Sp3ObjectInfoTable) != null;
                }
                else if (column >= 12 && column <= 35) {
                    return table.GetKeyBySourceTable(this._document.P2Sp3InvestInfoTable) != null;
                }
                else if (column > 35) {
                    return table.GetKeyBySourceTable(this._document.P2Sp3PowerInfoTable) != null;
                }
            }
        };
        P2Sp3Sp1Sheet.prototype.CanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            if (!this._document.CommonRules.IsFooterRow(sheetId, row)) {
                if (column >= 12 && column <= 35) {
                    return false;
                }
                else {
                    return this.CanEditEventHandler(sheetId, row, column, fieldId, rowLevel);
                }
            }
        };
        return P2Sp3Sp1Sheet;
    }(P2SpxSp1Sheet));
    F04120.P2Sp3Sp1Sheet = P2Sp3Sp1Sheet;
    var AnalyticSheet = (function (_super) {
        __extends(AnalyticSheet, _super);
        function AnalyticSheet(id, _document) {
            var _this = _super.call(this, id, false) || this;
            _this._document = _document;
            return _this;
        }
        AnalyticSheet.prototype.IsTotalRow = function (row) {
            return (AnalyticSheet._totalRow.indexOf(row) != -1);
        };
        AnalyticSheet.prototype.IsEditableRow = function (row) {
            return !this.IsTotalRow(row);
        };
        AnalyticSheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (column > AnalyticSheet._strCodeColumn) {
                if (this.IsTotalRow(row)) {
                    return SheetFormatCollection.Calc;
                }
                else if (this.IsEditableRow(row)) {
                    return SheetFormatCollection.Free;
                }
                else {
                    return SheetFormatCollection.Related;
                }
            }
            else {
                return SheetFormatCollection.Default;
            }
        };
        AnalyticSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (column > AnalyticSheet._strCodeColumn) {
                if (this.IsTotalRow(row)) {
                    var result = new SheetCalcResult(BaseFormulas.SUM);
                    if (row === 0) {
                        for (var i = row + 1; i < this.RowCount; i++) {
                            if (!this.IsTotalRow(i)) {
                                result.AddCoordinates(new CellCoordinate(i, column));
                            }
                        }
                    }
                    else if (row === 14) {
                        for (var i = row + 1; i < this.RowCount - 1; i++) {
                            if (!this.IsTotalRow(i)) {
                                result.AddCoordinates(new CellCoordinate(i, column));
                            }
                        }
                    }
                    else {
                        var i = row + 1;
                        while (!this.IsTotalRow(i) && i < this.RowCount) {
                            result.AddCoordinates(new CellCoordinate(i, column));
                            i++;
                        }
                    }
                    return result.ToArray();
                }
            }
            return undefined;
        };
        AnalyticSheet.prototype.CanEditCellEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return ((column > AnalyticSheet._strCodeColumn) && this.IsEditableRow(row));
        };
        AnalyticSheet._strCodeColumn = 1;
        AnalyticSheet._totalRow = [0, 1, 8, 14];
        return AnalyticSheet;
    }(Sheet));
    F04120.AnalyticSheet = AnalyticSheet;
})(F04120 || (F04120 = {}));
