var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F06100;
(function (F06100) {
    var InterfaceRules = (function (_super) {
        __extends(InterfaceRules, _super);
        function InterfaceRules() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        InterfaceRules.prototype.SheetP2Sp4FormatEventHandler = function (sheetId, row, column, groupIndex) {
            return SheetFormatCollection.Free;
        };
        InterfaceRules.prototype.NpaSheetFormatEventHandler = function (sheetId, row, column, groupIndex) {
            if ((column === 0) || (column === 4)) {
                return SheetFormatCollection.Spr;
            }
            else {
                return SheetFormatCollection.Free;
            }
        };
        InterfaceRules.prototype.FilterNPAStatuses = function () {
            var npaStatusesTable = ObasTableCollection.NpaStatusesSprTable;
            return npaStatusesTable.RecordKey.Value === 1 || npaStatusesTable.RecordKey.Value === 2;
        };
        return InterfaceRules;
    }(BaseInterfaceRules));
    InterfaceRules.StrCodeLength = 6;
    F06100.InterfaceRules = InterfaceRules;
    var P1Sheet = (function (_super) {
        __extends(P1Sheet, _super);
        function P1Sheet(id, _document) {
            var _this = _super.call(this, id, false) || this;
            _this._document = _document;
            return _this;
        }
        P1Sheet.prototype.IsFooterRow = function (row) {
            return this._document.CommonRules.IsFooterRow(this, row, P1Sheet._totalRowCount);
        };
        P1Sheet.prototype.IsFooterRelRow = function (row) {
            var relRow = this.GetRelRow(row);
            return relRow === P1Sheet._relRowCount - 1;
        };
        P1Sheet.prototype.GetRelRow = function (row) {
            return row % P1Sheet._relRowCount;
        };
        P1Sheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (this.IsFooterRow(row)) {
                if (column > P1Sheet._strCodeColumn) {
                    if (row === this.RowCount - 2) {
                        return SheetFormatCollection.Related;
                    }
                    else {
                        return SheetFormatCollection.Calc;
                    }
                }
                else {
                    return SheetFormatCollection.Default;
                }
            }
            else {
                switch (column) {
                    case 0:
                        return SheetFormatCollection.Related;
                    case 1:
                    case 2:
                        return SheetFormatCollection.Default;
                    default:
                        if (this.IsFooterRelRow(row)) {
                            return SheetFormatCollection.Calc;
                        }
                        else {
                            return SheetFormatCollection.Related;
                        }
                }
            }
        };
        P1Sheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (!this.IsFooterRow(row)) {
                if (column > P1Sheet._strCodeColumn) {
                    if (this.IsFooterRelRow(row)) {
                        var result = new SheetCalcResult(BaseFormulas.SUM);
                        for (var i = 1; i < P1Sheet._relRowCount; i++) {
                            result.AddCoordinates(new CellCoordinate(row - i, column));
                        }
                        return result.ToArray();
                    }
                }
            }
            return undefined;
        };
        P1Sheet._relRowCount = 6;
        P1Sheet._totalRowCount = 7;
        P1Sheet._strCodeColumn = 2;
        return P1Sheet;
    }(Sheet));
    F06100.P1Sheet = P1Sheet;
    var GroupSheet = (function (_super) {
        __extends(GroupSheet, _super);
        function GroupSheet(document) {
            return _super.call(this, document) || this;
        }
        GroupSheet.prototype.CalcStrCode = function (row) {
            return ObasHelper.FillWithCharacter(row + 1, InterfaceRules.StrCodeLength);
        };
        GroupSheet.prototype.IsFooterRow = function (sheetId, row) {
            return this.Document.CommonRules.IsFooterRow(sheetId, row);
        };
        GroupSheet.prototype.GetSheet = function (sheetId) {
            return this.Document.Sheets.getValue(sheetId);
        };
        GroupSheet.prototype.GetColumnCount = function (sheetId) {
            return this.GetSheet(sheetId).ColumnCount;
        };
        GroupSheet.prototype.IsLastColumn = function (sheetId, column) {
            return column === this.GetColumnCount(sheetId) - 1;
        };
        GroupSheet._totalRowName = "\u0418\u0442\u043E\u0433\u043E";
        GroupSheet._totalRowCode = "900000";
        return GroupSheet;
    }(YearGroupSheet));
    F06100.GroupSheet = GroupSheet;
    var P2SpxGroupSheet = (function (_super) {
        __extends(P2SpxGroupSheet, _super);
        function P2SpxGroupSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(P2SpxGroupSheet.prototype, "StrCodeColumn", {
            get: function () {
                return P2SpxGroupSheet._strCodeColumn;
            },
            enumerable: true,
            configurable: true
        });
        P2SpxGroupSheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (this.IsFooterRow(sheetId, row)) {
                if (column <= this.StrCodeColumn) {
                    return SheetFormatCollection.Default;
                }
                else {
                    return SheetFormatCollection.Calc;
                }
            }
            else {
                switch (column) {
                    case P2SpxGroupSheet._volumeValColumn:
                        return SheetFormatCollection.Free;
                    case P2SpxGroupSheet._volumeValColumn + 1:
                        return SheetFormatCollection.Calc;
                    case this.StrCodeColumn:
                        return SheetFormatCollection.Default;
                    default:
                        if (column < P2SpxGroupSheet._volumeValColumn) {
                            return SheetFormatCollection.Spr;
                        }
                        else if (this.IsCalcColumn(sheetId, column)) {
                            return SheetFormatCollection.Calc;
                        }
                        else {
                            return SheetFormatCollection.Free;
                        }
                }
            }
        };
        P2SpxGroupSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (this.IsFooterRow(sheetId, row)) {
                if (column === this.StrCodeColumn) {
                    return GroupSheet._totalRowCode;
                }
                else if (column === this.StrCodeColumn - 1) {
                    return GroupSheet._totalRowName;
                }
                else if (column > this.StrCodeColumn) {
                    return this.Document.CommonRules.GetFooterSum(sheetId, row, column);
                }
            }
            else {
                if (column === this.StrCodeColumn) {
                    return this.CalcStrCode(row);
                }
            }
            return undefined;
        };
        P2SpxGroupSheet.prototype.CanEditCellEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return column !== 3 && this.Document.CommonRules.CantEditPrevCurYearsEditingCellEventHandler(sheetId, row, column, fieldId, rowLevel);
        };
        P2SpxGroupSheet._volumeValColumn = 6;
        P2SpxGroupSheet._strCodeColumn = 9;
        return P2SpxGroupSheet;
    }(GroupSheet));
    F06100.P2SpxGroupSheet = P2SpxGroupSheet;
    var P2Sp1GroupSheet = (function (_super) {
        __extends(P2Sp1GroupSheet, _super);
        function P2Sp1GroupSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P2Sp1GroupSheet.prototype.IsCalcColumn = function (sheetId, column) {
            return column === this.StrCodeColumn + 1 ||
                column === this.StrCodeColumn + 2 ||
                column === this.StrCodeColumn + 20;
        };
        return P2Sp1GroupSheet;
    }(P2SpxGroupSheet));
    F06100.P2Sp1GroupSheet = P2Sp1GroupSheet;
    var P2Sp2GroupSheet = (function (_super) {
        __extends(P2Sp2GroupSheet, _super);
        function P2Sp2GroupSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P2Sp2GroupSheet.prototype.IsCalcColumn = function (sheetId, column) {
            return column === this.StrCodeColumn + 1 ||
                column === this.StrCodeColumn + 2 ||
                column === this.StrCodeColumn + 18;
        };
        return P2Sp2GroupSheet;
    }(P2SpxGroupSheet));
    F06100.P2Sp2GroupSheet = P2Sp2GroupSheet;
    var P2Sp3Sp1Sheet = (function (_super) {
        __extends(P2Sp3Sp1Sheet, _super);
        function P2Sp3Sp1Sheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(P2Sp3Sp1Sheet.prototype, "StrCodeColumn", {
            get: function () {
                return P2Sp3Sp1Sheet._strCodeColumn;
            },
            enumerable: true,
            configurable: true
        });
        P2Sp3Sp1Sheet.prototype.IsCalcColumn = function (sheetId, column) {
            return column > 4;
        };
        P2Sp3Sp1Sheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (this.IsFooterRow(sheetId, row)) {
                if (column <= this.StrCodeColumn) {
                    return SheetFormatCollection.Default;
                }
                else {
                    return SheetFormatCollection.Calc;
                }
            }
            else {
                switch (column) {
                    case this.StrCodeColumn - 1:
                        return SheetFormatCollection.Related;
                    case this.StrCodeColumn:
                        return SheetFormatCollection.Default;
                    default:
                        if (this.IsCalcColumn(sheetId, column)) {
                            return SheetFormatCollection.Calc;
                        }
                        else {
                            return SheetFormatCollection.Free;
                        }
                }
            }
        };
        P2Sp3Sp1Sheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (this.IsFooterRow(sheetId, row)) {
                if (column === this.StrCodeColumn) {
                    return GroupSheet._totalRowCode;
                }
                else if (column === this.StrCodeColumn - 1) {
                    return GroupSheet._totalRowName;
                }
                else if (this.IsCalcColumn(sheetId, column)) {
                    return ObasHelper.X;
                }
                else if (column > this.StrCodeColumn) {
                    return this.Document.CommonRules.GetFooterSum(sheetId, row, column);
                }
            }
            else {
                if (column === this.StrCodeColumn) {
                    return this.CalcStrCode(row);
                }
            }
            return undefined;
        };
        P2Sp3Sp1Sheet.prototype.CanEditCellEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return column > this.StrCodeColumn && !this.IsCalcColumn(sheetId, column);
        };
        P2Sp3Sp1Sheet._strCodeColumn = 1;
        return P2Sp3Sp1Sheet;
    }(GroupSheet));
    F06100.P2Sp3Sp1Sheet = P2Sp3Sp1Sheet;
    var P2Sp3Sp2Sheet = (function (_super) {
        __extends(P2Sp3Sp2Sheet, _super);
        function P2Sp3Sp2Sheet(id, _document) {
            var _this = _super.call(this, id, false) || this;
            _this._document = _document;
            return _this;
        }
        P2Sp3Sp2Sheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 0:
                    return SheetFormatCollection.Related;
                case 1:
                    return SheetFormatCollection.Default;
                default:
                    if (column > 7) {
                        return SheetFormatCollection.Calc;
                    }
                    else {
                        return SheetFormatCollection.Free;
                    }
            }
        };
        P2Sp3Sp2Sheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (BaseObasTableFields.StrCodeField.Equal(fieldId)) {
                return ObasHelper.FillWithCharacter(row + 1, InterfaceRules.StrCodeLength);
            }
            return undefined;
        };
        P2Sp3Sp2Sheet.prototype.GetCoefYearsCaptionEventHandler = function (tableId, index, defaultCaption, fieldCaption) {
            return "\u043D\u0430 " + (ObasStageSettings.CurrentYear + index) + " \u0433\u043E\u0434\n(\u0433\u0440. " + (3 + index) + " / (\u0433\u0440. " + (3 + index) + " + \u0433\u0440. " + (6 + index) + "))";
        };
        return P2Sp3Sp2Sheet;
    }(Sheet));
    F06100.P2Sp3Sp2Sheet = P2Sp3Sp2Sheet;
    var P2CorrectionSheet = (function (_super) {
        __extends(P2CorrectionSheet, _super);
        function P2CorrectionSheet(id, _document) {
            var _this = _super.call(this, id, false) || this;
            _this._document = _document;
            return _this;
        }
        Object.defineProperty(P2CorrectionSheet.prototype, "StrCodeColumn", {
            get: function () {
                return P2CorrectionSheet._strCodeColumn;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(P2CorrectionSheet.prototype, "abstract", {
            get: function () { },
            enumerable: true,
            configurable: true
        });
        P2CorrectionSheet.prototype.IsFooterRow = function (row) {
            return this._document.CommonRules.IsFooterRow(this, row, this.GetRelRowCount);
        };
        P2CorrectionSheet.prototype.GetRelRow = function (row) {
            return row % this.GetRelRowCount;
        };
        P2CorrectionSheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (this.IsFooterRow(row)) {
                if (column > this.StrCodeColumn) {
                    return SheetFormatCollection.Calc;
                }
                else {
                    return SheetFormatCollection.Default;
                }
            }
            else {
                switch (column) {
                    case 0:
                        return SheetFormatCollection.Related;
                    case 1:
                    case 2:
                        return SheetFormatCollection.Default;
                    default:
                        var relRow = this.GetRelRow(row);
                        if (this.IsAgrRow(relRow)) {
                            return SheetFormatCollection.Calc;
                        }
                        else {
                            return SheetFormatCollection.Free;
                        }
                }
            }
        };
        P2CorrectionSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (this.IsFooterRow(row)) {
                if (column > this.StrCodeColumn) {
                    return this._document.CommonRules.GetFooterSum(this, row, column, {
                        EndRow: this.RowCount - this.GetRelRowCount,
                        StartRow: this.GetRelRow(row),
                        Step: this.GetRelRowCount
                    });
                }
            }
            return undefined;
        };
        P2CorrectionSheet.prototype.EditingCellEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            var relRow = this.GetRelRow(row);
            return (!this.IsFooterRow(row) && !this.IsAgrRow(relRow));
        };
        P2CorrectionSheet._strCodeColumn = 2;
        return P2CorrectionSheet;
    }(Sheet));
    F06100.P2CorrectionSheet = P2CorrectionSheet;
    var P2Sp5Sheet = (function (_super) {
        __extends(P2Sp5Sheet, _super);
        function P2Sp5Sheet(id, _document) {
            var _this = _super.call(this, id, false) || this;
            _this._document = _document;
            _this._agrRows = [0, 1];
            return _this;
        }
        Object.defineProperty(P2Sp5Sheet.prototype, "GetRelRowCount", {
            get: function () {
                return P2Sp5Sheet._relRowCount;
            },
            enumerable: true,
            configurable: true
        });
        P2Sp5Sheet.prototype.IsAgrRow = function (row) {
            return this._agrRows.indexOf(row) !== -1;
        };
        P2Sp5Sheet._relRowCount = 19;
        return P2Sp5Sheet;
    }(P2CorrectionSheet));
    F06100.P2Sp5Sheet = P2Sp5Sheet;
    var P2Sp6Sheet = (function (_super) {
        __extends(P2Sp6Sheet, _super);
        function P2Sp6Sheet(id, _document) {
            var _this = _super.call(this, id, false) || this;
            _this._document = _document;
            _this._agrRows = [0];
            return _this;
        }
        Object.defineProperty(P2Sp6Sheet.prototype, "GetRelRowCount", {
            get: function () {
                return P2Sp6Sheet._relRowCount;
            },
            enumerable: true,
            configurable: true
        });
        P2Sp6Sheet.prototype.IsAgrRow = function (row) {
            return this._agrRows.indexOf(row) !== -1;
        };
        P2Sp6Sheet._relRowCount = 4;
        return P2Sp6Sheet;
    }(P2CorrectionSheet));
    F06100.P2Sp6Sheet = P2Sp6Sheet;
})(F06100 || (F06100 = {}));
