var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F06100;
(function (F06100) {
    var TableRules = (function () {
        function TableRules(_document) {
            this._document = _document;
        }
        return TableRules;
    }());
    F06100.TableRules = TableRules;
    var P1StrKeys;
    (function (P1StrKeys) {
        P1StrKeys[P1StrKeys["Total"] = 1] = "Total";
        P1StrKeys[P1StrKeys["Service"] = 2] = "Service";
        P1StrKeys[P1StrKeys["Work"] = 3] = "Work";
        P1StrKeys[P1StrKeys["Tax"] = 4] = "Tax";
        P1StrKeys[P1StrKeys["CorrectionWithCoef"] = 5] = "CorrectionWithCoef";
        P1StrKeys[P1StrKeys["CorrectionWithTerCoef"] = 6] = "CorrectionWithTerCoef";
        P1StrKeys[P1StrKeys["AddObas"] = 7] = "AddObas";
    })(P1StrKeys = F06100.P1StrKeys || (F06100.P1StrKeys = {}));
    var P1TotalTable = (function (_super) {
        __extends(P1TotalTable, _super);
        function P1TotalTable() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P1TotalTable.prototype.GetTotalKey = function () {
            return P1StrKeys.Total;
        };
        P1TotalTable.prototype.SumChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            if (this.StrKey !== P1StrKeys.AddObas) {
                _super.prototype.SumChangeEventHandler.call(this, tableId, oldValue, newValue, fieldId);
            }
        };
        return P1TotalTable;
    }(P1TotalObasTable));
    F06100.P1TotalTable = P1TotalTable;
    var P1Table = (function (_super) {
        __extends(P1Table, _super);
        function P1Table() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return P1Table;
    }(ObasTableP1));
    F06100.P1Table = P1Table;
    var PartServWorkTableKeys = (function (_super) {
        __extends(PartServWorkTableKeys, _super);
        function PartServWorkTableKeys(ServWorkKey, Year) {
            var _this = _super.call(this) || this;
            _this.ServWorkKey = ServWorkKey;
            _this.Year = Year;
            return _this;
        }
        return PartServWorkTableKeys;
    }(ObasTableKeys));
    F06100.PartServWorkTableKeys = PartServWorkTableKeys;
    var PartServWorkTable = (function (_super) {
        __extends(PartServWorkTable, _super);
        function PartServWorkTable(id, document) {
            var _this = _super.call(this, id, ["ServWork_ID", BaseObasTableFields.YearField.Id], document) || this;
            _this._servWorkKey = null;
            _this._year = null;
            return _this;
        }
        Object.defineProperty(PartServWorkTable.prototype, "Year", {
            get: function () {
                if (this._year == null) {
                    this._year = new NumberObasTableField(BaseObasTableFields.YearField.Id, this);
                }
                return this._year;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServWorkTable.prototype, "ServWorkKey", {
            get: function () {
                if (this._servWorkKey == null) {
                    this
                        ._servWorkKey = new ObasSprTableFieldTyped(ObasTableCollection.ServiceWorkSprTable, this);
                }
                return this._servWorkKey;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServWorkTable.prototype, "YearOffset", {
            get: function () {
                return ObasHelper.GetYearOffset(this);
            },
            enumerable: true,
            configurable: true
        });
        PartServWorkTable.prototype.GetKeys = function (servWorkKey, year) {
            if (servWorkKey === void 0) { servWorkKey = this.ServWorkKey.ForeignKey.Value; }
            if (year === void 0) { year = this.Year.Value; }
            if (this._keys == null) {
                this._keys = new PartServWorkTableKeys(servWorkKey, year);
            }
            else {
                this._keys.ServWorkKey = servWorkKey;
                this._keys.Year = year;
            }
            return this._keys;
        };
        PartServWorkTable.prototype.FilterIndicators = function () {
            return ObasTableCollection.ServiceWorkIndicatorsSprTable.IsParent(this.ServWorkKey.ForeignKey.Value);
        };
        return PartServWorkTable;
    }(ObasTableWithKeys));
    F06100.PartServWorkTable = PartServWorkTable;
    var PartServWorkOrgTableKeys = (function (_super) {
        __extends(PartServWorkOrgTableKeys, _super);
        function PartServWorkOrgTableKeys(servWorkKey, year, OrgKey) {
            var _this = _super.call(this, servWorkKey, year) || this;
            _this.OrgKey = OrgKey;
            return _this;
        }
        return PartServWorkOrgTableKeys;
    }(PartServWorkTableKeys));
    F06100.PartServWorkOrgTableKeys = PartServWorkOrgTableKeys;
    var PartOrgTable = (function (_super) {
        __extends(PartOrgTable, _super);
        function PartOrgTable(id, parentTable, _uniqOrgFormTable) {
            var _this = _super.call(this, id, parentTable.KeyFieldIds.concat("Organization_ID"), parentTable.Document, parentTable) || this;
            _this._uniqOrgFormTable = _uniqOrgFormTable;
            _this._org = null;
            _this._orgKey = null;
            _this._year = null;
            _uniqOrgFormTable.AddChildTable(_this);
            return _this;
        }
        Object.defineProperty(PartOrgTable.prototype, "ParentTable", {
            get: function () {
                return this.OwnerKey.SourceTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartOrgTable.prototype, "Org", {
            get: function () {
                if (this._org == null) {
                    this._org = new ObasSprTableField(ObasTableCollection.OrganizationTable, this);
                }
                return this._org;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartOrgTable.prototype, "Year", {
            get: function () {
                return this.ParentTable.Year;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartOrgTable.prototype, "YearOffset", {
            get: function () {
                return this.ParentTable.YearOffset;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartOrgTable.prototype, "ServWorkKey", {
            get: function () {
                return this.ParentTable.ServWorkKey;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartOrgTable.prototype, "UniqOrgKey", {
            get: function () {
                return this._uniqOrgFormTable.GetRecordKey(this._uniqOrgFormTable.GetKeys(this.Org.ForeignKey.Value));
            },
            enumerable: true,
            configurable: true
        });
        PartOrgTable.prototype.OrgChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this._uniqOrgFormTable.AddOrg(newValue);
            this.AfterDeleteEventHandler(tableId, oldValue);
        };
        PartOrgTable.prototype.DeleteEventHandler = function (tableId) {
            this._orgKey = this.Org.ForeignKey.Value;
            this._year = this.Year.NValue;
        };
        PartOrgTable.prototype.AfterDeleteEventHandler = function (tableId, orgKey) {
            if (orgKey === void 0) { orgKey = this._orgKey; }
            this._uniqOrgFormTable.DeleteOrg(orgKey);
        };
        PartOrgTable.prototype.GetKeys = function (servWorkKey, year, orgKey) {
            if (servWorkKey === void 0) { servWorkKey = this.ServWorkKey.ForeignKey.Value; }
            if (year === void 0) { year = this.Year.Value; }
            if (orgKey === void 0) { orgKey = this.Org.ForeignKey.Value; }
            if (this._keys == null) {
                this._keys = new PartServWorkOrgTableKeys(servWorkKey, year, orgKey);
            }
            else {
                this._keys.ServWorkKey = servWorkKey;
                this._keys.Year = year;
                this._keys.OrgKey = orgKey;
            }
            return this._keys;
        };
        PartOrgTable.prototype.GetRecordKey = function (keys, addIfNotExists) {
            if (addIfNotExists === void 0) { addIfNotExists = false; }
            var parentTable = this.ParentTable;
            var ownerKey = parentTable.GetRecordKey(parentTable.GetKeys(keys.ServWorkKey, keys.Year), addIfNotExists);
            return this.Document.CommonRules.GetValueByKeys(this, [this.OwnerKey.Id, this.Org.ForeignKey.Id], [ownerKey, keys.OrgKey], this.RecordKey.Id, addIfNotExists);
        };
        return PartOrgTable;
    }(ObasTableWithKeysParent));
    F06100.PartOrgTable = PartOrgTable;
    var PartServWorkOrgIndicatorsTableKeys = (function (_super) {
        __extends(PartServWorkOrgIndicatorsTableKeys, _super);
        function PartServWorkOrgIndicatorsTableKeys(servWorkKey, year, orgKey, IndicatorKey) {
            var _this = _super.call(this, servWorkKey, year, orgKey) || this;
            _this.IndicatorKey = IndicatorKey;
            return _this;
        }
        return PartServWorkOrgIndicatorsTableKeys;
    }(PartServWorkOrgTableKeys));
    F06100.PartServWorkOrgIndicatorsTableKeys = PartServWorkOrgIndicatorsTableKeys;
    var IndicatorOtField = (function (_super) {
        __extends(IndicatorOtField, _super);
        function IndicatorOtField(_groupIndex, _table) {
            var _this = _super.call(this, EditorProObjectTypes.None, "Ot" + _groupIndex) || this;
            _this._groupIndex = _groupIndex;
            _this._table = _table;
            _this._total = null;
            _this._salary = null;
            _this._payments = null;
            _this._addPayments = null;
            _this._other = null;
            _this._specialSalary = null;
            return _this;
        }
        Object.defineProperty(IndicatorOtField.prototype, "SpecialSalary", {
            get: function () {
                if (this._specialSalary == null) {
                    this._specialSalary = new NumberObasTableField(this.GenFieldId("SpecialSalary"), this._table);
                }
                return this._specialSalary;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(IndicatorOtField.prototype, "Other", {
            get: function () {
                if (this._other == null) {
                    this._other = new NumberObasTableField(this.GenFieldId("Other"), this._table);
                }
                return this._other;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(IndicatorOtField.prototype, "AddPayments", {
            get: function () {
                if (this._addPayments == null) {
                    this._addPayments = new NumberObasTableField(this.GenFieldId("AddPayments"), this._table);
                }
                return this._addPayments;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(IndicatorOtField.prototype, "Payments", {
            get: function () {
                if (this._payments == null) {
                    this._payments = new NumberObasTableField(this.GenFieldId("Payments"), this._table);
                }
                return this._payments;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(IndicatorOtField.prototype, "Salary", {
            get: function () {
                if (this._salary == null) {
                    this._salary = new NumberObasTableField(this.GenFieldId("Salary"), this._table);
                }
                return this._salary;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(IndicatorOtField.prototype, "Total", {
            get: function () {
                if (this._total == null) {
                    this._total = new NumberObasTableField(this.GenFieldId("Total"), this._table);
                }
                return this._total;
            },
            enumerable: true,
            configurable: true
        });
        IndicatorOtField.prototype.GenFieldId = function (fieldPart) {
            return "" + this.Id + IndicatorOtField.Delimiter + fieldPart;
        };
        IndicatorOtField.Delimiter = "_";
        return IndicatorOtField;
    }(BaseObject));
    F06100.IndicatorOtField = IndicatorOtField;
    var PartServiceWorkIndicatorsTable = (function (_super) {
        __extends(PartServiceWorkIndicatorsTable, _super);
        function PartServiceWorkIndicatorsTable(id, parentTable, _sumTable, _sumStrKey) {
            var _this = _super.call(this, id, parentTable.KeyFieldIds.concat("WorkIndex_ID"), parentTable.Document, parentTable) || this;
            _this._sumTable = _sumTable;
            _this._sumStrKey = _sumStrKey;
            _this._indicator = null;
            _this._totalSum = null;
            _this._volume = null;
            _this._totalCost = null;
            _this._averageValue = null;
            _this._ot1 = null;
            _this._mz = null;
            _this._gsm = null;
            _this._fr1 = null;
            _this._inz = null;
            _this._ku = null;
            _this._sni = null;
            _this._socdi = null;
            _this._sr = null;
            _this._fr2 = null;
            _this._us = null;
            _this._tu = null;
            _this._ot2 = null;
            _this._pnz = null;
            _this._isCopied = null;
            _this._copyData = null;
            _this._copyFields = null;
            return _this;
        }
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "CopyFields", {
            get: function () {
                if (this._copyFields == null) {
                    this._copyFields = [
                        this.OwnerKey,
                        this.Indicator.ForeignKey,
                        this.Volume,
                        this.AverageValue,
                        this.Ot1.Salary,
                        this.Ot1.SpecialSalary,
                        this.Ot1.Payments,
                        this.Ot1.AddPayments,
                        this.Ot1.Other,
                        this.Mz,
                        this.Gsm,
                        this.Fr1,
                        this.Inz,
                        this.Ku,
                        this.Sni,
                        this.Socdi,
                        this.Fr2,
                        this.Us,
                        this.Tu,
                        this.Ot2.Salary,
                        this.Ot2.SpecialSalary,
                        this.Ot2.Payments,
                        this.Ot2.AddPayments,
                        this.Ot2.Other,
                        this.Pnz
                    ];
                    this._copyFields = this._copyFields.concat(this.AddCopyFields);
                }
                return this._copyFields;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "CopyFieldsInfo", {
            get: function () {
                if (this._copyData == null) {
                    this._copyData = this.InitCopyFieldsInfo();
                }
                return this.CollectTableRecordData(this._copyData);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "IsCopied", {
            get: function () {
                if (this._isCopied == null) {
                    this._isCopied = new ObasTableField(BaseObasTableFields.CopiedRowFlagField.Id, this, true);
                }
                return this._isCopied;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "Volume", {
            get: function () {
                if (this._volume == null) {
                    this._volume = new NumberObasTableField("g8", this);
                }
                return this._volume;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "TotalSum", {
            get: function () {
                if (this._totalSum == null) {
                    this._totalSum = new NumberObasTableField("TotalSum", this);
                }
                return this._totalSum;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "TotalCost", {
            get: function () {
                if (this._totalCost == null) {
                    this._totalCost = new NumberObasTableField("TotalCost", this);
                }
                return this._totalCost;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "AverageValue", {
            get: function () {
                if (this._averageValue == null) {
                    this._averageValue = new NumberObasTableField("AverageValue", this);
                }
                return this._averageValue;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "Ot1", {
            get: function () {
                if (this._ot1 == null) {
                    this._ot1 = new IndicatorOtField(1, this);
                }
                return this._ot1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "Mz", {
            get: function () {
                if (this._mz == null) {
                    this._mz = new NumberObasTableField("Mz", this);
                }
                return this._mz;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "Gsm", {
            get: function () {
                if (this._gsm == null) {
                    this._gsm = new NumberObasTableField("Gsm", this);
                }
                return this._gsm;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "Fr1", {
            get: function () {
                if (this._fr1 == null) {
                    this._fr1 = new NumberObasTableField("Fr1", this);
                }
                return this._fr1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "Inz", {
            get: function () {
                if (this._inz == null) {
                    this._inz = new NumberObasTableField("Inz", this);
                }
                return this._inz;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "Ku", {
            get: function () {
                if (this._ku == null) {
                    this._ku = new NumberObasTableField("Ku", this);
                }
                return this._ku;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "Sni", {
            get: function () {
                if (this._sni == null) {
                    this._sni = new NumberObasTableField("Sni", this);
                }
                return this._sni;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "Socdi", {
            get: function () {
                if (this._socdi == null) {
                    this._socdi = new NumberObasTableField("Socdi", this);
                }
                return this._socdi;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "Sr", {
            get: function () {
                if (this._sr == null) {
                    this._sr = new NumberObasTableField("Sr", this);
                }
                return this._sr;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "Fr2", {
            get: function () {
                if (this._fr2 == null) {
                    this._fr2 = new NumberObasTableField("Fr2", this);
                }
                return this._fr2;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "Us", {
            get: function () {
                if (this._us == null) {
                    this._us = new NumberObasTableField("Us", this);
                }
                return this._us;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "Tu", {
            get: function () {
                if (this._tu == null) {
                    this._tu = new NumberObasTableField("Tu", this);
                }
                return this._tu;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "Ot2", {
            get: function () {
                if (this._ot2 == null) {
                    this._ot2 = new IndicatorOtField(2, this);
                }
                return this._ot2;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "Pnz", {
            get: function () {
                if (this._pnz == null) {
                    this._pnz = new NumberObasTableField("Pnz", this);
                }
                return this._pnz;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "Indicator", {
            get: function () {
                if (this._indicator == null) {
                    this._indicator = new ObasSprTableFieldTyped(ObasTableCollection.ServiceWorkIndicatorsSprTable, this);
                }
                return this._indicator;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "ParentTable", {
            get: function () {
                return this.OwnerKey.SourceTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "Org", {
            get: function () {
                return this.ParentTable.Org;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "Year", {
            get: function () {
                return this.ParentTable.Year;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "YearOffset", {
            get: function () {
                return this.ParentTable.YearOffset;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "ServWorkKey", {
            get: function () {
                return this.ParentTable.ServWorkKey;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartServiceWorkIndicatorsTable.prototype, "FilterKey", {
            get: function () {
                return this.ServWorkKey.ForeignKey.Value + "_" + this.Org.ForeignKey.Value + "_" + this.Indicator.ForeignKey.Value;
            },
            enumerable: true,
            configurable: true
        });
        PartServiceWorkIndicatorsTable.prototype.GetKeys = function (servWorkKey, year, orgKey, indicatorKey) {
            if (servWorkKey === void 0) { servWorkKey = this.ServWorkKey.ForeignKey.Value; }
            if (year === void 0) { year = this.Year.Value; }
            if (orgKey === void 0) { orgKey = this.Org.ForeignKey.Value; }
            if (indicatorKey === void 0) { indicatorKey = this.Indicator.ForeignKey.Value; }
            if (this._keys == null) {
                this._keys = new PartServWorkOrgIndicatorsTableKeys(servWorkKey, year, orgKey, indicatorKey);
            }
            else {
                this._keys.ServWorkKey = servWorkKey;
                this._keys.Year = year;
                this._keys.OrgKey = orgKey;
                this._keys.IndicatorKey = indicatorKey;
            }
            return this._keys;
        };
        PartServiceWorkIndicatorsTable.prototype.GetFieldProp = function (fieldId) {
            var fieldsParts = fieldId.split(IndicatorOtField.Delimiter);
            var fieldProp = this;
            for (var i = 0, fieldsParts_1 = fieldsParts; i < fieldsParts_1.length; i++) {
                var fieldPropId = fieldsParts_1[i];
                fieldProp = fieldProp["" + fieldPropId];
            }
            return fieldProp;
        };
        PartServiceWorkIndicatorsTable.prototype.OtPartsChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            var otProp = this.GetFieldProp(fieldId.split(IndicatorOtField.Delimiter)[0]);
            otProp.Total.NValue = otProp.Salary.NValue +
                otProp.SpecialSalary.NValue +
                otProp.Payments.NValue +
                otProp.AddPayments.NValue +
                otProp.Other.NValue;
            this.CostPartsChangeEventHandler(tableId, oldValue, newValue, fieldId);
        };
        PartServiceWorkIndicatorsTable.prototype.CostPartsChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this.TotalCost.NValue = this.Ot1.Total.NValue +
                this.Mz.NValue +
                this.Fr1.NValue +
                this.Inz.NValue +
                this.Ku.NValue +
                this.Sni.NValue +
                this.Socdi.NValue +
                this.Sr.NValue +
                this.Fr2.NValue +
                this.Us.NValue +
                this.Tu.NValue +
                this.Ot2.Total.NValue +
                this.Pnz.NValue;
        };
        PartServiceWorkIndicatorsTable.prototype.SumPartsChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this.TotalSum.NValue = this.Volume.NValue * this.TotalCost.NValue;
        };
        PartServiceWorkIndicatorsTable.prototype.SumChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            var yearFieldId = BaseObasTableFields.YearDataField.GenerateId(this.YearOffset + 1);
            this._sumTable.SetSumByKeys(yearFieldId, this._sumTable.GetKeys(this._sumStrKey, this.ParentTable.UniqOrgKey), oldValue, newValue);
        };
        PartServiceWorkIndicatorsTable.prototype.AfterDeleteChildsEventHandler = function (tableId) {
            this.IsCopied.Value = true;
            this.Ot1.Salary.NValue = 0;
            this.Ot1.SpecialSalary.NValue = 0;
            this.Ot1.Payments.NValue = 0;
            this.Ot1.AddPayments.NValue = 0;
            this.Ot1.Other.NValue = 0;
            this.Mz.NValue = 0;
            this.Fr1.NValue = 0;
            this.Inz.NValue = 0;
            this.Ku.NValue = 0;
            this.Sni.NValue = 0;
            this.Socdi.NValue = 0;
            this.Sr.NValue = 0;
            this.Fr2.NValue = 0;
            this.Us.NValue = 0;
            this.Tu.NValue = 0;
            this.Ot2.Salary.NValue = 0;
            this.Ot2.SpecialSalary.NValue = 0;
            this.Ot2.Payments.NValue = 0;
            this.Ot2.AddPayments.NValue = 0;
            this.Ot2.Other.NValue = 0;
            this.Pnz.NValue = 0;
        };
        PartServiceWorkIndicatorsTable.prototype.InnerCopyData = function (recordKey, endYear) {
            if (this.Locate(this.RecordKey.Id, recordKey)) {
                this.IsCopied.Value = true;
                var copyData = this.CopyFieldsInfo;
                var keys = this.GetKeys();
                var parentTable = this.ParentTable;
                for (var year = keys.Year + 1; year <= endYear; year++) {
                    var ownerKey = parentTable.GetRecordKey(parentTable.GetKeys(keys.ServWorkKey, year, keys.OrgKey), true);
                    copyData.getValue(this.OwnerKey.Id).Value = ownerKey;
                    keys.Year = year;
                    this.SetupTableRecordData(copyData, this.RecordKey.LookupByKeys(keys.ToArray()), true);
                }
                this.Locate(this.RecordKey.Id, recordKey);
            }
        };
        PartServiceWorkIndicatorsTable.prototype.CopyData = function (srcYear, destYear) {
            var _this = this;
            var endYear = ObasStageSettings.CurrentYear + ObasStageSettings.YearsCount;
            if (srcYear == null) {
                srcYear = endYear - 2;
            }
            if (destYear == null) {
                destYear = endYear - 1;
            }
            if (srcYear && destYear) {
                var copyHandler = function (table, recordKey) {
                    if (_this.Year.Value === srcYear) {
                        _this.InnerCopyData(recordKey, destYear);
                    }
                };
                this.Iterate(copyHandler);
            }
        };
        PartServiceWorkIndicatorsTable.prototype.EditEventHandler = function (tableId) {
            if (this.Document.NotOnUpdate && !this.IsCopied.Value && this.IsRedyForCopy()) {
                //this.InnerCopyData(this.RecordKey.Value, ObasStageSettings.CurrentYear + ObasStageSettings.YearsCount - 1);
            }
        };
        PartServiceWorkIndicatorsTable.prototype.IsRedyForCopy = function () {
            var _this = this;
            return ObasHelper.CheckIsReadyForCopy(this.CopyFieldsInfo, function (value, index, array) {
                return _this.IsRedyForCopyFilter(value, index, array);
            });
        };
        PartServiceWorkIndicatorsTable.prototype.ResetData = function (keys) {
            var _this = this;
            var resetHandler = function () {
                _this.Ot1.Salary.NValue = 0;
                _this.Ot1.SpecialSalary.NValue = 0;
                _this.Ot1.Payments.NValue = 0;
                _this.Ot1.AddPayments.NValue = 0;
                _this.Ot1.Other.NValue = 0;
                _this.Ot2.Salary.NValue = 0;
                _this.Ot2.SpecialSalary.NValue = 0;
                _this.Ot2.Payments.NValue = 0;
                _this.Ot2.AddPayments.NValue = 0;
                _this.Ot2.Other.NValue = 0;
                _this.Mz.NValue = 0;
                _this.Inz.NValue = 0;
                _this.Ku.NValue = 0;
                _this.Sni.NValue = 0;
                _this.Socdi.NValue = 0;
                _this.Sr.NValue = 0;
                _this.Us.NValue = 0;
                _this.Tu.NValue = 0;
                _this.Pnz.NValue = 0;
                _this.Fr1.NValue = 0;
                _this.Fr2.NValue = 0;
                _this.Volume.NValue = 0;
                _this.Ot1.Total.NValue = 0;
                _this.Ot2.Total.NValue = 0;
                _this.TotalCost.NValue = 0;
                _this.TotalSum.NValue = 0;
            };
            if (keys) {
                if (this.LocateByKeys(keys.ToArray())) {
                    resetHandler();
                }
            }
            else {
                this.Iterate(resetHandler);
            }
        };
        PartServiceWorkIndicatorsTable.prototype.CollectUserData = function () {
            return this.CollectTableData(this.InitCopyFieldsInfo());
        };
        PartServiceWorkIndicatorsTable.prototype.InitCopyFieldsInfo = function () {
            return ObasHelper.CreateInitCopyFieldsInfo(this);
        };
        return PartServiceWorkIndicatorsTable;
    }(ObasTableWithKeysParent));
    F06100.PartServiceWorkIndicatorsTable = PartServiceWorkIndicatorsTable;
    var P2ServiceIndicatorsTable = (function (_super) {
        __extends(P2ServiceIndicatorsTable, _super);
        function P2ServiceIndicatorsTable() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._inz_ku = null;
            _this._inz_sni = null;
            _this._addCopyFields = null;
            return _this;
        }
        Object.defineProperty(P2ServiceIndicatorsTable.prototype, "AddCopyFields", {
            get: function () {
                if (this._addCopyFields == null) {
                    this._addCopyFields = [this.Inz_Ku, this.Inz_Sni];
                }
                return this._addCopyFields;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(P2ServiceIndicatorsTable.prototype, "Inz_Ku", {
            get: function () {
                if (this._inz_ku == null) {
                    this._inz_ku = new NumberObasTableField("Inz_Ku", this);
                }
                return this._inz_ku;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(P2ServiceIndicatorsTable.prototype, "Inz_Sni", {
            get: function () {
                if (this._inz_sni == null) {
                    this._inz_sni = new NumberObasTableField("Inz_Sni", this);
                }
                return this._inz_sni;
            },
            enumerable: true,
            configurable: true
        });
        P2ServiceIndicatorsTable.prototype.IsRedyForCopyFilter = function (value, index, array) {
            return !(value.Id === this.Gsm.Id || value.Id === this.AverageValue.Id || value.Id === this.Inz_Ku.Id || value.Id === this.Inz_Sni.Id);
        };
        return P2ServiceIndicatorsTable;
    }(PartServiceWorkIndicatorsTable));
    F06100.P2ServiceIndicatorsTable = P2ServiceIndicatorsTable;
    var P2WorkIndicatorsTable = (function (_super) {
        __extends(P2WorkIndicatorsTable, _super);
        function P2WorkIndicatorsTable() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._addCopyFields = [];
            return _this;
        }
        Object.defineProperty(P2WorkIndicatorsTable.prototype, "AddCopyFields", {
            get: function () {
                return this._addCopyFields;
            },
            enumerable: true,
            configurable: true
        });
        P2WorkIndicatorsTable.prototype.IsRedyForCopyFilter = function (value, index, array) {
            return !(value.Id === this.Gsm.Id || value.Id === this.AverageValue.Id);
        };
        return P2WorkIndicatorsTable;
    }(PartServiceWorkIndicatorsTable));
    F06100.P2WorkIndicatorsTable = P2WorkIndicatorsTable;
    var P2Sp3Table = (function (_super) {
        __extends(P2Sp3Table, _super);
        function P2Sp3Table(id, parentTable, _sumTable) {
            var _this = _super.call(this, id, parentTable.Document, parentTable) || this;
            _this._sumTable = _sumTable;
            _this._copyFields = null;
            _this._addYearDataField = null;
            _this._revYearDataField = null;
            _this._coefYearDataField = null;
            return _this;
        }
        Object.defineProperty(P2Sp3Table.prototype, "CopyFields", {
            get: function () {
                if (this._copyFields == null) {
                    this._copyFields = [this.OwnerKey];
                    for (var i = 1, yearsCount = this.Document.Settings.YearsCount; i <= yearsCount; i++) {
                        this._copyFields.push(this.AdditionalYearDataField.GenerateTableField(this, i));
                        this._copyFields.push(this.RevenueYearDataField.GenerateTableField(this, i));
                        this._copyFields.push(BaseObasTableFields.YearDataField.GenerateTableField(this));
                    }
                }
                return this._copyFields;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(P2Sp3Table.prototype, "AdditionalYearDataField", {
            get: function () {
                if (this._addYearDataField == null) {
                    this._addYearDataField = new BaseGenericObasTableField("Add_Y");
                }
                return this._addYearDataField;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(P2Sp3Table.prototype, "RevenueYearDataField", {
            get: function () {
                if (this._revYearDataField == null) {
                    this._revYearDataField = new BaseGenericObasTableField("Rev_Y");
                }
                return this._revYearDataField;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(P2Sp3Table.prototype, "CoeficientYearDataField", {
            get: function () {
                if (this._coefYearDataField == null) {
                    this._coefYearDataField = new BaseGenericObasTableField("Coef_Y");
                }
                return this._coefYearDataField;
            },
            enumerable: true,
            configurable: true
        });
        P2Sp3Table.prototype.GetYearByField = function (fieldId) {
            return ObasStageSettings.CurrentYear + ObasHelper.GetYearOffsetById(fieldId);
        };
        P2Sp3Table.prototype.CoefPartsChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            var yearIndex = ObasHelper.GetYearIndexById(fieldId);
            var volume = this.GetFieldValue(this.AdditionalYearDataField.GenerateId(yearIndex)) || 0;
            var revenue = this.GetFieldValue(this.RevenueYearDataField.GenerateId(yearIndex)) || 0;
            var sum = volume + revenue;
            this.SetFieldValue(this.CoeficientYearDataField.GenerateId(yearIndex), sum === 0 ? sum : volume / sum);
        };
        P2Sp3Table.prototype.SumChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this._sumTable.SetSumByKeys(fieldId, this._sumTable.GetKeys(P1StrKeys.Tax, this.OwnerKey.Value), oldValue, newValue);
        };
        P2Sp3Table.prototype.CopyData = function (srcYear, destYear) {
            this.Document.CommonRules.CopyTableData(this, srcYear, destYear, null, this.AdditionalYearDataField, this.RevenueYearDataField, this.CoeficientYearDataField, BaseObasTableFields.YearDataField);
        };
        P2Sp3Table.prototype.ResetData = function () {
            this.Document.CommonRules.ResetTableData(this, [this.AdditionalYearDataField,
                this.RevenueYearDataField,
                this.CoeficientYearDataField,
                BaseObasTableFields.YearDataField]);
        };
        P2Sp3Table.prototype.InitCopyFieldsInfo = function () {
            return ObasHelper.CreateSimpleInitCopyFieldsInfo(this);
        };
        P2Sp3Table.prototype.CollectUserData = function () {
            return this.CollectTableData(this.InitCopyFieldsInfo());
        };
        return P2Sp3Table;
    }(ObasTableWithSimpleKeysParent));
    F06100.P2Sp3Table = P2Sp3Table;
    var P2Sp4Table = (function (_super) {
        __extends(P2Sp4Table, _super);
        function P2Sp4Table(id, _sumTable) {
            var _this = _super.call(this, id) || this;
            _this._sumTable = _sumTable;
            _this._copyFields = null;
            return _this;
        }
        Object.defineProperty(P2Sp4Table.prototype, "CopyFields", {
            get: function () {
                if (this._copyFields == null) {
                    this._copyFields = [];
                    for (var i = 1, yearsCount = this.Document.Settings.YearsCount; i <= yearsCount; i++) {
                        this._copyFields.push(BaseObasTableFields.YearDataField.GenerateTableField(this, i));
                    }
                }
                return this._copyFields;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(P2Sp4Table.prototype, "Document", {
            get: function () {
                return this._sumTable.Document;
            },
            enumerable: true,
            configurable: true
        });
        P2Sp4Table.prototype.SumChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this._sumTable.SetValueByKeys(fieldId, this._sumTable.GetKeys(P1StrKeys.AddObas), newValue);
        };
        P2Sp4Table.prototype.CopyData = function (srcYear, destYear) {
            this.Document.CommonRules.CopyTableData(this, srcYear, destYear, null, BaseObasTableFields.YearDataField);
        };
        P2Sp4Table.prototype.ResetData = function () {
            this.Document.CommonRules.ResetTableData(this, [BaseObasTableFields.YearDataField]);
        };
        P2Sp4Table.prototype.InitCopyFieldsInfo = function () {
            return ObasHelper.CreateSimpleInitCopyFieldsInfo(this);
        };
        P2Sp4Table.prototype.CollectUserData = function () {
            return this.CollectTableData(this.InitCopyFieldsInfo());
        };
        return P2Sp4Table;
    }(ObasTable));
    F06100.P2Sp4Table = P2Sp4Table;

    var AnalyticRowsTable = (function (_super) {
        __extends(AnalyticRowsTable, _super);
        function AnalyticRowsTable(id) {
            return _super.call(this, id, [BaseObasTableFields.RecordKeyField.Id], "StrCode", "StrName") || this;
        }
        return AnalyticRowsTable;
    }(BarsRowsSprTable));
    F06100.AnalyticRowsTable = AnalyticRowsTable;
    var AdjustRows = (function (_super) {
        __extends(AdjustRows, _super);
        function AdjustRows() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._isTotalField = null;
            return _this;
        }
        Object.defineProperty(AdjustRows.prototype, "IsTotalField", {
            get: function () {
                if (this._isTotalField == null) {
                    this._isTotalField = new ObasTableField(BaseObasTableFields.TotalRowFlagField.Id, this);
                }
                return this._isTotalField;
            },
            enumerable: true,
            configurable: true
        });
        AdjustRows.prototype.IsTotalRow = function () {
            return this.IsTotalField.Value;
        };
        AdjustRows.prototype.IsNotTotalRow = function () {
            return !this.IsTotalField.Value;
        };
        return AdjustRows;
    }(AnalyticRowsTable));
    F06100.AdjustRows = AdjustRows;
    var P2CorrectionTable = (function (_super) {
        __extends(P2CorrectionTable, _super);
        function P2CorrectionTable(id, parentTable, _sumTable, _sumStrKey) {
            var _this = _super.call(this, id, parentTable.Document, parentTable, [BaseObasTableFields.StrKeyField.Id, BaseObasTableFields.OwnerKeyField.Id]) || this;
            _this._sumTable = _sumTable;
            _this._sumStrKey = _sumStrKey;
            _this._copyFields = null;
            _this._parentStrKey = null;
            _this._isAgrRow = null;
            _this._isTotalRow = null;
            return _this;
        }
        Object.defineProperty(P2CorrectionTable.prototype, "CopyFields", {
            get: function () {
                if (this._copyFields == null) {
                    this._copyFields = [this.OwnerKey, this.StrKeyField];
                    for (var i = 1, yearsCount = this.Document.Settings.YearsCount; i <= yearsCount; i++) {
                        this._copyFields.push(BaseObasTableFields.YearDataField.GenerateTableField(this, i));
                    }
                }
                return this._copyFields;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(P2CorrectionTable.prototype, "ParentStrKey", {
            get: function () {
                if (this._parentStrKey == null) {
                    this._parentStrKey = new NumberObasTableField("ParentStrKey", this);
                }
                return this._parentStrKey;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(P2CorrectionTable.prototype, "IsAgrRow", {
            get: function () {
                if (this._isAgrRow == null) {
                    this._isAgrRow = new ObasTableField("IsAgr", this);
                }
                return this._isAgrRow;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(P2CorrectionTable.prototype, "IsTotalRow", {
            get: function () {
                if (this._isTotalRow == null) {
                    this._isTotalRow = new ObasTableField("IsTotal", this);
                }
                return this._isTotalRow;
            },
            enumerable: true,
            configurable: true
        });
        P2CorrectionTable.prototype.SumChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            if (!this.IsTotalRow.Value) {
                var parentStrKey = (this.ParentStrKey.Value || -1);
                if (!this.IsAgrRow.Value && parentStrKey !== -1) {
                    this._sumTable.SetSumByKeys(fieldId, this._sumTable.GetKeys(this._sumStrKey, this.OwnerKey.Value), oldValue, newValue);
                }
                if (parentStrKey !== -1) {
                    this._document.CommonRules.SetSumByKeys(this, this.KeyFieldIds, [parentStrKey, this.OwnerKey.Value], fieldId, oldValue, newValue);
                }
            }
        };
        P2CorrectionTable.prototype.AfterDeleteChildsEventHandler = function (tableId) {
            for (var i = 1, yearsCount = this.Document.Settings.YearsCount; i <= yearsCount; i++) {
                this.SetFieldValue(BaseObasTableFields.YearDataField.GenerateId(i), 0);
            }
        };
        P2CorrectionTable.prototype.CopyData = function (srcYear, destYear) {
            this.Document.CommonRules.CopyTableData(this, srcYear, destYear, null, BaseObasTableFields.YearDataField);
        };
        P2CorrectionTable.prototype.ResetData = function () {
            this.Document.CommonRules.ResetTableData(this, [BaseObasTableFields.YearDataField]);
        };
        P2CorrectionTable.prototype.InitCopyFieldsInfo = function () {
            return ObasHelper.CreateSimpleInitCopyFieldsInfo(this);
        };
        P2CorrectionTable.prototype.CollectUserData = function () {
            return this.CollectTableData(this.InitCopyFieldsInfo());
        };
        return P2CorrectionTable;
    }(ObasTableWithStrKeysParent));
    F06100.P2CorrectionTable = P2CorrectionTable;

})(F06100 || (F06100 = {}));
