var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F06200;
(function (F06200) {
    var InterfaceRules = (function (_super) {
        __extends(InterfaceRules, _super);
        function InterfaceRules() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        InterfaceRules.prototype.SheetNpaFormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 0:
                case 1:
                    return SheetFormatCollection.Related;
                case 2:
                    return SheetFormatCollection.Default;
                case 3:
                case 7:
                    return SheetFormatCollection.Spr;
                default:
                    return SheetFormatCollection.Free;
            }
        };
        InterfaceRules.prototype.SheetNpaCalcEventHandler = function (sheetId, row, column, fieldId) {
            if (BaseObasTableFields.StrCodeField.Equal(fieldId)) {
                return ObasHelper.FillWithCharacter(row + 1, InterfaceRules.CodeLength);
            }
            return undefined;
        };
        InterfaceRules.prototype.FilterNPAStatuses = function () {
            var npaStatusesTable = ObasTableCollection.NpaStatusesSprTable;
            return npaStatusesTable.RecordKey.Value === 1 || npaStatusesTable.RecordKey.Value === 2;
        };
        InterfaceRules.TotalRowName = "\u0418\u0442\u043E\u0433\u043E";
        InterfaceRules.TotalRowCode = 900;
        InterfaceRules.CodeLength = 3;
        return InterfaceRules;
    }(BaseInterfaceRules));
    F06200.InterfaceRules = InterfaceRules;
    var P1Sheet = (function (_super) {
        __extends(P1Sheet, _super);
        function P1Sheet(id, _document) {
            var _this = _super.call(this, id, false) || this;
            _this._document = _document;
            return _this;
        }
        P1Sheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (column < 2) {
                return SheetFormatCollection.Default;
            }
            else {
                if (row === 0) {
                    return SheetFormatCollection.Calc;
                }
                else {
                    return SheetFormatCollection.Related;
                }
            }
        };
        return P1Sheet;
    }(Sheet));
    F06200.P1Sheet = P1Sheet;
    var BaseGroupSheet = (function (_super) {
        __extends(BaseGroupSheet, _super);
        function BaseGroupSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        BaseGroupSheet.prototype.IsFooterRow = function (sheetId, row) {
            return this.Document.CommonRules.IsFooterRow(sheetId, row);
        };
        BaseGroupSheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (this.IsFooterRow(sheetId, row)) {
                if (column > this.RowCode) {
                    return SheetFormatCollection.Calc;
                }
                else {
                    return SheetFormatCollection.Default;
                }
            }
            else {
                if (this.IsSprColumn(sheetId, column)) {
                    return SheetFormatCollection.Spr;
                }
                else if (this.IsCalcColumn(sheetId, column)) {
                    return SheetFormatCollection.Calc;
                }
                else if (column === this.RowCode) {
                    return SheetFormatCollection.Default;
                }
                else {
                    return SheetFormatCollection.Free;
                }
            }
            return undefined;
        };
        return BaseGroupSheet;
    }(YearGroupSheet));
    F06200.BaseGroupSheet = BaseGroupSheet;
    var P2Sp1GroupSheet = (function (_super) {
        __extends(P2Sp1GroupSheet, _super);
        function P2Sp1GroupSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(P2Sp1GroupSheet.prototype, "RowCode", {
            get: function () {
                return 3;
            },
            enumerable: true,
            configurable: true
        });
        P2Sp1GroupSheet.prototype.IsSprColumn = function (sheetId, column) {
            var sprColumns = [0, 1];
            return sprColumns.indexOf(column) != -1;
        };
        P2Sp1GroupSheet.prototype.IsCalcColumn = function (sheetId, column) {
            var calcColumns = [6];
            return calcColumns.indexOf(column) != -1;
        };
        P2Sp1GroupSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (this.IsFooterRow(sheetId, row)) {
                if (column === this.RowCode - 1) {
                    return InterfaceRules.TotalRowName;
                }
                else if (column === this.RowCode) {
                    return InterfaceRules.TotalRowCode;
                }
                else if (column > this.RowCode) {
                    if (column === 5) {
                        return ObasHelper.X;
                    }
                    else {
                        return this.Document.CommonRules.GetFooterSum(sheetId, row, column);
                    }
                }
            }
            else {
                if (column === this.RowCode) {
                    return ObasHelper.FillWithCharacter(row + 1, InterfaceRules.CodeLength);
                }
            }
            return undefined;
        };
        return P2Sp1GroupSheet;
    }(BaseGroupSheet));
    F06200.P2Sp1GroupSheet = P2Sp1GroupSheet;
    var PXSp1Sheet = (function (_super) {
        __extends(PXSp1Sheet, _super);
        function PXSp1Sheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(PXSp1Sheet.prototype, "RowCode", {
            get: function () {
                return 3;
            },
            enumerable: true,
            configurable: true
        });
        PXSp1Sheet.prototype.IsSprColumn = function (sheetId, column) {
            var sprColumns = [0, 1, 2];
            return sprColumns.indexOf(column) != -1;
        };
        PXSp1Sheet.prototype.IsCalcColumn = function (sheetId, column) {
            return false;
        };
        PXSp1Sheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (this.IsFooterRow(sheetId, row)) {
                if (column === this.RowCode - 1) {
                    return InterfaceRules.TotalRowName;
                }
                else if (column === this.RowCode) {
                    return InterfaceRules.TotalRowCode;
                }
                else if (column > this.RowCode) {
                    return this.Document.CommonRules.GetFooterSum(sheetId, row, column);
                }
            }
            else {
                if (column === this.RowCode) {
                    return ObasHelper.FillWithCharacter(row + 1, InterfaceRules.CodeLength);
                }
            }
            return undefined;
        };
        return PXSp1Sheet;
    }(BaseGroupSheet));
    F06200.PXSp1Sheet = PXSp1Sheet;
})(F06200 || (F06200 = {}));
