var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F06300;
(function (F06300) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(_document) {
            var _this = _super.call(this, _document) || this;
            _this._document = _document;
            return _this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetP1Data("\u0418\u0422\u041E\u0413\u0418"));
            result.push(this.GetP2Sp1Data("\u0423\u0441\u043B\u0443\u0433\u0438_\u0420\u0430\u0431\u043E\u0442\u044B"));
            result.push(this.GetP3Sp1Data("\u0418\u043D\u044B\u0435_\u0446\u0435\u043B\u0438"));
            result.push(this.GetP2NpaData("\u041D\u041F\u0410_\u0423\u0441\u043B\u0443\u0433\u0438_\u0420\u0430\u0431\u043E\u0442\u044B"));
            result.push(this.GetP3NpaData("\u041D\u041F\u0410_\u0438\u043D\u044B\u0435_\u0446\u0435\u043B\u0438"));
            result.push(this.GetSecretData("\u0413\u043E\u0441\u0442\u0430\u0439\u043D\u0430"));
            var kosguData = this._document.AnalyticsDataTable.CollectKosguData();
            result.push(this.GetAnalyticKosguData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423", kosguData));
            result.push(this.GetRaspredelenieKosguData("\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041F\u043E\u041A\u041E\u0421\u0413\u0423", kosguData));
            return result;
        };
        ExportRules.prototype.GenYearData = function (srcTable, fieldId, startIndex) {
            var result = "";
            for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                result += "b" + (startIndex + j) + "=\"" + (srcTable.GetFieldValue(fieldId + j.toString()) || 0) + "\" ";
            }
            return result;
        };
        ExportRules.prototype.GetP1Data = function (barsTableId) {
            var srcTable = this._document.P1TotalTable;
            var srcData = [];
            var i = 1;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                if (!srcTable.IsTotal) {
                    var template = "<a ID=\"" + ObasHelper.FillWithCharacter(i.toString(), 2) + "\" ";
                    for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                        template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue("Y" + (j + 1).toString()) || 0) + "\" ";
                    }
                    template += "/>";
                    srcData.push(template);
                    i++;
                }
            }
            srcData.push("<a ID=\"100\" b3=\"0\" b4=\"0\" b5=\"0\" />");
            for (var i_1 = 1; i_1 <= ObasStageSettings.YearsCount + 1; i_1++) {
                srcData.push("<c ID=\"SUM_" + i_1 + "\" />");
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2Sp1Data = function (barsTableId) {
            var dataTable = this._document.P2ServiceWorkIndicatorTable;
            var srcTable = this._document.TransTableP2Sp1;
            var servWorkTable = ObasTableCollection.ServiceWorkSprTable;
            var indicatorTable = ObasTableCollection.ServiceWorkIndicatorsSprTable;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                var existsServWorkRow = servWorkTable.Locate(servWorkTable.RecordKey.Id, srcTable.GetFieldValue(dataTable.ServWorkKey.ForeignKey.Id));
                var existsIndicatorRow = indicatorTable.Locate(indicatorTable.RecordKey.Id, srcTable.GetFieldValue(dataTable.Indicator.ForeignKey.Id));
                template += "b2=\"" + (existsServWorkRow ? (servWorkTable.Name.Value || "") : "") + "\" ";
                template += "b3=\"" + (existsServWorkRow ? (servWorkTable.ActivityType || "") : "") + "\" ";
                template += "b5=\"" + (existsIndicatorRow ? (indicatorTable.Unit.Value || "") : "") + "\" ";
                template += this.GenYearData(srcTable, dataTable.Volume.Id, 7);
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.Iz.Id, 11);
                template += this.GenYearData(srcTable, dataTable.TotalSum.Id, 15);
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.OtPayment.Id, 19);
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.OtInsurance.Id, 23);
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.OtOthers.Id, 27);
                template += this.GenYearData(srcTable, dataTable.MzTotal.Id, 31);
                template += this.GenYearData(srcTable, dataTable.MzOthers.Id, 35);
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.Ku.Id, 39);
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.Us.Id, 43);
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.Tu.Id, 47);
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.OtSum.Id, 51);
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.Ot.Id, 55);
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.TotalCost.Id, 59);
                template += "b62=\"True\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "b1_text=\"" + (existsServWorkRow ? (servWorkTable.UniqRegNumber.Value || "") : "") + "\" ";
                template += "b4_text=\"" + (existsIndicatorRow ? (indicatorTable.Name.Value || "") : "") + "\" ";
                template += "b63_text=\"" + (existsServWorkRow ? (servWorkTable.GetFieldValue("Indicators") || "") : "") + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP3Sp1Data = function (barsTableId) {
            var dataTable = this._document.P3SubsidieNameTable;
            var srcTable = this._document.TransTableP3Sp1;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((srcTable.GetFieldValue(dataTable.SubsidieName.Id) || "")) + "\" ";
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.Iz.Id, 3);
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.OtSum.Id, 7);
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.Ot.Id, 11);
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.OtPayment.Id, 15);
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.OtInsurance.Id, 19);
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.OtOthers.Id, 23);
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.Ku.Id, 27);
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.Us.Id, 31);
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.Tu.Id, 35);
                template += this.GenYearData(srcTable, dataTable.Sf.Id, 39);
                template += this.GenYearData(srcTable, dataTable.ValuesHelper.TotalCost.Id, 43);
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2NpaData = function (barsTableId) {
            var srcTable = this._document.P2NpaTable;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b5=\"False\" ";
                template += "b8=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "b9=\"" + (srcTable.SubsidieName.Value || "") + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaFields.NpaName.Value || "") + "\" ";
                template += "b10=\"" + (srcTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "b11=\"" + (ObasHelper.ConvertToString(srcTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b12=\"" + (srcTable.NpaFields.NpaNumber.Value || "") + "\" ";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP3NpaData = function (barsTableId) {
            var srcTable = this._document.P3NpaTable;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + (srcTable.SubsidieName.Value || "") + "\" ";
                template += "b6=\"False\" ";
                template += "b9=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaFields.NpaName.Value || "") + "\" ";
                template += "b10=\"" + (srcTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "b11=\"" + (ObasHelper.ConvertToString(srcTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b12=\"" + (srcTable.NpaFields.NpaNumber.Value || "") + "\" ";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticKosguData = function (id, kosguData) {
            var srcData = [];
            for (var i = 0; i < kosguData.length; i++) {
                var template = "<a ID=\"" + ((kosguData[i].Code === "-") ? "200" : kosguData[i].Code) + "\" ";
                for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                    template += "b" + (3 + j) + "=\"" + (kosguData[i].Data[j] || 0) + "\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetRaspredelenieKosguData = function (id, kosguData) {
            var srcData = [];
            for (var i = 0; i < kosguData.length; i++) {
                var template = "<a ID=\"" + ((kosguData[i].Code === "-") ? "200" : kosguData[i].Code) + "\" b3=\"0\" b4=\"0\" b5=\"0\" b6=\"0\" />";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F06300.ExportRules = ExportRules;
})(F06300 || (F06300 = {}));
