var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F06300;
(function (F06300) {
    var InterfaceRules = (function (_super) {
        __extends(InterfaceRules, _super);
        function InterfaceRules() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        InterfaceRules.prototype.P2NpaSheetFormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 1:
                    return SheetFormatCollection.Default;
                case 2:
                case 6:
                    return SheetFormatCollection.Spr;
                default:
                    return SheetFormatCollection.Free;
            }
        };
        InterfaceRules.prototype.P3NpaSheetFormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 0:
                    return SheetFormatCollection.Related;
                case 1:
                    return SheetFormatCollection.Default;
                case 2:
                case 6:
                    return SheetFormatCollection.Spr;
                default:
                    return SheetFormatCollection.Free;
            }
        };
        InterfaceRules.prototype.NpaSheetCalcEventHandler = function (sheetId, row, column, fieldId) {
            if (column === 1) {
                return ObasHelper.FillWithCharacter((row + 1).toString(), InterfaceRules.CodeLength);
            }
        };
        InterfaceRules.prototype.FilterNPAStatuses = function () {
            var npaStatusesTable = ObasTableCollection.NpaStatusesSprTable;
            return npaStatusesTable.RecordKey.Value === 1 || npaStatusesTable.RecordKey.Value === 2;
        };
        InterfaceRules.TotalRowName = "\u0418\u0442\u043E\u0433\u043E";
        InterfaceRules.TotalRowCode = "900000";
        InterfaceRules.CodeLength = 6;
        return InterfaceRules;
    }(BaseInterfaceRules));
    F06300.InterfaceRules = InterfaceRules;
    var P1Sheet = (function (_super) {
        __extends(P1Sheet, _super);
        function P1Sheet(id, _document) {
            var _this = _super.call(this, id, false) || this;
            _this._document = _document;
            return _this;
        }
        P1Sheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (column < 2) {
                if (this._document.CommonRules.IsFooterRow(this, row)) {
                    return SheetFormatCollection.Default;
                }
            }
            else {
                if (this._document.CommonRules.IsFooterRow(this, row)) {
                    return SheetFormatCollection.Calc;
                }
                else {
                    return SheetFormatCollection.Related;
                }
            }
        };
        return P1Sheet;
    }(Sheet));
    F06300.P1Sheet = P1Sheet;
    var P2Sp1GroupSheet = (function (_super) {
        __extends(P2Sp1GroupSheet, _super);
        function P2Sp1GroupSheet(_document) {
            return _super.call(this, _document) || this;
        }
        P2Sp1GroupSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (this.Document.CommonRules.IsFooterRow(sheetId, row)) {
                if (column === P2Sp1GroupSheet._strCodeColumn - 1) {
                    return InterfaceRules.TotalRowName;
                }
                else if (column === P2Sp1GroupSheet._strCodeColumn) {
                    return InterfaceRules.TotalRowCode;
                }
                else if (column > P2Sp1GroupSheet._strCodeColumn) {
                    return this.Document.CommonRules.GetFooterSum(sheetId, row, column);
                }
            }
            if (BaseObasTableFields.StrCodeField.Equal(fieldId)) {
                return ObasHelper.FillWithCharacter(row + 1, InterfaceRules.CodeLength);
            }
            return undefined;
        };
        P2Sp1GroupSheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (this.Document.CommonRules.IsFooterRow(sheetId, row)) {
                if (column > P2Sp1GroupSheet._strCodeColumn) {
                    return SheetFormatCollection.Calc;
                }
                else {
                    return SheetFormatCollection.Default;
                }
            }
            else {
                switch (column) {
                    case 0:
                    case 2:
                    case 4:
                    case 7:
                        return SheetFormatCollection.Spr;
                    case 3:
                    case 5:
                    case 6:
                        return SheetFormatCollection.Related;
                    case 11:
                    case 12:
                    case 23:
                        return SheetFormatCollection.Calc;
                    case 10:
                        return SheetFormatCollection.Default;
                    default:
                        return SheetFormatCollection.Free;
                }
            }
        };
        P2Sp1GroupSheet._strCodeColumn = 10;
        return P2Sp1GroupSheet;
    }(YearGroupSheet));
    F06300.P2Sp1GroupSheet = P2Sp1GroupSheet;
    var P3Sp1SpxGroupSheet = (function (_super) {
        __extends(P3Sp1SpxGroupSheet, _super);
        function P3Sp1SpxGroupSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(P3Sp1SpxGroupSheet.prototype, "RowCode", {
            get: function () {
                return 2;
            },
            enumerable: true,
            configurable: true
        });
        P3Sp1SpxGroupSheet.prototype.IsFooterRow = function (sheetId, row) {
            return this.Document.CommonRules.IsFooterRow(sheetId, row);
        };
        P3Sp1SpxGroupSheet.prototype.IsSprColumn = function (sheetId, column) {
            var sprColumns = [0, 1, 4, 5, 6];
            return sprColumns.indexOf(column) != -1;
        };
        P3Sp1SpxGroupSheet.prototype.IsCalcColumn = function (sheetId, column) {
            var calcColumns = [9, 12, 15];
            return calcColumns.indexOf(column) != -1;
        };
        P3Sp1SpxGroupSheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (this.IsFooterRow(sheetId, row)) {
                if (column > this.RowCode) {
                    return SheetFormatCollection.Calc;
                }
                else {
                    return SheetFormatCollection.Default;
                }
            }
            else {
                if (this.IsSprColumn(sheetId, column)) {
                    return SheetFormatCollection.Spr;
                }
                else if (this.IsCalcColumn(sheetId, column)) {
                    return SheetFormatCollection.Calc;
                }
                else if (column === this.RowCode) {
                    return SheetFormatCollection.Default;
                }
                else {
                    return SheetFormatCollection.Free;
                }
            }
            return undefined;
        };
        P3Sp1SpxGroupSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (this.IsFooterRow(sheetId, row)) {
                if (column === this.RowCode - 1) {
                    return InterfaceRules.TotalRowName;
                }
                else if (column === this.RowCode) {
                    return P3Sp1SpxGroupSheet.TotalRowCode;
                }
                else if (column > this.RowCode) {
                    if (!this.IsCalcColumn(sheetId, column)) {
                        return ObasHelper.X;
                    }
                    else {
                        return this.Document.CommonRules.GetFooterSum(sheetId, row, column);
                    }
                }
            }
            else {
                if (column === this.RowCode) {
                    return ObasHelper.FillWithCharacter(row + 1, P3Sp1SpxGroupSheet.CodeLength);
                }
            }
            return undefined;
        };
        P3Sp1SpxGroupSheet.TotalRowCode = "90000";
        P3Sp1SpxGroupSheet.CodeLength = 5;
        return P3Sp1SpxGroupSheet;
    }(YearGroupSheet));
    F06300.P3Sp1SpxGroupSheet = P3Sp1SpxGroupSheet;
    var P3Sp2GroupSheet = (function (_super) {
        __extends(P3Sp2GroupSheet, _super);
        function P3Sp2GroupSheet(_document) {
            return _super.call(this, _document) || this;
        }
        P3Sp2GroupSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (this.Document.CommonRules.IsFooterRow(sheetId, row)) {
                switch (column) {
                    case 0:
                        return InterfaceRules.TotalRowName;
                    case 1:
                        return InterfaceRules.TotalRowCode;
                    default:
                        if (column > 1) {
                            return this.Document.CommonRules.GetFooterSum(sheetId, row, column);
                        }
                }
            }
            if (BaseObasTableFields.StrCodeField.Equal(fieldId)) {
                return ObasHelper.FillWithCharacter(row + 1, InterfaceRules.CodeLength);
            }
            return undefined;
        };
        P3Sp2GroupSheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (this.Document.CommonRules.IsFooterRow(sheetId, row)) {
                switch (column) {
                    case 0:
                    case 1:
                        return SheetFormatCollection.Default;
                    default:
                        return SheetFormatCollection.Calc;
                }
            }
            else {
                switch (column) {
                    case 2:
                    case 3:
                        return SheetFormatCollection.Calc;
                    case 1:
                        return SheetFormatCollection.Default;
                    default:
                        return SheetFormatCollection.Free;
                }
            }
        };
        return P3Sp2GroupSheet;
    }(YearGroupSheet));
    F06300.P3Sp2GroupSheet = P3Sp2GroupSheet;
})(F06300 || (F06300 = {}));
