var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F08100;
(function (F08100) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(_document) {
            var _this = _super.call(this, _document) || this;
            _this._document = _document;
            return _this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetP2Data("\u0424\u0430\u043A\u0442\u043E\u0440\u044B_1"));
            result.push(this.GetP2DetailData("\u0420\u0430\u0441\u0447\u0435\u0442_1"));
            result.push(this.GetPXNpaData("\u041D\u041F\u0410_1", this._document.P2NpaTable, this._document.P2SubsidyTable));
            result.push(this.GetP3Data("\u0424\u0430\u043A\u0442\u043E\u0440\u044B_2"));
            result.push(this.GetPXNpaData("\u041D\u041F\u0410_2", this._document.P3NpaTable, this._document.P3SubsidyTable));
            result.push(this.GetP4Data("\u0424\u0430\u043A\u0442\u043E\u0440\u044B_3"));
            result.push(this.GetPXNpaData("\u041D\u041F\u0410_3", this._document.P4NpaTable, this._document.P4SubsidyTable));
            result.push(this.GetP1Data("\u0418\u0442\u043E\u0433\u0438"));
            result.push(this.GetP1Sp2Sp1Data("\u0420\u0435\u0437\u0443\u043B\u044C\u0442\u0430\u0442\u041F\u0440\u0435\u0434\u043E\u0441\u0442\u0430\u0432\u043B\u0435\u043D\u0438\u044F\u0421\u0443\u0431\u0441\u0438\u0434\u0438\u04381"));
            result.push(this.GetP1Sp2Sp2Data("\u0420\u0435\u0437\u0443\u043B\u044C\u0442\u0430\u0442\u041F\u0440\u0435\u0434\u043E\u0441\u0442\u0430\u0432\u043B\u0435\u043D\u0438\u044F\u0421\u0443\u0431\u0441\u0438\u0434\u0438\u04382"));
            result.push(this.GetSecretData("\u0413\u043E\u0441\u0442\u0430\u0439\u043D\u0430"));
            result.push(this.GetAnalyticRespredelenieData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041E\u0411\u0410\u0421"));
            var kosguData = this._document.AnalyticsDataTable.CollectKosguData();
            result.push(this.GetAnalyticKosguData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423", kosguData));
            result.push(this.GetRaspredelenieKosguData("\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041F\u043E\u041A\u041E\u0421\u0413\u0423"));
            return result;
        };
        ExportRules.prototype.GenYearData = function (srcTable, fieldId, startIndex) {
            var result = "";
            for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                result += "b" + (startIndex + j) + "=\"" + (srcTable.GetFieldValue(fieldId + j.toString()) || 0) + "\" ";
            }
            return result;
        };
        ExportRules.prototype.GetP1Data = function (id) {
            var srcTable = this._document.P1TotalTable;
            var StrKeysP1 = F08100.StrKeysP1Total;
            var keys = [StrKeysP1.Total, StrKeysP1.P2, StrKeysP1.P3, StrKeysP1.P4, StrKeysP1.Correction];
            var strCodes = ["01", "02", "03", "04", "100"];
            var yearsCount = this._document.Settings.YearsCount;
            var srcData = [];
            for (var i = 0; i < keys.length; i++) {
                var template = "<a ID=\"" + strCodes[i] + "\" ";
                if (srcTable.Locate(srcTable.StrKeyField.Id, keys[i])) {
                    for (var j = 0; j < yearsCount; j++) {
                        template += "b" + (2 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                    }
                }
                else {
                    template += "b2=\"0\" b3=\"0\" b4=\"0\" b5=\"0\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetP1Sp2Sp1Data = function (id) {
            var srcTable = this._document.P1Sp2Sp1SubsidyDetailTable;
            var srcData = [];
            var yearsCount = this._document.Settings.YearsCount;
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + (srcTable.ParentTable.Subsidy.Name || "") + "\" ";
                template += "b2=\"" + (srcTable.ParentTable.SubsidyType.Code || "") + "\" ";
                template += "b3=\"" + (srcTable.ParentTable.SubsidyType.Name || "") + "\" ";
                template += "b4=\"" + (srcTable.SubsidyResultType.Code || "") + "\" ";
                template += "b5=\"" + (srcTable.SubsidyResultType.Name || "") + "\" ";
                template += "b6=\"" + (srcTable.SubsidyResultName.Value || "") + "\" ";
                template += "b7=\"" + (srcTable.Okei.Code || "") + "\" ";
                template += "b8=\"" + (srcTable.Okei.Name || "") + "\" ";
                for (var j = 0; j < yearsCount; j++) {
                    template += "b" + (9 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.CountYearDataField.GenerateId(j + 1)) || 0) + "\" ";
                }
                for (var j = 0; j < yearsCount; j++) {
                    template += "b" + (13 + j) + "=\"" + (srcTable.GetFieldValue(F08100.ObasTableFields.SumYearDataField.GenerateId(j + 1)) || 0) + "\" ";
                }
                for (var j = 0; j < yearsCount; j++) {
                    template += "b" + (17 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                }
                template += "bFILTERINGCOLUMN=\"" + (srcTable.ParentTable.GetFieldValue("Id")) + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetP1Sp2Sp2Data = function (id) {
            var srcTable = this._document.P1Sp2Sp2SubsidyDetailTable;
            var srcData = [];
            var yearsCount = this._document.Settings.YearsCount;
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + (srcTable.ParentTable.Subsidy.Name || "") + "\" ";
                template += "b2=\"" + (srcTable.ParentTable.SubsidyType.Code || "") + "\" ";
                template += "b3=\"" + (srcTable.ParentTable.SubsidyType.Name || "") + "\" ";
                template += "b4=\"" + (srcTable.SubsidyResultType.Code || "") + "\" ";
                template += "b5=\"" + (srcTable.SubsidyResultType.Name || "") + "\" ";
                template += "b6=\"" + (srcTable.SubsidyResultName.Value || "") + "\" ";
                template += "b7=\"" + (srcTable.Okei.Code || "") + "\" ";
                template += "b8=\"" + (srcTable.Okei.Name || "") + "\" ";
                for (var j = 0; j < yearsCount; j++) {
                    template += "b" + (9 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.CountYearDataField.GenerateId(j + 1)) || 0) + "\" ";
                }
                for (var j = 0; j < yearsCount; j++) {
                    template += "b" + (13 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                }
                template += "bFILTERINGCOLUMN=\"" + (srcTable.ParentTable.GetFieldValue("Id")) + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetP2Data = function (id) {
            var dataTable = this._document.P2SubsidyDetailTable;
            var srcTable = this._document.P2SubsidyDetailTransTable;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var keyIds = [dataTable.ParentTable.Subsidy.ForeignKey.Id, dataTable.ParentTable.SubsidyType.ForeignKey.Id, dataTable.SubsidyResultType.ForeignKey.Id,
                    dataTable.SubsidyResultName.Id, dataTable.PersonName.Id, dataTable.Okpd.ForeignKey.Id, dataTable.Okei.ForeignKey.Id, dataTable.PaymentName.Id];
                var keyValues = [];
                for (var j = 0; j < keyIds.length; j++) {
                    keyValues.push(srcTable.GetFieldValue(keyIds[j]));
                }
                dataTable.Locate(keyIds, keyValues);
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + (dataTable.ParentTable.Subsidy.Name || "") + "\" ";
                template += "b2=\"" + (dataTable.ParentTable.SubsidyType.Code || "") + "\" ";
                template += "b3=\"" + (dataTable.ParentTable.SubsidyType.Name || "") + "\" ";
                template += "b4=\"" + (dataTable.SubsidyResultType.Code || "") + "\" ";
                template += "b5=\"" + (dataTable.SubsidyResultType.Name || "") + "\" ";
                template += "b6=\"" + (dataTable.SubsidyResultName.Value || "") + "\" ";
                template += "b7=\"" + (dataTable.PersonName.Value || "") + "\" ";
                template += "b8=\"" + (dataTable.Okpd.Code || "") + "\" ";
                template += "b9=\"" + (dataTable.Okpd.Name || "") + "\" ";
                template += "b10=\"" + (dataTable.Okei.Code || "") + "\" ";
                template += "b11=\"" + (dataTable.Okei.Name || "") + "\" ";
                template += "b12=\"" + (dataTable.PaymentName.Value || "") + "\" ";
                template += this.GenYearData(srcTable, dataTable.TotalPrice.Id, 13);
                template += this.GenYearData(srcTable, dataTable.SubsUnit.Id, 17);
                template += this.GenYearData(srcTable, dataTable.SubsPayment.Id, 21);
                template += this.GenYearData(srcTable, dataTable.TotalSum.Id, 25);
                template += "bFILTERINGCOLUMN=\"" + (dataTable.ParentTable.GetFieldValue("Id")) + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetP2DetailData = function (id) {
            var dataTable = this._document.P2SubsidyDetailTable;
            var srcTable = this._document.P2SubsidyDetailTransTable;
            var srcData = [];
            var yearsCount = this._document.Settings.YearsCount;
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var keyIds = [dataTable.ParentTable.Subsidy.ForeignKey.Id, dataTable.ParentTable.SubsidyType.ForeignKey.Id, dataTable.SubsidyResultType.ForeignKey.Id,
                    dataTable.SubsidyResultName.Id, dataTable.PersonName.Id, dataTable.Okpd.ForeignKey.Id, dataTable.Okei.ForeignKey.Id, dataTable.PaymentName.Id];
                var keyValues = [];
                for (var j = 0; j < keyIds.length; j++) {
                    keyValues.push(srcTable.GetFieldValue(keyIds[j]));
                }
                dataTable.Locate(keyIds, keyValues);
                for (var j = 0; j < yearsCount; j++) {
                    var year = this._document.Settings.StartYear + j;
                    var template = "<a ID=\"" + i + "\" ";
                    template += "b1=\"" + year + "\" ";
                    template += "b2=\"" + (srcTable.GetFieldValue(dataTable.UnitCount.Id + j.toString()) || "0") + "\" ";
                    template += "b3=\"" + (srcTable.GetFieldValue(dataTable.Price.Id + j.toString()) || "0") + "\" ";
                    template += "b4=\"" + (srcTable.GetFieldValue(dataTable.SubsPrice.Id + j.toString()) || "0") + "\" ";
                    template += "b5=\"" + (srcTable.GetFieldValue(dataTable.PaymentName.Id) || "") + "\" ";
                    template += "b6=\"" + (srcTable.GetFieldValue(dataTable.Payment.Id + j.toString()) || "0") + "\" ";
                    template += "b7=\"" + (srcTable.GetFieldValue(dataTable.PaymentCount.Id + j.toString()) || "0") + "\" ";
                    template += "b8=\"" + (srcTable.GetFieldValue(dataTable.TotalPrice.Id + j.toString()) || "0") + "\" ";
                    template += "b9=\"" + (srcTable.GetFieldValue(dataTable.SubsUnit.Id + j.toString()) || "0") + "\" ";
                    template += "b10=\"" + (srcTable.GetFieldValue(dataTable.SubsPayment.Id + j.toString()) || "0") + "\" ";
                    template += "b11=\"" + (srcTable.GetFieldValue(dataTable.TotalSum.Id + j.toString()) || "0") + "\" ";
                    template += "bFILTERINGCOLUMN=\"" + (dataTable.ParentTable.GetFieldValue("Id")) + "\" ";
                    template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                    template += "/>";
                    srcData.push(template);
                    i++;
                }
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetP3Data = function (id) {
            var srcTable = this._document.P3SubsidyDetailTable;
            var srcData = [];
            var yearsCount = this._document.Settings.YearsCount;
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + (srcTable.ParentTable.Subsidy.Name || "") + "\" ";
                template += "b2=\"" + (srcTable.ParentTable.SubsidyType.Code || "") + "\" ";
                template += "b3=\"" + (srcTable.ParentTable.SubsidyType.Name || "") + "\" ";
                template += "b4=\"" + (srcTable.SubsidyResultType.Code || "") + "\" ";
                template += "b5=\"" + (srcTable.SubsidyResultType.Name || "") + "\" ";
                template += "b6=\"" + (srcTable.SubsidyResultName.Value || "") + "\" ";
                template += "b7=\"" + (srcTable.PersonName.Value || "") + "\" ";
                for (var j = 0; j < yearsCount; j++) {
                    template += "b" + (8 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                }
                template += "bFILTERINGCOLUMN=\"" + (srcTable.ParentTable.GetFieldValue("Id")) + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetP4Data = function (id) {
            var dataTable = this._document.P4SubsidyDetailTable;
            var srcTable = this._document.P4SubsidyDetailTransTable;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                dataTable.Locate([dataTable.ParentTable.Subsidy.ForeignKey.Id, dataTable.PersonName.Id, dataTable.CreditKind.Id], [srcTable.GetFieldValue(dataTable.ParentTable.Subsidy.ForeignKey.Id), srcTable.GetFieldValue(dataTable.PersonName.Id), srcTable.GetFieldValue(dataTable.CreditKind.Id)]);
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + (dataTable.ParentTable.Subsidy.Name || "") + "\" ";
                template += "b2=\"" + (dataTable.PersonName.Value || "") + "\" ";
                template += "b4=\"" + (dataTable.CreditKind.Value || "") + "\" ";
                template += this.GenYearData(srcTable, dataTable.CreditSum.Id, 5);
                template += this.GenYearData(srcTable, dataTable.SsudaDolg.Id, 9);
                template += this.GenYearData(srcTable, dataTable.CreditPeriod.Id, 13);
                template += this.GenYearData(srcTable, dataTable.MonthCount.Id, 17);
                template += this.GenYearData(srcTable, dataTable.InterestRate.Id, 21);
                template += this.GenYearData(srcTable, dataTable.RecoverRate.Id, 25);
                template += this.GenYearData(srcTable, dataTable.TotalSum.Id, 29);
                template += "bFILTERINGCOLUMN=\"" + (dataTable.ParentTable.GetFieldValue("Id")) + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetPXNpaData = function (id, srcTable, subsidyTable) {
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + (srcTable.Subsidy.Name || "") + "\" ";
                template += "b\u043F\u0440\u0438\u0437\u043D\u0430\u043A\u041F\u0440\u043E\u0435\u043A\u0442\u0430=\"" + ((srcTable.NpaStatus.Code === "1") ? "True" : "Fasle") + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "b8=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaName.Value || "") + "\" ";
                template += "b9=\"" + (srcTable.NpaType.Code || "") + "\" ";
                template += "b10=\"" + (ObasHelper.ConvertToString(srcTable.NpaDate.Value) || "") + "\" ";
                template += "b11=\"" + (srcTable.NpaNumber.Value || "") + "\" ";
                template += "b12=\"" + (srcTable.NpaStatus.Code || "") + "\" ";
                subsidyTable.Locate(subsidyTable.Subsidy.ForeignKey.Id, srcTable.Subsidy.ForeignKey.Value);
                template += "bFILTERINGCOLUMN=\"" + (subsidyTable.GetFieldValue("Id")) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticRespredelenieData = function (barsTableId) {
            var srcData = [];
            srcData.push("<a ID=\"0\" b4=\"0\" b5=\"0\" b6=\"0\" barservice=\"\u0412\u0441\u0435\u0433\u043E, \u0438\u0437 \u043D\u0438\u0445:\" />");
            srcData.push("<a ID=\"1\" b4=\"0\" b5=\"0\" b6=\"0\" barservice=\"\u041D\u0435\u0440\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u043D\u044B\u0439 \u043E\u0441\u0442\u0430\u0442\u043E\u043A\" />");
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticKosguData = function (id, kosguData) {
            var kosguTable = ObasTableCollection.KosguSprTable;
            var srcData = [];
            for (var i = 1; i < kosguData.length; i++) {
                var template = "<a ID=\"" + (i - 1) + "\" ";
                template += "b1=\"" + (!kosguTable.Locate(kosguTable.Code.Id, kosguData[i].Code) ? "" : (kosguTable.Name.Value || "")) + "\" ";
                template += "b2=\"" + (kosguData[i].Code || "") + "\" ";
                for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                    template += "b" + (3 + j) + "=\"" + (kosguData[i].Data[j] || 0) + "\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetRaspredelenieKosguData = function (id) {
            var strCodes = ["241", "242", "530", "total"];
            var srcData = [];
            for (var i = 0; i < strCodes.length; i++) {
                srcData.push("<a ID=\"" + strCodes[i] + "\" b4=\"0\" b5=\"0\" b6=\"0\" />");
            }
            return { Id: id, Data: srcData };
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F08100.ExportRules = ExportRules;
})(F08100 || (F08100 = {}));
