var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F08100;
(function (F08100) {
    var InterfaceRules = (function () {
        function InterfaceRules(_document) {
            this._document = _document;
        }
        InterfaceRules.prototype.GetTotalSum = function (table, fieldId) {
            var result = 0;
            var reader = table.CreateReader();
            while (reader.Read()) {
                result += table.GetFieldValue(fieldId) || 0;
            }
            return result;
        };
        InterfaceRules.prototype.CheckDocumentBeforeSave = function () {
            var result = true;
            var errorPart = "";
            var totalTable = this._document.P1TotalTable;
            var sourceTable = this._document.P2SubsidyDetailTable;
            var dataTable = this._document.P2SubsidyDetailTransTable;
            if (totalTable.Locate(totalTable.RecordKey.Id, F08100.StrKeysP1Total.P2)) {
                for (var i = 1; i <= ObasStageSettings.YearsCount; i++) {
                    var sum = this.GetTotalSum(dataTable, sourceTable.TotalSum.Id + (i - 1).toString());
                    result = ((totalTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(i)) || 0) === (sum || 0));
                    if (!result) {
                        errorPart = "2.1";
                        break;
                    }
                }
            }
            sourceTable = this._document.P3SubsidyDetailTable;
            if (result && totalTable.Locate(totalTable.RecordKey.Id, F08100.StrKeysP1Total.P3)) {
                for (var i = 1; i <= ObasStageSettings.YearsCount; i++) {
                    var fieldId = BaseObasTableFields.YearDataField.GenerateId(i);
                    var sum = this.GetTotalSum(sourceTable, fieldId);
                    result = ((totalTable.GetFieldValue(fieldId) || 0) === (sum || 0));
                    if (!result) {
                        errorPart = "3.1";
                        break;
                    }
                }
            }
            sourceTable = this._document.P4SubsidyDetailTable;
            dataTable = this._document.P4SubsidyDetailTransTable;
            if (result && totalTable.Locate(totalTable.RecordKey.Id, F08100.StrKeysP1Total.P4)) {
                for (var i = 1; i <= ObasStageSettings.YearsCount; i++) {
                    var sum = this.GetTotalSum(dataTable, sourceTable.TotalSum.Id + (i - 1).toString());
                    result = ((totalTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(i)) || 0) === (sum || 0));
                    if (!result) {
                        errorPart = "4.1";
                        break;
                    }
                }
            }
            if (!result) {
                Client.ShowMessage("\u041E\u0448\u0438\u0431\u043A\u0430", "\u0421\u043E\u0445\u0440\u0430\u043D\u0435\u043D\u0438\u0435 \u043D\u0435\u0432\u043E\u0437\u043C\u043E\u0436\u043D\u043E!\n\u0418\u0442\u043E\u0433\u043E\u0432\u0430\u044F \u0441\u0443\u043C\u043C\u0430 \u041E\u0411\u0410\u0421 \u043D\u0435 \u0441\u043E\u043E\u0442\u0432\u0435\u0442\u0441\u0442\u0432\u0443\u0435\u0442 \u0441\u0443\u043C\u043C\u0435 \u0432 \u0440\u0430\u0437\u0434\u0435\u043B\u0435 " + errorPart + ".\n\u041D\u0435\u043E\u0431\u0445\u043E\u0434\u0438\u043C\u043E \u0432\u043D\u0435\u0441\u0442\u0438 \u0438\u0437\u043C\u0435\u043D\u0435\u043D\u0438\u044F!", MessageIcons.Error);
            }
            return result && this._document.CommonRules.CheckChangeType();
        };
        InterfaceRules.prototype.P1Sp2Sp1SubsidyEditorCloseEventHandler = function (isSuccess) {
            if (isSuccess) {
                var sourceTable = this._document.P1Sp2Sp1SubsidyTable;
                var keyIds = sourceTable.GetSubsidyFieldsId();
                keyIds.push(BaseObasTableFields.YearField.Id);
                var p2SubsidyTable = this._document.P2SubsidyTable;
                var p4SubsidyTable = this._document.P4SubsidyTable;
                for (var i = 0; i < this._document.Settings.YearsCount; i++) {
                    var year = this._document.Settings.StartYear + i;
                    var keyValues = sourceTable.GetSubsidyFieldsValue();
                    keyValues.push(year);
                    if (!p2SubsidyTable.Locate(keyIds, keyValues)) {
                        p2SubsidyTable.AddRow();
                        p2SubsidyTable.Year.Value = year;
                        p2SubsidyTable.CopySubsidyData(keyValues);
                        p2SubsidyTable.PostRow();
                    }
                    if (!p4SubsidyTable.Locate(keyIds, keyValues)) {
                        p4SubsidyTable.AddRow();
                        p4SubsidyTable.Year.Value = year;
                        p4SubsidyTable.CopySubsidyData(keyValues);
                        p4SubsidyTable.PostRow();
                    }
                }
            }
        };
        InterfaceRules.prototype.P1Sp2Sp2SubsidyEditorCloseEventHandler = function (isSuccess) {
            if (isSuccess) {
                var sourceTable = this._document.P1Sp2Sp2SubsidyTable;
                var keyIds = sourceTable.GetSubsidyFieldsId();
                var keyValues = sourceTable.GetSubsidyFieldsValue();
                var p3SubsidyTable = this._document.P3SubsidyTable;
                if (!p3SubsidyTable.Locate(keyIds, keyValues)) {
                    p3SubsidyTable.AddRow();
                    p3SubsidyTable.CopySubsidyData(keyValues);
                    p3SubsidyTable.PostRow();
                }
                keyIds.push(BaseObasTableFields.YearField.Id);
                var p4SubsidyTable = this._document.P4SubsidyTable;
                for (var i = 0; i < this._document.Settings.YearsCount; i++) {
                    var year = this._document.Settings.StartYear + i;
                    keyValues = sourceTable.GetSubsidyFieldsValue();
                    keyValues.push(year);
                    if (!p4SubsidyTable.Locate(keyIds, keyValues)) {
                        p4SubsidyTable.AddRow();
                        p4SubsidyTable.Year.Value = year;
                        p4SubsidyTable.CopySubsidyData(keyValues);
                        p4SubsidyTable.PostRow();
                    }
                }
            }
        };
        InterfaceRules.prototype.P1Sp2Sp1SubsidyDetailEditorCloseEventHandler = function (isSuccess) {
            if (isSuccess) {
                var sourceTable = this._document.P1Sp2Sp1SubsidyDetailTable;
                var keyIds = sourceTable.ParentTable.GetSubsidyFieldsId();
                keyIds.push(BaseObasTableFields.YearField.Id);
                var p2SubsidyTable = this._document.P2SubsidyTable;
                var p2SubsidyDetailTable = this._document.P2SubsidyDetailTable;
                for (var i = 0; i < this._document.Settings.YearsCount; i++) {
                    var year = this._document.Settings.StartYear + i;
                    var keyValues = sourceTable.ParentTable.GetSubsidyFieldsValue();
                    keyValues.push(year);
                    if (p2SubsidyTable.Locate(keyIds, keyValues)) {
                        var ownerKey = p2SubsidyTable.RecordKey.Value;
                        var keyIds2 = p2SubsidyDetailTable.GetSubsidyDetailFieldsId();
                        var keyValues2 = sourceTable.GetSubsidyDetailFieldsValue(keyIds2);
                        keyIds2.push(BaseObasTableFields.OwnerKeyField.Id);
                        keyValues2.push(ownerKey);
                        if (!p2SubsidyDetailTable.Locate(keyIds2, keyValues2)) {
                            p2SubsidyDetailTable.AddRow();
                            p2SubsidyDetailTable.OwnerKey.Value = ownerKey;
                            p2SubsidyDetailTable.CopySubsidyDetailData(keyValues2);
                            p2SubsidyDetailTable.PostRow();
                        }
                    }
                }
            }
        };
        InterfaceRules.prototype.P1Sp2Sp2SubsidyDetailEditorCloseEventHandler = function (isSuccess) {
            if (isSuccess) {
                var sourceTable = this._document.P1Sp2Sp2SubsidyDetailTable;
                var keyIds = sourceTable.ParentTable.GetSubsidyFieldsId();
                var p3SubsidyTable = this._document.P3SubsidyTable;
                var p3SubsidyDetailTable = this._document.P3SubsidyDetailTable;
                for (var i = 0; i < this._document.Settings.YearsCount; i++) {
                    var keyValues = sourceTable.ParentTable.GetSubsidyFieldsValue();
                    if (p3SubsidyTable.Locate(keyIds, keyValues)) {
                        var ownerKey = p3SubsidyTable.RecordKey.Value;
                        var keyIds2 = p3SubsidyDetailTable.GetSubsidyDetailFieldsId();
                        var keyValues2 = sourceTable.GetSubsidyDetailFieldsValue(keyIds2);
                        keyIds2.push(BaseObasTableFields.OwnerKeyField.Id);
                        keyValues2.push(ownerKey);
                        if (!p3SubsidyDetailTable.Locate(keyIds2, keyValues2)) {
                            p3SubsidyDetailTable.AddRow();
                            p3SubsidyDetailTable.OwnerKey.Value = ownerKey;
                            p3SubsidyDetailTable.CopySubsidyDetailData(keyValues2);
                            p3SubsidyDetailTable.PostRow();
                        }
                    }
                }
            }
        };
        InterfaceRules.prototype.FilterNPAStatuses = function () {
            var npaStatusesTable = ObasTableCollection.NpaStatusesSprTable;
            return npaStatusesTable.RecordKey.Value === 1 || npaStatusesTable.RecordKey.Value === 2;
        };
        InterfaceRules.prototype.ShiftDataMenuItemClickEventHandler = function () {
            this._document.UpdateRules.ShiftData();
        };
        InterfaceRules.prototype.CopyDataMenuItemClickEventHandler = function () {
            this._document.UpdateRules.CopyData();
        };
        InterfaceRules.prototype.RecalcDataMenuItemClickEventHandler = function () {
            this._document.UpdateRules.RecalcData();
        };
        return InterfaceRules;
    }());
    InterfaceRules.TotalRowName = "Итого";
    InterfaceRules.TotalRowCode = 90000;
    InterfaceRules.RowCodeLength = 5;
    F08100.InterfaceRules = InterfaceRules;
    var P1SheetRows;
    (function (P1SheetRows) {
        P1SheetRows[P1SheetRows["P2"] = 0] = "P2";
        P1SheetRows[P1SheetRows["P3"] = 1] = "P3";
        P1SheetRows[P1SheetRows["P4"] = 2] = "P4";
        P1SheetRows[P1SheetRows["Total"] = 3] = "Total";
        P1SheetRows[P1SheetRows["Correction"] = 4] = "Correction";
        P1SheetRows[P1SheetRows["P1Sp2Sp1"] = 5] = "P1Sp2Sp1";
        P1SheetRows[P1SheetRows["P1Sp2Sp2"] = 6] = "P1Sp2Sp2";
    })(P1SheetRows || (P1SheetRows = {}));
    var P1Sheet = (function (_super) {
        __extends(P1Sheet, _super);
        function P1Sheet(id, document) {
            return _super.call(this, id, document, 1) || this;
        }
        P1Sheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case this.RowNameColumn:
                case this.RowCodeColumn:
                    return SheetFormatCollection.Default;
                default:
                    if (row === P1SheetRows.Total) {
                        return SheetFormatCollection.Calc;
                    }
                    else if (row === P1SheetRows.P1Sp2Sp1 || row === P1SheetRows.P1Sp2Sp2) {
                        return SheetFormatCollection.Related;
                    }
                    else {
                        return SheetFormatCollection.Free;
                    }
            }
        };
        P1Sheet.prototype.CanEditCellEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return (column > this.RowCodeColumn) && (row != P1SheetRows.Total) && (row != P1SheetRows.P1Sp2Sp1) && (row != P1SheetRows.P1Sp2Sp2);
        };
        return P1Sheet;
    }(YearsSheet));
    F08100.P1Sheet = P1Sheet;
    var BaseGroupSheet = (function (_super) {
        __extends(BaseGroupSheet, _super);
        function BaseGroupSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        BaseGroupSheet.prototype.IsFooterRow = function (sheetId, row) {
            return this.Document.CommonRules.IsFooterRow(sheetId, row);
        };
        BaseGroupSheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (this.IsFooterRow(sheetId, row)) {
                if (column > this.RowCode) {
                    return SheetFormatCollection.Calc;
                }
                else {
                    return SheetFormatCollection.Default;
                }
            }
            else {
                if (this.IsSprColumn(sheetId, column)) {
                    return SheetFormatCollection.Spr;
                }
                else if (this.IsCalcColumn(sheetId, column)) {
                    return SheetFormatCollection.Calc;
                }
                else if (column === this.RowCode) {
                    return SheetFormatCollection.Default;
                }
                else {
                    return SheetFormatCollection.Free;
                }
            }
            return undefined;
        };
        return BaseGroupSheet;
    }(YearGroupSheet));
    F08100.BaseGroupSheet = BaseGroupSheet;
    var P1Sp2Sp1Sheet = (function (_super) {
        __extends(P1Sp2Sp1Sheet, _super);
        function P1Sp2Sp1Sheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(P1Sp2Sp1Sheet.prototype, "RowCode", {
            get: function () {
                return 3;
            },
            enumerable: true,
            configurable: true
        });
        P1Sp2Sp1Sheet.prototype.IsSprColumn = function (sheetId, column) {
            var sprColumns = [0, 1, 2, 4, 5, 7, 8];
            return sprColumns.indexOf(column) != -1;
        };
        P1Sp2Sp1Sheet.prototype.IsCalcColumn = function (sheetId, column) {
            var calcColumns = [11, 14, 17, 20];
            return calcColumns.indexOf(column) != -1;
        };
        P1Sp2Sp1Sheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (this.IsFooterRow(sheetId, row)) {
                if (column === this.RowCode - 1) {
                    return InterfaceRules.TotalRowName;
                }
                else if (column === this.RowCode) {
                    return InterfaceRules.TotalRowCode;
                }
                else if (column > this.RowCode) {
                    if (!this.IsCalcColumn(sheetId, column)) {
                        return ObasHelper.X;
                    }
                    else {
                        return this.Document.CommonRules.GetFooterSum(sheetId, row, column);
                    }
                }
            }
            else {
                if (column === this.RowCode) {
                    return ObasHelper.FillWithCharacter(row + 1, InterfaceRules.RowCodeLength);
                }
            }
            return undefined;
        };
        P1Sp2Sp1Sheet.prototype.CanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return this.Document.P1Sp2Sp2SubsidyTable.RowCount === 0;
        };
        return P1Sp2Sp1Sheet;
    }(BaseGroupSheet));
    F08100.P1Sp2Sp1Sheet = P1Sp2Sp1Sheet;
    var P1Sp2Sp2Sheet = (function (_super) {
        __extends(P1Sp2Sp2Sheet, _super);
        function P1Sp2Sp2Sheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(P1Sp2Sp2Sheet.prototype, "RowCode", {
            get: function () {
                return 3;
            },
            enumerable: true,
            configurable: true
        });
        P1Sp2Sp2Sheet.prototype.IsSprColumn = function (sheetId, column) {
            var sprColumns = [0, 1, 2, 4, 5, 7, 8];
            return sprColumns.indexOf(column) != -1;
        };
        P1Sp2Sp2Sheet.prototype.IsCalcColumn = function (sheetId, column) {
            return false;
        };
        P1Sp2Sp2Sheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (this.IsFooterRow(sheetId, row)) {
                if (column === this.RowCode - 1) {
                    return InterfaceRules.TotalRowName;
                }
                else if (column === this.RowCode) {
                    return InterfaceRules.TotalRowCode;
                }
                else if (column > this.RowCode) {
                    if (column < 9) {
                        return ObasHelper.X;
                    }
                    else {
                        return this.Document.CommonRules.GetFooterSum(sheetId, row, column);
                    }
                }
            }
            else {
                if (column === this.RowCode) {
                    return ObasHelper.FillWithCharacter(row + 1, InterfaceRules.RowCodeLength);
                }
            }
            return undefined;
        };
        P1Sp2Sp2Sheet.prototype.CanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return this.Document.P1Sp2Sp1SubsidyTable.RowCount === 0;
        };
        return P1Sp2Sp2Sheet;
    }(BaseGroupSheet));
    F08100.P1Sp2Sp2Sheet = P1Sp2Sp2Sheet;
    var P2Sp1GroupSheet = (function (_super) {
        __extends(P2Sp1GroupSheet, _super);
        function P2Sp1GroupSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(P2Sp1GroupSheet.prototype, "RowCode", {
            get: function () {
                return 17;
            },
            enumerable: true,
            configurable: true
        });
        P2Sp1GroupSheet.prototype.IsSprColumn = function (sheetId, column) {
            var sprColumns = [0, 1, 2, 3, 4, 7, 8, 9, 10];
            return sprColumns.indexOf(column) != -1;
        };
        P2Sp1GroupSheet.prototype.IsCalcColumn = function (sheetId, column) {
            var calcColumns = [18, 19, 20, 21];
            return calcColumns.indexOf(column) != -1;
        };
        P2Sp1GroupSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (this.IsFooterRow(sheetId, row)) {
                if (column === this.RowCode - 1) {
                    return InterfaceRules.TotalRowName;
                }
                else if (column === this.RowCode) {
                    return InterfaceRules.TotalRowCode;
                }
                else if (column > this.RowCode) {
                    return this.Document.CommonRules.GetFooterSum(sheetId, row, column);
                }
            }
            else {
                if (column === this.RowCode) {
                    return ObasHelper.FillWithCharacter(row + 1, InterfaceRules.RowCodeLength);
                }
            }
            return undefined;
        };
        return P2Sp1GroupSheet;
    }(BaseGroupSheet));
    F08100.P2Sp1GroupSheet = P2Sp1GroupSheet;
    var P3Sp1Sheet = (function (_super) {
        __extends(P3Sp1Sheet, _super);
        function P3Sp1Sheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(P3Sp1Sheet.prototype, "RowCode", {
            get: function () {
                return 7;
            },
            enumerable: true,
            configurable: true
        });
        P3Sp1Sheet.prototype.IsSprColumn = function (sheetId, column) {
            var sprColumns = [0, 1, 2, 3, 4];
            return sprColumns.indexOf(column) != -1;
        };
        P3Sp1Sheet.prototype.IsCalcColumn = function (sheetId, column) {
            return false;
        };
        P3Sp1Sheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (this.IsFooterRow(sheetId, row)) {
                if (column === this.RowCode - 1) {
                    return InterfaceRules.TotalRowName;
                }
                else if (column === this.RowCode) {
                    return InterfaceRules.TotalRowCode;
                }
                else if (column > this.RowCode) {
                    return this.Document.CommonRules.GetFooterSum(sheetId, row, column);
                }
            }
            else {
                if (column === this.RowCode) {
                    return ObasHelper.FillWithCharacter(row + 1, InterfaceRules.RowCodeLength);
                }
            }
            return undefined;
        };
        return P3Sp1Sheet;
    }(BaseGroupSheet));
    F08100.P3Sp1Sheet = P3Sp1Sheet;
    var P4Sp1GroupSheet = (function (_super) {
        __extends(P4Sp1GroupSheet, _super);
        function P4Sp1GroupSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(P4Sp1GroupSheet.prototype, "RowCode", {
            get: function () {
                return 2;
            },
            enumerable: true,
            configurable: true
        });
        P4Sp1GroupSheet.prototype.IsSprColumn = function (sheetId, column) {
            var sprColumns = [0];
            return sprColumns.indexOf(column) != -1;
        };
        P4Sp1GroupSheet.prototype.IsCalcColumn = function (sheetId, column) {
            var calcColumns = [10];
            return calcColumns.indexOf(column) != -1;
        };
        P4Sp1GroupSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (this.IsFooterRow(sheetId, row)) {
                if (column === this.RowCode - 1) {
                    return InterfaceRules.TotalRowName;
                }
                else if (column === this.RowCode) {
                    return InterfaceRules.TotalRowCode;
                }
                else if (column > this.RowCode) {
                    if (!this.IsCalcColumn(sheetId, column)) {
                        return ObasHelper.X;
                    }
                    else {
                        return this.Document.CommonRules.GetFooterSum(sheetId, row, column);
                    }
                }
            }
            else {
                if (column === this.RowCode) {
                    return ObasHelper.FillWithCharacter(row + 1, InterfaceRules.RowCodeLength);
                }
            }
            return undefined;
        };
        return P4Sp1GroupSheet;
    }(BaseGroupSheet));
    F08100.P4Sp1GroupSheet = P4Sp1GroupSheet;
    var NpaSheetColumns;
    (function (NpaSheetColumns) {
        NpaSheetColumns[NpaSheetColumns["OwnerName"] = 0] = "OwnerName";
        NpaSheetColumns[NpaSheetColumns["RowCode"] = 1] = "RowCode";
        NpaSheetColumns[NpaSheetColumns["Type"] = 2] = "Type";
        NpaSheetColumns[NpaSheetColumns["Data"] = 3] = "Data";
        NpaSheetColumns[NpaSheetColumns["Number"] = 4] = "Number";
        NpaSheetColumns[NpaSheetColumns["Name"] = 5] = "Name";
        NpaSheetColumns[NpaSheetColumns["Status"] = 6] = "Status";
        NpaSheetColumns[NpaSheetColumns["ChangeDate"] = 7] = "ChangeDate";
    })(NpaSheetColumns || (NpaSheetColumns = {}));
    var NpaSheet = (function (_super) {
        __extends(NpaSheet, _super);
        function NpaSheet(id) {
            return _super.call(this, id, false) || this;
        }
        NpaSheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case NpaSheetColumns.OwnerName:
                    return SheetFormatCollection.Related;
                case NpaSheetColumns.RowCode:
                    return SheetFormatCollection.Default;
                case NpaSheetColumns.Type:
                case NpaSheetColumns.Status:
                    return SheetFormatCollection.Spr;
                default:
                    return SheetFormatCollection.Free;
            }
        };
        NpaSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (column === NpaSheetColumns.RowCode) {
                return ObasHelper.FillWithCharacter(row + 1, InterfaceRules.RowCodeLength);
            }
            return undefined;
        };
        return NpaSheet;
    }(Sheet));
    F08100.NpaSheet = NpaSheet;
})(F08100 || (F08100 = {}));
