var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F08100;
(function (F08100) {
    var UpdateRules = (function (_super) {
        __extends(UpdateRules, _super);
        function UpdateRules() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._deleteYearTables = null;
            _this._copyDataTables = null;
            _this._shiftYearTables = null;
            _this._recalcedDataTables = null;
            _this._resetDataTables = null;
            return _this;
        }
        Object.defineProperty(UpdateRules.prototype, "ResetDataTables", {
            get: function () {
                if (this._resetDataTables == null) {
                    this._resetDataTables = [this.Document.TableP1];
                }
                return this._resetDataTables;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateRules.prototype, "RecalcedDataTables", {
            get: function () {
                if (this._recalcedDataTables == null) {
                    this._recalcedDataTables = [this.Document.TableP2, this.Document.TableP3, this.Document.TableP4, this.Document.TableP5];
                }
                return this._recalcedDataTables;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateRules.prototype, "ShiftYearTables", {
            get: function () {
                if (this._shiftYearTables == null) {
                    this._shiftYearTables = [
                        {
                            Table: this.Document.TableP1,
                            GenericFields: [BaseObasTableFields.YearDataField]
                        },
                        {
                            Table: this.Document.TableP5,
                            GenericFields: [BaseObasTableFields.YearDataField]
                        }
                    ];
                }
                return this._shiftYearTables;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateRules.prototype, "CopyDataTables", {
            get: function () {
                if (this._copyDataTables == null) {
                    this._copyDataTables = [this.Document.TableP2, this.Document.TableP3, this.Document.TableP4, this.Document.TableP5];
                }
                return this._copyDataTables;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateRules.prototype, "DeleteYearTables", {
            get: function () {
                if (this._deleteYearTables == null) {
                    this._deleteYearTables = [this.Document.TableP2, this.Document.TableP3, this.Document.TableP4];
                }
                return this._deleteYearTables;
            },
            enumerable: true,
            configurable: true
        });
        UpdateRules.prototype.ShiftData = function () {
            _super.prototype.ShiftData.call(this);
            var yearDataField = BaseObasTableFields.YearDataField;
            var srcField = [];
            var destField = [];
            for (var i = 1; i <= ObasStageSettings.YearsCount - 1; i++) {
                destField.push(yearDataField.GenerateId(i));
                srcField.push(yearDataField.GenerateId(i + 1));
            }
            this._document.CommonRules.ShiftTableData(this.Document.AnalyticsDataTable, srcField, destField);
        };
        UpdateRules.prototype.InnerUpdate = function (oldVersion, currentVersion) {
            if (this.CanUpdateTo("5.0.0")) {
                this.RecalcData();
            }
            if (this.CanUpdateTo("5.3.3")) {
                this.UpdateTo533();
            }
            if (this.CanUpdateTo("6.0.0")) {
                this.ShiftData();
                this.CopyData();
                this.RecalcData();
            }
            if (this.CanUpdateTo("6.1.0")) {
                this.ShiftData();
                this.CopyData();
                this.RecalcData();
            }
            if (this.CanUpdateTo("6.1.1")) {
                this.ShiftData();
                this.CopyData();
                this.RecalcData();
            }
            if (this.CanUpdateTo("6.1.2")) {
                this.ShiftData();
                this.CopyData();
                this.RecalcData();
            }
            if (this.CanUpdateTo("6.1.3")) {
                this.ShiftData();
                this.CopyData();
                this.RecalcData();
            }
        };
        UpdateRules.prototype.UpdateTo533 = function () {
            var destTable = this.Document.TableP4;
            var parentTable = destTable.ParentTable;
            var srcTable = new ObasTable("F08_100_R4");
            srcTable.Iterate(function () {
                srcTable.CopyRow(destTable.Id, srcTable.RecordKey.Value, true);
                destTable.OwnerKey.Value = parentTable.GetRecordKey(srcTable.GetFieldValue("g2"));
            });
        };
        return UpdateRules;
    }(BaseUpdateRules));
    F08100.UpdateRules = UpdateRules;
})(F08100 || (F08100 = {}));
