var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F08410;
(function (F08410) {
    var InterfaceRules = (function (_super) {
        __extends(InterfaceRules, _super);
        function InterfaceRules() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        InterfaceRules.prototype.SheetP1FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (column < 2) {
                return SheetFormatCollection.Default;
            }
            else {
                if (row === 0) {
                    return SheetFormatCollection.Calc;
                }
                else {
                    return SheetFormatCollection.Related;
                }
            }
        };
        InterfaceRules.prototype.SheetP2FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (this._document.CommonRules.IsFooterRow(sheetId, row)) {
                if (column >= 9) {
                    return SheetFormatCollection.Calc;
                }
            }
            else {
                if (column >= 7) {
                    return SheetFormatCollection.Related;
                }
            }
            return SheetFormatCollection.Default;
        };
        InterfaceRules.prototype.SheetP2CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (this._document.CommonRules.IsFooterRow(sheetId, row)) {
                if (column === 5) {
                    return "\u0418\u0442\u043E\u0433\u043E";
                }
                else if (column === 6) {
                    return "9000";
                }
                else if ((column === 7) || (column === 8)) {
                    return ObasHelper.X;
                }
                else if ((column >= 9) && (column <= 12)) {
                    return this._document.CommonRules.GetFooterSum(sheetId, row, column);
                }
                else {
                    return undefined;
                }
            }
            else {
                if (column === 6) {
                    return ObasHelper.FillWithCharacter((row + 1).toString(), 4);
                }
            }
        };
        InterfaceRules.prototype.SheetP2Sp1Sp2Sp1FormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 0:
                case 1:
                    return SheetFormatCollection.Related;
                case 2:
                    return SheetFormatCollection.Spr;
                default:
                    return SheetFormatCollection.Free;
            }
        };
        InterfaceRules.prototype.SheetP2Sp1Sp2Sp1CanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return column > 1;
        };
        InterfaceRules.prototype.SheetP2Sp1Sp2Sp1CanEditEventHandler = function (sheetId, row, column, fieldId, levelRow) {
            var table = this._document.Sheets.getValue(sheetId).Table;
            if (column < 2) {
                return false;
            }
            else {
                return table.GetKeyBySourceTable(this._document._p2Sp1ProjectDocsTable) != null;
            }
        };
        InterfaceRules.prototype.SheetP2Sp1Sp2Sp1CanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return this.SheetP2Sp1Sp2Sp1CanEditEventHandler(sheetId, row, column, fieldId, rowLevel);
        };
        InterfaceRules.prototype.SheetP2Sp1Sp2Sp2FormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 0:
                case 1:
                    return SheetFormatCollection.Related;
                case 2:
                case 5:
                    return SheetFormatCollection.Spr;
                default:
                    return SheetFormatCollection.Free;
            }
        };
        InterfaceRules.prototype.SheetP2Sp1Sp2Sp2CanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return column > 1;
        };
        InterfaceRules.prototype.SheetP2Sp1Sp2Sp2CanEditEventHandler = function (sheetId, row, column, fieldId, levelRow) {
            var table = this._document.Sheets.getValue(sheetId).Table;
            if (column < 2) {
                return false;
            }
            else {
                return table.GetKeyBySourceTable(this._document.P2Sp1LandPlotsTable) != null;
            }
        };
        InterfaceRules.prototype.SheetP2Sp1Sp2Sp2CanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return this.SheetP2Sp1Sp2Sp2CanEditEventHandler(sheetId, row, column, fieldId, rowLevel);
        };
        InterfaceRules.prototype.SheetP2Sp1NpaFormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 0:
                case 1:
                    return SheetFormatCollection.Related;
                case 2:
                case 6:
                    return SheetFormatCollection.Spr;
                default:
                    return SheetFormatCollection.Free;
            }
        };
        InterfaceRules.prototype.SheetP2Sp1NpaCanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return column > 1;
        };
        InterfaceRules.prototype.SheetP2Sp1NpaCanEditEventHandler = function (sheetId, row, column, fieldId, levelRow) {
            var table = this._document.Sheets.getValue(sheetId).Table;
            if (column < 2) {
                return false;
            }
            else if (column > 1 && column < 8) {
                return table.GetKeyBySourceTable(this._document.P2Sp1NpaTable) != null;
            }
            else {
                return table.GetKeyBySourceTable(this._document.P2Sp1DecisionCoordinatingBodyTable) != null;
            }
        };
        InterfaceRules.prototype.SheetP2Sp1NpaCanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return this.SheetP2Sp1NpaCanEditEventHandler(sheetId, row, column, fieldId, rowLevel);
        };
        InterfaceRules.prototype.SheetP2Sp2NpaFormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 0:
                case 1:
                    return SheetFormatCollection.Related;
                case 2:
                case 6:
                    return SheetFormatCollection.Spr;
                default:
                    return SheetFormatCollection.Free;
            }
        };
        InterfaceRules.prototype.SheetP2Sp2NpaCanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return column > 1;
        };
        InterfaceRules.prototype.SheetP2Sp2NpaCanEditEventHandler = function (sheetId, row, column, fieldId, levelRow) {
            var table = this._document.Sheets.getValue(sheetId).Table;
            if (column < 2) {
                return false;
            }
            else if (column > 1 && column < 8) {
                return table.GetKeyBySourceTable(this._document.P2Sp2NpaTable) != null;
            }
            else {
                return table.GetKeyBySourceTable(this._document.P2Sp2DecisionCoordinatingBodyTable) != null;
            }
        };
        InterfaceRules.prototype.SheetP2Sp2NpaCanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return this.SheetP2Sp2NpaCanEditEventHandler(sheetId, row, column, fieldId, rowLevel);
        };
        InterfaceRules.prototype.SheetP2Sp3Sp1NpaFormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 0:
                case 1:
                    return SheetFormatCollection.Related;
                case 2:
                case 6:
                    return SheetFormatCollection.Spr;
                default:
                    return SheetFormatCollection.Free;
            }
        };
        InterfaceRules.prototype.SheetP2Sp3Sp1NpaCanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return column > 1;
        };
        InterfaceRules.prototype.SheetP2Sp3Sp1NpaCanEditEventHandler = function (sheetId, row, column, fieldId, levelRow) {
            var table = this._document.Sheets.getValue(sheetId).Table;
            if (column < 2) {
                return false;
            }
            else if (column > 1 && column < 8) {
                return table.GetKeyBySourceTable(this._document.P2Sp3Sp1NpaTable) != null;
            }
            else {
                return table.GetKeyBySourceTable(this._document.P2Sp3Sp1DecisionCoordinatingBodyTable) != null;
            }
        };
        InterfaceRules.prototype.SheetP2Sp3Sp1NpaCanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return this.SheetP2Sp3Sp1NpaCanEditEventHandler(sheetId, row, column, fieldId, rowLevel);
        };
        InterfaceRules.prototype.SheetP2Sp3Sp2Sp1Sp1FormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 0:
                case 1:
                case 2:
                case 3:
                    return SheetFormatCollection.Related;
                case 4:
                    return SheetFormatCollection.Spr;
                default:
                    return SheetFormatCollection.Free;
            }
        };
        InterfaceRules.prototype.SheetP2Sp3Sp2Sp1Sp1CanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return column > 3;
        };
        InterfaceRules.prototype.SheetP2Sp3Sp2Sp1Sp1CanEditEventHandler = function (sheetId, row, column, fieldId, levelRow) {
            var table = this._document.Sheets.getValue(sheetId).Table;
            if (column < 4) {
                return false;
            }
            else {
                return table.GetKeyBySourceTable(this._document.P2Sp3Sp2ProjectDocsTable) != null;
            }
        };
        InterfaceRules.prototype.SheetP2Sp3Sp2Sp1Sp1CanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return this.SheetP2Sp3Sp2Sp1Sp1CanEditEventHandler(sheetId, row, column, fieldId, rowLevel);
        };
        InterfaceRules.prototype.SheetP2Sp3Sp2Sp1Sp2FormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 0:
                case 1:
                case 2:
                case 3:
                    return SheetFormatCollection.Related;
                case 4:
                case 7:
                    return SheetFormatCollection.Spr;
                default:
                    return SheetFormatCollection.Free;
            }
        };
        InterfaceRules.prototype.SheetP2Sp3Sp2Sp1Sp2CanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return column > 3;
        };
        InterfaceRules.prototype.SheetP2Sp3Sp2Sp1Sp2CanEditEventHandler = function (sheetId, row, column, fieldId, levelRow) {
            var table = this._document.Sheets.getValue(sheetId).Table;
            if (column < 4) {
                return false;
            }
            else {
                return table.GetKeyBySourceTable(this._document.P2Sp3Sp2LandPlotsTable) != null;
            }
        };
        InterfaceRules.prototype.SheetP2Sp3Sp2Sp1Sp2CanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return this.SheetP2Sp3Sp2Sp1Sp2CanEditEventHandler(sheetId, row, column, fieldId, rowLevel);
        };
        InterfaceRules.prototype.SheetP2Sp3Sp2NpaFormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 0:
                case 1:
                case 2:
                case 3:
                    return SheetFormatCollection.Related;
                case 4:
                case 8:
                    return SheetFormatCollection.Spr;
                default:
                    return SheetFormatCollection.Free;
            }
        };
        InterfaceRules.prototype.SheetP2Sp3Sp2NpaCanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return column > 3;
        };
        InterfaceRules.prototype.SheetP2Sp3Sp2NpaCanEditEventHandler = function (sheetId, row, column, fieldId, levelRow) {
            var table = this._document.Sheets.getValue(sheetId).Table;
            if (column < 4) {
                return false;
            }
            else if (column > 3 && column < 10) {
                return table.GetKeyBySourceTable(this._document.P2Sp3Sp2NpaTable) != null;
            }
            else {
                return table.GetKeyBySourceTable(this._document.P2Sp3Sp2DecisionCoordinatingBodyTable) != null;
            }
        };
        InterfaceRules.prototype.SheetP2Sp3Sp2NpaCanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return this.SheetP2Sp3Sp2NpaCanEditEventHandler(sheetId, row, column, fieldId, rowLevel);
        };
        return InterfaceRules;
    }(BaseInterfaceRules));
    F08410.InterfaceRules = InterfaceRules;
    var P2SpxSp1GroupSheet = (function (_super) {
        __extends(P2SpxSp1GroupSheet, _super);
        function P2SpxSp1GroupSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P2SpxSp1GroupSheet.prototype.StandardCalcStrCode = function (param, row, column, info) {
            var sheet = this.GetSheetFromParam(param);
            var curLvl = sheet.GetRowLevel(row) - 1;
            var lvlInc = curLvl > 0 ? info.LevelIncs[curLvl - 1] : 0;
            var prevLvl = -1;
            var prevCode = 0;
            var curCode;
            if (row > 0) {
                prevLvl = sheet.GetRowLevel(row - 1) - 1;
                prevCode = parseInt(sheet.GetCellValue(row - 1, column), 10);
            }
            if (prevLvl === curLvl && curLvl === this.SheetInfo.MaxLevel) {
                curCode = prevCode + lvlInc;
            }
            else if (curLvl === 0) {
                curCode = info.CalcTotalCode(sheet, row, column);
            }
            else {
                curCode = lvlInc;
            }
            return ObasHelper.FillWithCharacter(curCode.toString(), info.Length);
        };
        P2SpxSp1GroupSheet.prototype.StandardCalc = function (param, row, column, info) {
            var sheet = this.GetSheetFromParam(param);
            var curLvl = sheet.GetRowLevel(row) - 1;
            if (column === info.CodeInfo.Column) {
                if (curLvl === info.MaxLevel) {
                    var prevInvestKey = sheet.GetCellValue(row - 1, sheet.ColumnCount, false) || 0;
                    var curInvestKey = sheet.GetCellValue(row, sheet.ColumnCount, false) || 0;
                    var prevCode = (row > 0) ? parseInt(sheet.GetCellValue(row - 1, info.CodeInfo.Column)) : 0;
                    if ((curInvestKey > 0 || prevInvestKey > 0) && curInvestKey === prevInvestKey && prevCode > 0 && prevCode !== info.CodeInfo.LevelIncs[curLvl - 2]) {
                        return sheet.GetCellValue(row - 1, info.CodeInfo.Column);
                    }
                }
                return this.StandardCalcStrCode(sheet, row, column, info.CodeInfo);
            }
            else {
                var columnInfo = info.ColumnsInfo[column];
                if (curLvl === 0) {
                    var rowInfo = columnInfo.TotalRow;
                    if (rowInfo.IsCalculated) {
                        var result = new SheetCalcResult(BaseFormulas.SUM);
                        for (var i = 0; i < sheet.RowCount; i++) {
                            var code = parseInt(sheet.GetCellValue(i, info.CodeInfo.Column));
                            if (code === info.CodeInfo.LevelIncs[curLvl]) {
                                result.AddCoordinates(new CellCoordinate(i, column));
                            }
                        }
                        return result.ToArray();
                    }
                }
                else if (curLvl === 1) {
                    var rowInfo = columnInfo.SubTotalRow;
                    if (rowInfo.IsCalculated) {
                        var result = new SheetCalcResult(BaseFormulas.SUM);
                        var code = (row > 0) ? parseInt(sheet.GetCellValue(row - 1, info.CodeInfo.Column)) : 0;
                        var i = row - 1;
                        while (i >= 0 && code > 0 && code !== info.CodeInfo.LevelIncs[curLvl - 1]) {
                            var prevCode = (i > 0) ? parseInt(sheet.GetCellValue(i - 1, info.CodeInfo.Column)) : -1;
                            if (code !== prevCode) {
                                result.AddCoordinates(new CellCoordinate(i, column));
                            }
                            code = prevCode;
                            i--;
                        }
                        return result.ToArray();
                    }
                }
            }
            return _super.prototype.StandardCalc.call(this, param, row, column, info);
        };
        P2SpxSp1GroupSheet.prototype.CanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return this.CanEditEventHandler(sheetId, row, column, fieldId, rowLevel);
        };
        P2SpxSp1GroupSheet._totalRowInfo = {
            IsCalculated: false,
            Name: "\u0412\u0441\u0435\u0433\u043E",
            Format: SheetFormatCollection.Default
        };
        P2SpxSp1GroupSheet._totalObjectRowInfo = {
            IsCalculated: false,
            Name: "\u0418\u0442\u043E\u0433\u043E \u043F\u043E \u043E\u0431\u044A\u0435\u043A\u0442\u0443",
            Format: SheetFormatCollection.Default
        };
        P2SpxSp1GroupSheet._sprColAllDefault = {
            Cell: { Type: SheetCellTypes.Spr },
            SubTotalRow: [SheetRowInfoCollection.Default, SheetRowInfoCollection.Default],
            TotalRow: SheetRowInfoCollection.Default
        };
        P2SpxSp1GroupSheet._freeColAllConst = {
            Cell: { Type: SheetCellTypes.Free },
            SubTotalRow: P2SpxSp1GroupSheet._totalObjectRowInfo,
            TotalRow: P2SpxSp1GroupSheet._totalRowInfo
        };
        return P2SpxSp1GroupSheet;
    }(HierarchyYearGroupSheet));
    F08410.P2SpxSp1GroupSheet = P2SpxSp1GroupSheet;
    var P2Sp1Sp1GroupSheet = (function (_super) {
        __extends(P2Sp1Sp1GroupSheet, _super);
        function P2Sp1Sp1GroupSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(P2Sp1Sp1GroupSheet.prototype, "SheetInfo", {
            get: function () {
                return P2Sp1Sp1GroupSheet._sheetInfo;
            },
            enumerable: true,
            configurable: true
        });
        P2Sp1Sp1GroupSheet.prototype.CanEditEventHandler = function (sheetId, row, column, fieldId, levelRow) {
            var sheet = this._document.Sheets.getValue(sheetId);
            var code = parseInt(sheet.GetCellValue(row, this.SheetInfo.CodeInfo.Column));
            if (code !== 900) {
                var table = this._document.Sheets.getValue(sheetId).Table;
                if (column > 7 && column <= 15) {
                    return table.GetKeyBySourceTable(this._document.P2Sp1InvestInfoTable) != null;
                }
                else if (column > 15) {
                    return table.GetKeyBySourceTable(this._document.P2Sp1PowerInfoTable) != null;
                }
            }
        };
        P2Sp1Sp1GroupSheet._codeInfo = {
            Column: 11,
            Length: 3,
            LevelIncs: [800, 1],
            CalcTotalCode: function () {
                return 900;
            }
        };
        P2Sp1Sp1GroupSheet._sheetInfo = {
            MaxLevel: 2,
            CodeInfo: P2Sp1Sp1GroupSheet._codeInfo,
            ColumnsInfo: [
                SheetColumnInfoCollection.SprColDefaultTotal,
                SheetColumnInfoCollection.SprColDefaultTotal,
                SheetColumnInfoCollection.SprColDefaultTotal,
                SheetColumnInfoCollection.SprColDefaultTotal,
                SheetColumnInfoCollection.SprColDefaultTotal,
                SheetColumnInfoCollection.SprColDefaultTotal,
                SheetColumnInfoCollection.FreeColDefaultTotal,
                SheetColumnInfoCollection.FreeColDefaultTotal,
                P2SpxSp1GroupSheet._sprColAllDefault,
                P2SpxSp1GroupSheet._sprColAllDefault,
                P2SpxSp1GroupSheet._freeColAllConst,
                SheetColumnInfoCollection.AllDefault,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.SprColAllX,
                SheetColumnInfoCollection.SprColAllX,
                SheetColumnInfoCollection.FreeColAllX,
                SheetColumnInfoCollection.FreeColAllX
            ]
        };
        return P2Sp1Sp1GroupSheet;
    }(P2SpxSp1GroupSheet));
    F08410.P2Sp1Sp1GroupSheet = P2Sp1Sp1GroupSheet;
    var P2SpxSpxSheet = (function (_super) {
        __extends(P2SpxSpxSheet, _super);
        function P2SpxSpxSheet(id, _document) {
            var _this = _super.call(this, id) || this;
            _this._document = _document;
            _this._totalRowCode = "900";
            _this._totalRowName = "\u0418\u0442\u043E\u0433\u043E";
            return _this;
        }
        P2SpxSpxSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (BaseObasTableFields.StrCodeField.Equal(fieldId)) {
                if (this._document.CommonRules.IsFooterRow(sheetId, row)) {
                    return this._totalRowCode;
                }
                else {
                    var sheet = this._document.Sheets.getValue(sheetId);
                    var prevInvestKey = sheet.GetCellValue(row - 1, sheet.ColumnCount, false) || 0;
                    var curInvestKey = sheet.GetCellValue(row, sheet.ColumnCount, false) || 0;
                    var prevCode = (row > 0) ? parseInt(sheet.GetCellValue(row - 1, column)) : 0;
                    if ((curInvestKey > 0 || prevInvestKey > 0) && curInvestKey === prevInvestKey && prevCode > 0) {
                        return sheet.GetCellValue(row - 1, column);
                    }
                    else {
                        return ObasHelper.FillWithCharacter(prevCode + 1, 3);
                    }
                }
            }
            if (this._document.CommonRules.IsFooterRow(sheetId, row)) {
                if (column === this.GetStrCodeColumn() - 1) {
                    return this._totalRowName;
                }
                else if (this.IsCalculatedColumn(column)) {
                    var sheet = this._document.Sheets.getValue(sheetId);
                    var result = new SheetCalcResult(BaseFormulas.SUM);
                    var code = (row > 0) ? parseInt(sheet.GetCellValue(row - 1, this.GetStrCodeColumn())) : 0;
                    var i = row - 1;
                    while (i >= 0 && code > 0) {
                        var prevCode = (i > 0) ? parseInt(sheet.GetCellValue(i - 1, this.GetStrCodeColumn())) : -1;
                        if (code !== prevCode) {
                            result.AddCoordinates(new CellCoordinate(i, column));
                        }
                        code = prevCode;
                        i--;
                    }
                    return result.ToArray();
                }
                else if (column > this.GetStrCodeColumn() && !this.IsCalculatedColumn(column)) {
                    return ObasHelper.X;
                }
            }
            return undefined;
        };
        return P2SpxSpxSheet;
    }(Sheet));
    F08410.P2SpxSpxSheet = P2SpxSpxSheet;
    var P2Sp2Sp1Sheet = (function (_super) {
        __extends(P2Sp2Sp1Sheet, _super);
        function P2Sp2Sp1Sheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P2Sp2Sp1Sheet.prototype.GetStrCodeColumn = function () {
            return 11;
        };
        P2Sp2Sp1Sheet.prototype.IsCalculatedColumn = function (column) {
            return column > 11 && column < 16;
        };
        P2Sp2Sp1Sheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (this._document.CommonRules.IsFooterRow(sheetId, row)) {
                if (this.IsCalculatedColumn(column)) {
                    return SheetFormatCollection.Calc;
                }
                else {
                    return SheetFormatCollection.Default;
                }
            }
            else {
                switch (column) {
                    case 0:
                    case 1:
                    case 2:
                    case 3:
                    case 4:
                    case 5:
                    case 8:
                    case 9:
                    case 16:
                    case 17:
                        return SheetFormatCollection.Spr;
                    case 11:
                        return SheetFormatCollection.Default;
                    default:
                        return SheetFormatCollection.Free;
                }
            }
        };
        P2Sp2Sp1Sheet.prototype.CanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            if (this._document.CommonRules.IsFooterRow(sheetId, row)) {
                return true;
            }
            else {
                return column < 8 || column > 15;
            }
        };
        P2Sp2Sp1Sheet.prototype.CanEditEventHandler = function (sheetId, row, column, fieldId, levelRow) {
            if (!this._document.CommonRules.IsFooterRow(sheetId, row)) {
                var table = this._document.Sheets.getValue(sheetId).Table;
                if (column < 8) {
                    return table.GetKeyBySourceTable(this._document.P2Sp2ObjectInfoTable) != null;
                }
                else if (column >= 8 && column <= 15) {
                    return table.GetKeyBySourceTable(this._document.P2Sp2InvestInfoTable) != null;
                }
                else if (column > 15) {
                    return table.GetKeyBySourceTable(this._document.P2Sp2PowerInfoTable) != null;
                }
            }
        };
        P2Sp2Sp1Sheet.prototype.CanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            if (!this._document.CommonRules.IsFooterRow(sheetId, row)) {
                if (column >= 8 && column <= 15) {
                    return false;
                }
                else {
                    return this.CanEditEventHandler(sheetId, row, column, fieldId, rowLevel);
                }
            }
        };
        return P2Sp2Sp1Sheet;
    }(P2SpxSpxSheet));
    F08410.P2Sp2Sp1Sheet = P2Sp2Sp1Sheet;
    var P2Sp3Sp1Sheet = (function (_super) {
        __extends(P2Sp3Sp1Sheet, _super);
        function P2Sp3Sp1Sheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P2Sp3Sp1Sheet.prototype.GetStrCodeColumn = function () {
            return 5;
        };
        P2Sp3Sp1Sheet.prototype.IsCalculatedColumn = function (column) {
            return column > 5 && column < 10;
        };
        P2Sp3Sp1Sheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (this._document.CommonRules.IsFooterRow(sheetId, row)) {
                if (this.IsCalculatedColumn(column)) {
                    return SheetFormatCollection.Calc;
                }
                else {
                    return SheetFormatCollection.Default;
                }
            }
            else {
                switch (column) {
                    case 0:
                    case 1:
                    case 2:
                    case 10:
                    case 11:
                        return SheetFormatCollection.Spr;
                    case 5:
                        return SheetFormatCollection.Default;
                    default:
                        return SheetFormatCollection.Free;
                }
            }
        };
        P2Sp3Sp1Sheet.prototype.CanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            if (this._document.CommonRules.IsFooterRow(sheetId, row)) {
                return true;
            }
            else {
                return column < 5 || column > 9;
            }
        };
        P2Sp3Sp1Sheet.prototype.CanEditEventHandler = function (sheetId, row, column, fieldId, levelRow) {
            if (!this._document.CommonRules.IsFooterRow(sheetId, row)) {
                var table = this._document.Sheets.getValue(sheetId).Table;
                if (column < 5) {
                    return table.GetKeyBySourceTable(this._document.P2Sp3InvestProjectInfoTable) != null;
                }
                else if (column >= 5 && column <= 9) {
                    return table.GetKeyBySourceTable(this._document.P2Sp3Sp1InvestInfoTable) != null;
                }
                else if (column > 9) {
                    return table.GetKeyBySourceTable(this._document.P2Sp3Sp1PowerInfoTable) != null;
                }
            }
        };
        P2Sp3Sp1Sheet.prototype.CanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            if (!this._document.CommonRules.IsFooterRow(sheetId, row)) {
                if (column >= 5 && column <= 9) {
                    return false;
                }
                else {
                    return this.CanEditEventHandler(sheetId, row, column, fieldId, rowLevel);
                }
            }
        };
        return P2Sp3Sp1Sheet;
    }(P2SpxSpxSheet));
    F08410.P2Sp3Sp1Sheet = P2Sp3Sp1Sheet;
    var P2Sp3Sp2GroupSheet = (function (_super) {
        __extends(P2Sp3Sp2GroupSheet, _super);
        function P2Sp3Sp2GroupSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(P2Sp3Sp2GroupSheet.prototype, "SheetInfo", {
            get: function () {
                return P2Sp3Sp2GroupSheet._sheetInfo;
            },
            enumerable: true,
            configurable: true
        });
        P2Sp3Sp2GroupSheet.prototype.StandardCalcStrCode = function (param, row, column, info) {
            var sheet = this.GetSheetFromParam(param);
            var curLvl = sheet.GetRowLevel(row) - 1;
            var lvlInc = curLvl > 0 ? info.LevelIncs[curLvl - 1] : 0;
            var prevLvl = -1;
            var prevCode = 0;
            var curCode;
            if (row > 0) {
                prevLvl = sheet.GetRowLevel(row - 1) - 1;
                prevCode = parseInt(sheet.GetCellValue(row - 1, column), 10);
            }
            if (prevLvl === curLvl && curLvl === this.SheetInfo.MaxLevel) {
                curCode = prevCode + lvlInc;
            }
            else if (curLvl === 0) {
                curCode = info.CalcTotalCode(sheet, row, column);
            }
            else {
                curCode = lvlInc;
            }
            return ObasHelper.FillWithCharacter(curCode.toString(), info.Length);
        };
        P2Sp3Sp2GroupSheet.prototype.StandardCalc = function (param, row, column, info) {
            var sheet = this.GetSheetFromParam(param);
            var curLvl = sheet.GetRowLevel(row) - 1;
            if (column === info.CodeInfo.Column) {
                if (curLvl === info.MaxLevel) {
                    var prevInvestKey = sheet.GetCellValue(row - 1, sheet.ColumnCount, false) || 0;
                    var curInvestKey = sheet.GetCellValue(row, sheet.ColumnCount, false) || 0;
                    var prevCode = (row > 0) ? parseInt(sheet.GetCellValue(row - 1, info.CodeInfo.Column)) : 0;
                    if ((curInvestKey > 0 || prevInvestKey > 0) && curInvestKey === prevInvestKey && prevCode > 0 && prevCode !== info.CodeInfo.LevelIncs[curLvl - 2]) {
                        return sheet.GetCellValue(row - 1, info.CodeInfo.Column);
                    }
                }
                return this.StandardCalcStrCode(sheet, row, column, info.CodeInfo);
            }
            else {
                var columnInfo = info.ColumnsInfo[column];
                var rowInfo = void 0;
                if (curLvl === 0) {
                    rowInfo = columnInfo.TotalRow;
                }
                else {
                    if (columnInfo.SubTotalRow instanceof Array) {
                        rowInfo = columnInfo.SubTotalRow[curLvl - 1];
                    }
                    else {
                        var temp = columnInfo.SubTotalRow;
                        rowInfo = temp;
                    }
                }
                if (curLvl === 0) {
                    if (rowInfo.IsCalculated) {
                        var result = new SheetCalcResult(BaseFormulas.SUM);
                        for (var i = 0; i < sheet.RowCount; i++) {
                            var code = parseInt(sheet.GetCellValue(i, info.CodeInfo.Column));
                            if (code === info.CodeInfo.LevelIncs[curLvl]) {
                                result.AddCoordinates(new CellCoordinate(i, column));
                            }
                        }
                        return result.ToArray();
                    }
                }
                else if (curLvl < info.MaxLevel - 1) {
                    if (rowInfo.IsCalculated) {
                        var result = new SheetCalcResult(BaseFormulas.SUM);
                        var code = (row > 0) ? parseInt(sheet.GetCellValue(row - 1, info.CodeInfo.Column)) : 0;
                        var i = row - 1;
                        while (i >= 0 && code > 0 && code !== info.CodeInfo.LevelIncs[curLvl - 1]) {
                            code = (i > 0) ? parseInt(sheet.GetCellValue(i, info.CodeInfo.Column)) : -1;
                            if (code === info.CodeInfo.LevelIncs[curLvl]) {
                                result.AddCoordinates(new CellCoordinate(i, column));
                            }
                            i--;
                        }
                        return result.ToArray();
                    }
                }
                else if (curLvl === info.MaxLevel - 1) {
                    if (rowInfo.IsCalculated) {
                        var result = new SheetCalcResult(BaseFormulas.SUM);
                        var code = (row > 0) ? parseInt(sheet.GetCellValue(row - 1, info.CodeInfo.Column)) : 0;
                        var i = row - 1;
                        while (i >= 0 && code > 0 && code !== info.CodeInfo.LevelIncs[curLvl - 1] && code !== info.CodeInfo.LevelIncs[curLvl - 2]) {
                            var prevCode = (i > 0) ? parseInt(sheet.GetCellValue(i - 1, info.CodeInfo.Column)) : -1;
                            if (code !== prevCode) {
                                result.AddCoordinates(new CellCoordinate(i, column));
                            }
                            code = prevCode;
                            i--;
                        }
                        return result.ToArray();
                    }
                }
            }
            return _super.prototype.StandardCalc.call(this, param, row, column, info);
        };
        P2Sp3Sp2GroupSheet.prototype.CanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return column > 1;
        };
        P2Sp3Sp2GroupSheet.prototype.CanEditEventHandler = function (sheetId, row, column, fieldId, levelRow) {
            var sheet = this._document.Sheets.getValue(sheetId);
            var code = parseInt(sheet.GetCellValue(row, this.SheetInfo.CodeInfo.Column));
            if (code !== 900 && code !== 700) {
                var table = this._document.Sheets.getValue(sheetId).Table;
                if (column > 1 && column <= 9) {
                    return table.GetKeyBySourceTable(this._document.P2Sp3Sp2ObjectInfoTable) != null;
                }
                else if (column > 9 && column <= 17) {
                    return table.GetKeyBySourceTable(this._document.P2Sp3Sp2InvestInfoTable) != null;
                }
                else if (column > 17) {
                    return table.GetKeyBySourceTable(this._document.P2Sp3Sp2PowerInfoTable) != null;
                }
            }
            return false;
        };
        P2Sp3Sp2GroupSheet.prototype.CanDeleteEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return this.CanEditEventHandler(sheetId, row, column, fieldId, rowLevel);
        };
        P2Sp3Sp2GroupSheet._totalRowInfo = {
            IsCalculated: false,
            Name: "\u0412\u0441\u0435\u0433\u043E",
            Format: SheetFormatCollection.Default
        };
        P2Sp3Sp2GroupSheet._totalInvestProjectRowInfo = {
            IsCalculated: false,
            Name: "\u0418\u0442\u043E\u0433\u043E \u043F\u043E \u043C\u0435\u0440\u043E\u043F\u0440\u0438\u044F\u0442\u0438\u044E",
            Format: SheetFormatCollection.Default
        };
        P2Sp3Sp2GroupSheet._totalObjectRowInfo = {
            IsCalculated: false,
            Name: "\u0418\u0442\u043E\u0433\u043E \u043F\u043E \u043E\u0431\u044A\u0435\u043A\u0442\u0443",
            Format: SheetFormatCollection.Default
        };
        P2Sp3Sp2GroupSheet._subTotalRowInfos = [
            P2Sp3Sp2GroupSheet._totalInvestProjectRowInfo, P2Sp3Sp2GroupSheet._totalObjectRowInfo
        ];
        P2Sp3Sp2GroupSheet._sprColDefault = {
            Cell: { Type: SheetCellTypes.Spr },
            SubTotalRow: [SheetRowInfoCollection.Default, SheetRowInfoCollection.SprOnlyFormatRow],
            TotalRow: SheetRowInfoCollection.Default
        };
        P2Sp3Sp2GroupSheet._freeColDefault = {
            Cell: { Type: SheetCellTypes.Free },
            SubTotalRow: [SheetRowInfoCollection.Default, SheetRowInfoCollection.FreeOnlyFormatRow],
            TotalRow: SheetRowInfoCollection.Default
        };
        P2Sp3Sp2GroupSheet._sprColAllDefault = {
            Cell: { Type: SheetCellTypes.Spr },
            SubTotalRow: [SheetRowInfoCollection.Default, SheetRowInfoCollection.Default],
            TotalRow: SheetRowInfoCollection.Default
        };
        P2Sp3Sp2GroupSheet._freeColAllConst = {
            Cell: { Type: SheetCellTypes.Free },
            SubTotalRow: P2Sp3Sp2GroupSheet._subTotalRowInfos,
            TotalRow: P2Sp3Sp2GroupSheet._totalRowInfo
        };
        P2Sp3Sp2GroupSheet._codeInfo = {
            Column: 13,
            Length: 3,
            LevelIncs: [700, 600, 1],
            CalcTotalCode: function () {
                return 900;
            }
        };
        P2Sp3Sp2GroupSheet._sheetInfo = {
            MaxLevel: 3,
            CodeInfo: P2Sp3Sp2GroupSheet._codeInfo,
            ColumnsInfo: [
                SheetColumnInfoCollection.RelatedColDefaultTotal,
                SheetColumnInfoCollection.RelatedColDefaultTotal,
                P2Sp3Sp2GroupSheet._sprColDefault,
                P2Sp3Sp2GroupSheet._sprColDefault,
                P2Sp3Sp2GroupSheet._sprColDefault,
                P2Sp3Sp2GroupSheet._sprColDefault,
                P2Sp3Sp2GroupSheet._sprColDefault,
                P2Sp3Sp2GroupSheet._sprColDefault,
                P2Sp3Sp2GroupSheet._freeColDefault,
                P2Sp3Sp2GroupSheet._freeColDefault,
                P2Sp3Sp2GroupSheet._sprColAllDefault,
                P2Sp3Sp2GroupSheet._sprColAllDefault,
                P2Sp3Sp2GroupSheet._freeColAllConst,
                SheetColumnInfoCollection.AllDefault,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.SprColAllX,
                SheetColumnInfoCollection.SprColAllX,
                SheetColumnInfoCollection.FreeColAllX,
                SheetColumnInfoCollection.FreeColAllX
            ]
        };
        return P2Sp3Sp2GroupSheet;
    }(HierarchyYearGroupSheet));
    F08410.P2Sp3Sp2GroupSheet = P2Sp3Sp2GroupSheet;
})(F08410 || (F08410 = {}));
