var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F08410;
(function (F08410) {
    var TableRules = (function () {
        function TableRules(_document) {
            this._document = _document;
        }
        return TableRules;
    }());
    F08410.TableRules = TableRules;
    var StrKeysP1;
    (function (StrKeysP1) {
        StrKeysP1[StrKeysP1["Total"] = 1] = "Total";
        StrKeysP1[StrKeysP1["P2Sp1Sp1"] = 2] = "P2Sp1Sp1";
        StrKeysP1[StrKeysP1["P2Sp2Sp1"] = 3] = "P2Sp2Sp1";
        StrKeysP1[StrKeysP1["P2Sp3Sp1"] = 4] = "P2Sp3Sp1";
    })(StrKeysP1 = F08410.StrKeysP1 || (F08410.StrKeysP1 = {}));
    var FObasTableP1Total = (function (_super) {
        __extends(FObasTableP1Total, _super);
        function FObasTableP1Total() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FObasTableP1Total.prototype.GetTotalKey = function () {
            return StrKeysP1.Total;
        };
        return FObasTableP1Total;
    }(P1TotalObasTable));
    F08410.FObasTableP1Total = FObasTableP1Total;
    var P2TotalTable = (function (_super) {
        __extends(P2TotalTable, _super);
        function P2TotalTable(id, _document) {
            var _this = _super.call(this, id) || this;
            _this._document = _document;
            _this._object = null;
            _this._action = null;
            _this._objectTableIds = [];
            _this._actionTableIds = [];
            _this._investObjectTables = [];
            _this._investActionTables = [];
            return _this;
        }
        Object.defineProperty(P2TotalTable.prototype, "Object", {
            get: function () {
                if (this._object == null) {
                    this._object = new ObasSprTableField(this._document.ObjectsSprTable, this);
                }
                return this._object;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(P2TotalTable.prototype, "Action", {
            get: function () {
                if (this._action == null) {
                    this._action = new ObasSprTableField(this._document.ActionsSprTable, this);
                }
                return this._action;
            },
            enumerable: true,
            configurable: true
        });
        P2TotalTable.prototype.CalcObjName = function () {
            var objName = this.Object.Name;
            return objName ? objName : this.Action.Name;
        };
        P2TotalTable.prototype.CalcObjCode = function () {
            var objCode = this.Object.Code;
            return objCode ? objCode : this.Action.Code;
        };
        P2TotalTable.prototype.AddObjectTableId = function (child) {
            var childId = child.Id;
            if (this._objectTableIds.indexOf(childId) === -1) {
                this._objectTableIds.push(childId);
            }
        };
        P2TotalTable.prototype.AddObject = function (objectKey) {
            this._document.CommonRules.AddNewLink(this.Id, [this.Object.ForeignKey.Id], [objectKey]);
            this.RecalcSums(objectKey, this.Object.ForeignKey.Id);
        };
        P2TotalTable.prototype.DeleteObject = function (objectKey) {
            this._document.CommonRules.DeleteOldLink(this.Id, this._objectTableIds, [this.Object.ForeignKey.Id], [objectKey || -1]);
            this.RecalcSums(objectKey, this.Object.ForeignKey.Id);
        };
        P2TotalTable.prototype.AddActionTableId = function (child) {
            var childId = child.Id;
            if (this._actionTableIds.indexOf(childId) === -1) {
                this._actionTableIds.push(childId);
            }
        };
        P2TotalTable.prototype.AddAction = function (actionKey) {
            this._document.CommonRules.AddNewLink(this.Id, [this.Action.ForeignKey.Id], [actionKey]);
            this.RecalcSums(actionKey, this.Action.ForeignKey.Id);
        };
        P2TotalTable.prototype.DeleteAction = function (actionKey) {
            this._document.CommonRules.DeleteOldLink(this.Id, this._actionTableIds, [this.Action.ForeignKey.Id], [actionKey || -1]);
            this.RecalcSums(actionKey, this.Action.ForeignKey.Id);
        };
        P2TotalTable.prototype.AddInvestTableId = function (child, parent) {
            var isObject = (this._objectTableIds.indexOf(parent.Id) !== -1);
            var isAction = (this._actionTableIds.indexOf(parent.Id) !== -1);
            if (isObject || isAction) {
                var investTables = isObject ? this._investObjectTables : this._investActionTables;
                var childId = child;
                if (investTables.indexOf(child) === -1) {
                    investTables.push(child);
                }
            }
        };
        P2TotalTable.prototype.ChangeSum = function (tableId, oldValue, newValue, fieldId) {
            var investTable = this._document.Tables.getValue(tableId);
            var isObject = investTable.IsFieldExists(this.Object.ForeignKey.Id);
            var objFieldId = isObject ? this.Object.ForeignKey.Id : this.Action.ForeignKey.Id;
            var objFieldValue = investTable.GetFieldValue(objFieldId);
            if (this.Locate(objFieldId, objFieldValue)) {
                this.SetFieldValue(fieldId, this.GetFieldValue(fieldId) + (newValue - oldValue));
            }
        };
        P2TotalTable.prototype.RecalcSums = function (objFieldValue, objFieldId) {
            if (objFieldValue != null) {
                if (this.Locate(objFieldId, objFieldValue)) {
                    var yearsCount = this._document.Settings.YearsCount;
                    var yearField = BaseObasTableFields.YearDataField;
                    for (var i = 0; i < yearsCount; i++) {
                        this.SetFieldValue(yearField.GenerateId(i + 1), 0);
                    }
                    var investTables = (objFieldId === this.Object.ForeignKey.Id) ? this._investObjectTables : this._investActionTables;
                    for (var i = 0; i < investTables.length; i++) {
                        var investTable = investTables[i];
                        var reader = investTable.CreateReader();
                        while (reader.Read()) {
                            if (investTable.ParentTable.GetFieldValue(objFieldId) === objFieldValue) {
                                for (var j = 0; j < yearsCount; j++) {
                                    this.SetFieldValue(yearField.GenerateId(j + 1), this.GetFieldValue(yearField.GenerateId(j + 1)) + investTable.GetFieldValue(yearField.GenerateId(j + 1)));
                                }
                            }
                        }
                    }
                }
            }
        };
        return P2TotalTable;
    }(ObasTable));
    F08410.P2TotalTable = P2TotalTable;
    var ObjectInfoTable = (function (_super) {
        __extends(ObjectInfoTable, _super);
        function ObjectInfoTable(id, _document, _sumTable) {
            var _this = _super.call(this, id) || this;
            _this._document = _document;
            _this._sumTable = _sumTable;
            _this._object = null;
            _this._customer = null;
            _this._oktmo = null;
            _this._address = null;
            _this._cost = null;
            _this._objectKey = null;
            _this._sumTable.AddObjectTableId(_this);
            return _this;
        }
        Object.defineProperty(ObjectInfoTable.prototype, "Object", {
            get: function () {
                if (this._object == null) {
                    this._object = new ObasSprTableField(this._document.ObjectsSprTable, this);
                }
                return this._object;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ObjectInfoTable.prototype, "Customer", {
            get: function () {
                if (this._customer == null) {
                    this._customer = new ObasSprTableField(this._document.CustomersSprTable, this);
                }
                return this._customer;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ObjectInfoTable.prototype, "Oktmo", {
            get: function () {
                if (this._oktmo == null) {
                    this._oktmo = new ObasSprTableField(this._document.OktmoSprTable, this);
                }
                return this._oktmo;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ObjectInfoTable.prototype, "Address", {
            get: function () {
                if (this._address == null) {
                    this._address = new NumberObasTableField("Address", this);
                }
                return this._address;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ObjectInfoTable.prototype, "Cost", {
            get: function () {
                if (this._cost == null) {
                    this._cost = new NumberObasTableField("Cost", this);
                }
                return this._cost;
            },
            enumerable: true,
            configurable: true
        });
        ObjectInfoTable.prototype.ObjectChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this.AfterDeleteEventHandler(this.Id, oldValue);
            this._sumTable.AddObject(newValue);
        };
        ObjectInfoTable.prototype.DeleteEventHandler = function (tableId) {
            this._objectKey = this.Object.ForeignKey.Value;
        };
        ObjectInfoTable.prototype.AfterDeleteEventHandler = function (tableId, objectKey) {
            if (objectKey === void 0) { objectKey = this._objectKey; }
            this._sumTable.DeleteObject(objectKey);
        };
        return ObjectInfoTable;
    }(ObasTable));
    F08410.ObjectInfoTable = ObjectInfoTable;
    var InvestInfoTable = (function (_super) {
        __extends(InvestInfoTable, _super);
        function InvestInfoTable(id, _document, _parentTable, _totalTable, _totalRowKey, _sumTable) {
            var _this = _super.call(this, id, _document, _parentTable) || this;
            _this._document = _document;
            _this._parentTable = _parentTable;
            _this._totalTable = _totalTable;
            _this._totalRowKey = _totalRowKey;
            _this._sumTable = _sumTable;
            _this._investigationType = null;
            _this._okved = null;
            _this._startUseDate = null;
            _this._sumTable.AddInvestTableId(_this, _parentTable);
            return _this;
        }
        Object.defineProperty(InvestInfoTable.prototype, "ParentTable", {
            get: function () {
                return this.OwnerKey.SourceTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InvestInfoTable.prototype, "InvestigationType", {
            get: function () {
                if (this._investigationType == null) {
                    this._investigationType = new ObasSprTableField(ObasTableCollection.InvestigationTypesSprTable, this, "Investigation");
                }
                return this._investigationType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InvestInfoTable.prototype, "Okved", {
            get: function () {
                if (this._okved == null) {
                    this._okved = new ObasSprTableField(ObasTableCollection.OkvedSprTable, this);
                }
                return this._okved;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InvestInfoTable.prototype, "StartUseDate", {
            get: function () {
                if (this._startUseDate == null) {
                    this._startUseDate = new ObasTableField("StartUseDate", this);
                }
                return this._startUseDate;
            },
            enumerable: true,
            configurable: true
        });
        InvestInfoTable.prototype.SumChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this._totalTable.SetSumByKeys(fieldId, this._totalTable.GetKeys(this._totalRowKey), oldValue, newValue);
            this._sumTable.ChangeSum(tableId, oldValue, newValue, fieldId);
        };
        InvestInfoTable.prototype.AfterDeleteChildsEventHandler = function (tableId) {
            var _this = this;
            var yearField = BaseObasTableFields.YearDataField;
            this.Document.IterateByYears(function (yearIndex) {
                var fieldId = yearField.GenerateId(yearIndex);
                _this.SetFieldValue(fieldId, 0);
            });
        };
        return InvestInfoTable;
    }(ObasTableWithSimpleKeysParent));
    F08410.InvestInfoTable = InvestInfoTable;
    var PowerInfoTable = (function (_super) {
        __extends(PowerInfoTable, _super);
        function PowerInfoTable(id, _document, parent) {
            var _this = _super.call(this, id, _document, parent) || this;
            _this._document = _document;
            _this._okei = null;
            _this._name = null;
            _this._value = null;
            return _this;
        }
        Object.defineProperty(PowerInfoTable.prototype, "ParentTable", {
            get: function () {
                return this.OwnerKey.SourceTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PowerInfoTable.prototype, "Okei", {
            get: function () {
                if (this._okei == null) {
                    this._okei = new ObasSprTableField(ObasTableCollection.OkeiSprTable, this);
                }
                return this._okei;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PowerInfoTable.prototype, "Name", {
            get: function () {
                if (this._name == null) {
                    this._name = new NumberObasTableField("Name", this);
                }
                return this._name;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PowerInfoTable.prototype, "Value", {
            get: function () {
                if (this._value == null) {
                    this._value = new NumberObasTableField("Value", this);
                }
                return this._value;
            },
            enumerable: true,
            configurable: true
        });
        return PowerInfoTable;
    }(ObasTableWithSimpleKeysParent));
    F08410.PowerInfoTable = PowerInfoTable;
    var ProjectDocsTable = (function (_super) {
        __extends(ProjectDocsTable, _super);
        function ProjectDocsTable(id, _document, parent) {
            var _this = _super.call(this, id, _document, parent) || this;
            _this._document = _document;
            _this._projectDocStatus = null;
            _this._dateApproveProjectDoc = null;
            return _this;
        }
        Object.defineProperty(ProjectDocsTable.prototype, "ParentTable", {
            get: function () {
                return this.OwnerKey.SourceTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ProjectDocsTable.prototype, "ProjectDocStatus", {
            get: function () {
                if (this._projectDocStatus == null) {
                    this._projectDocStatus = new ObasSprTableField(ObasTableCollection.SprProjectDocStatus, this);
                }
                return this._projectDocStatus;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ProjectDocsTable.prototype, "DateApproveProjectDoc", {
            get: function () {
                if (this._dateApproveProjectDoc == null) {
                    this._dateApproveProjectDoc = new ObasTableField("DateApproveProjectDoc", this);
                }
                return this._dateApproveProjectDoc;
            },
            enumerable: true,
            configurable: true
        });
        ProjectDocsTable.prototype.IsProjectDocStatusNotApproved = function () {
            return (this.ProjectDocStatus.ForeignKey.Value !== 1);
        };
        ProjectDocsTable.prototype.ProjectDocStatusChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            if (this.ProjectDocStatus.ForeignKey.Value !== 1) {
                this.DateApproveProjectDoc.Value = null;
            }
        };
        return ProjectDocsTable;
    }(ObasTableWithSimpleKeysParent));
    F08410.ProjectDocsTable = ProjectDocsTable;
    var LandPlotsTable = (function (_super) {
        __extends(LandPlotsTable, _super);
        function LandPlotsTable(id, _document, parent) {
            var _this = _super.call(this, id, _document, parent) || this;
            _this._document = _document;
            _this._landPlotStatus = null;
            _this._legalSubject = null;
            return _this;
        }
        Object.defineProperty(LandPlotsTable.prototype, "ParentTable", {
            get: function () {
                return this.OwnerKey.SourceTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LandPlotsTable.prototype, "LandPlotStatus", {
            get: function () {
                if (this._landPlotStatus == null) {
                    this._landPlotStatus = new ObasSprTableField(ObasTableCollection.SprLandPlotStatus, this);
                }
                return this._landPlotStatus;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LandPlotsTable.prototype, "LegalSubject", {
            get: function () {
                if (this._legalSubject == null) {
                    this._legalSubject = new ObasSprTableField(ObasTableCollection.SprLegalSubject, this);
                }
                return this._legalSubject;
            },
            enumerable: true,
            configurable: true
        });
        return LandPlotsTable;
    }(ObasTableWithSimpleKeysParent));
    F08410.LandPlotsTable = LandPlotsTable;
    var NpaTable = (function (_super) {
        __extends(NpaTable, _super);
        function NpaTable(id, _document, parent) {
            var _this = _super.call(this, id, _document, parent) || this;
            _this._document = _document;
            _this._npaFields = null;
            _this._npaStatus = null;
            _this._npsStatusChangeDate = null;
            _this._npa = null;
            return _this;
        }
        Object.defineProperty(NpaTable.prototype, "ParentTable", {
            get: function () {
                return this.OwnerKey.SourceTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NpaTable.prototype, "NpaFields", {
            get: function () {
                if (this._npaFields == null) {
                    this._npaFields = new NpaRequisitesFields(this);
                }
                return this._npaFields;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NpaTable.prototype, "NpaNumber", {
            get: function () {
                return this.NpaFields.NpaNumber;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NpaTable.prototype, "NpaName", {
            get: function () {
                return this.NpaFields.NpaName;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NpaTable.prototype, "NpaDate", {
            get: function () {
                return this.NpaFields.NpaDate;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NpaTable.prototype, "NpaType", {
            get: function () {
                return this.NpaFields.NpaType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NpaTable.prototype, "NpaStatus", {
            get: function () {
                if (this._npaStatus == null) {
                    this._npaStatus = new ObasSprTableField(ObasTableCollection.NpaStatusesSprTable, this);
                }
                return this._npaStatus;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NpaTable.prototype, "NpaStatusChangeDate", {
            get: function () {
                if (this._npsStatusChangeDate == null) {
                    this._npsStatusChangeDate = new ObasTableField("NpaChangeDate", this);
                }
                return this._npsStatusChangeDate;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NpaTable.prototype, "Npa", {
            get: function () {
                if (this._npa == null) {
                    this._npa = new ObasSprTableField(ObasTableCollection.NpaSprTable, this);
                }
                return this._npa;
            },
            enumerable: true,
            configurable: true
        });
        NpaTable.prototype.GetNpaFieldsId = function () {
            var result = [];
            result.push(this.NpaType.ForeignKey.Id);
            result.push(this.NpaNumber.Id);
            result.push(this.NpaName.Id);
            result.push(this.NpaDate.Id);
            result.push(this.NpaStatus.ForeignKey.Id);
            result.push(this.NpaStatusChangeDate.Id);
            return result;
        };
        NpaTable.prototype.GetNpaFieldsValue = function () {
            var result = [];
            result.push(this.NpaType.ForeignKey.Value);
            result.push(this.NpaNumber.Value);
            result.push(this.NpaName.Value);
            result.push(this.NpaDate.Value);
            result.push(this.NpaStatus.ForeignKey.Value);
            result.push(this.NpaStatusChangeDate.Value);
            return result;
        };
        NpaTable.prototype.CopyNpaData = function (keyValues) {
            var keyIds = this.GetNpaFieldsId();
            for (var i = 0; i < keyIds.length; i++) {
                this.SetFieldValue(keyIds[i], keyValues[i]);
            }
        };
        NpaTable.prototype.NpaChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this.CopyNpaData(this.Npa.ForeignKey.SourceTable.GetNpaFieldsValue());
        };
        return NpaTable;
    }(ObasTableWithSimpleKeysParent));
    F08410.NpaTable = NpaTable;
    var DecisionCoordinatingBodyTable = (function (_super) {
        __extends(DecisionCoordinatingBodyTable, _super);
        function DecisionCoordinatingBodyTable(id, _document, parent) {
            var _this = _super.call(this, id, _document, parent) || this;
            _this._document = _document;
            _this._name = null;
            _this._protocolNumber = null;
            _this._protocolDate = null;
            return _this;
        }
        Object.defineProperty(DecisionCoordinatingBodyTable.prototype, "ParentTable", {
            get: function () {
                return this.OwnerKey.SourceTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DecisionCoordinatingBodyTable.prototype, "Name", {
            get: function () {
                if (this._name == null) {
                    this._name = new NumberObasTableField("Name", this);
                }
                return this._name;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DecisionCoordinatingBodyTable.prototype, "ProtocolNumber", {
            get: function () {
                if (this._protocolNumber == null) {
                    this._protocolNumber = new NumberObasTableField("ProtocolNumber", this);
                }
                return this._protocolNumber;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DecisionCoordinatingBodyTable.prototype, "ProtocolDate", {
            get: function () {
                if (this._protocolDate == null) {
                    this._protocolDate = new NumberObasTableField("ProtocolDate", this);
                }
                return this._protocolDate;
            },
            enumerable: true,
            configurable: true
        });
        return DecisionCoordinatingBodyTable;
    }(ObasTableWithSimpleKeysParent));
    F08410.DecisionCoordinatingBodyTable = DecisionCoordinatingBodyTable;
    var InvestProjectInfoTable = (function (_super) {
        __extends(InvestProjectInfoTable, _super);
        function InvestProjectInfoTable(id, _document, _sumTable) {
            var _this = _super.call(this, id) || this;
            _this._document = _document;
            _this._sumTable = _sumTable;
            _this._action = null;
            _this._okved = null;
            _this._cost = null;
            _this._startUseDate = null;
            _this._actionKey = null;
            _this._sumTable.AddActionTableId(_this);
            return _this;
        }
        Object.defineProperty(InvestProjectInfoTable.prototype, "Action", {
            get: function () {
                if (this._action == null) {
                    this._action = new ObasSprTableField(this._document.ActionsSprTable, this);
                }
                return this._action;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InvestProjectInfoTable.prototype, "Okved", {
            get: function () {
                if (this._okved == null) {
                    this._okved = new ObasSprTableField(ObasTableCollection.OkvedSprTable, this);
                }
                return this._okved;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InvestProjectInfoTable.prototype, "Cost", {
            get: function () {
                if (this._cost == null) {
                    this._cost = new NumberObasTableField("Cost", this);
                }
                return this._cost;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InvestProjectInfoTable.prototype, "StartUseDate", {
            get: function () {
                if (this._startUseDate == null) {
                    this._startUseDate = new ObasTableField("StartUseDate", this);
                }
                return this._startUseDate;
            },
            enumerable: true,
            configurable: true
        });
        InvestProjectInfoTable.prototype.ActionChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this.AfterDeleteEventHandler(this.Id, oldValue);
            this._sumTable.AddAction(newValue);
        };
        InvestProjectInfoTable.prototype.DeleteEventHandler = function (tableId) {
            this._actionKey = this.Action.ForeignKey.Value;
        };
        InvestProjectInfoTable.prototype.AfterDeleteEventHandler = function (tableId, actionKey) {
            if (actionKey === void 0) { actionKey = this._actionKey; }
            this._sumTable.DeleteAction(actionKey);
        };
        return InvestProjectInfoTable;
    }(ObasTable));
    F08410.InvestProjectInfoTable = InvestProjectInfoTable;
    var ObjectInfoTableWithParent = (function (_super) {
        __extends(ObjectInfoTableWithParent, _super);
        function ObjectInfoTableWithParent(id, _document, _parentTable, _sumTable) {
            var _this = _super.call(this, id, _document, _parentTable) || this;
            _this._document = _document;
            _this._parentTable = _parentTable;
            _this._sumTable = _sumTable;
            _this._object = null;
            _this._customer = null;
            _this._oktmo = null;
            _this._address = null;
            _this._cost = null;
            _this._objectKey = null;
            _this._sumTable.AddObjectTableId(_this);
            return _this;
        }
        Object.defineProperty(ObjectInfoTableWithParent.prototype, "ParentTable", {
            get: function () {
                return this.OwnerKey.SourceTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ObjectInfoTableWithParent.prototype, "Object", {
            get: function () {
                if (this._object == null) {
                    this._object = new ObasSprTableField(this._document.ObjectsSprTable, this);
                }
                return this._object;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ObjectInfoTableWithParent.prototype, "Customer", {
            get: function () {
                if (this._customer == null) {
                    this._customer = new ObasSprTableField(this._document.CustomersSprTable, this);
                }
                return this._customer;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ObjectInfoTableWithParent.prototype, "Oktmo", {
            get: function () {
                if (this._oktmo == null) {
                    this._oktmo = new ObasSprTableField(this._document.OktmoSprTable, this);
                }
                return this._oktmo;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ObjectInfoTableWithParent.prototype, "Address", {
            get: function () {
                if (this._address == null) {
                    this._address = new NumberObasTableField("Address", this);
                }
                return this._address;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ObjectInfoTableWithParent.prototype, "Cost", {
            get: function () {
                if (this._cost == null) {
                    this._cost = new NumberObasTableField("Cost", this);
                }
                return this._cost;
            },
            enumerable: true,
            configurable: true
        });
        ObjectInfoTableWithParent.prototype.ObjectChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this.AfterDeleteEventHandler(this.Id, oldValue);
            this._sumTable.AddObject(newValue);
        };
        ObjectInfoTableWithParent.prototype.DeleteEventHandler = function (tableId) {
            this._objectKey = this.Object.ForeignKey.Value;
        };
        ObjectInfoTableWithParent.prototype.AfterDeleteEventHandler = function (tableId, objectKey) {
            if (objectKey === void 0) { objectKey = this._objectKey; }
            this._sumTable.DeleteObject(objectKey);
        };
        return ObjectInfoTableWithParent;
    }(ObasTableWithSimpleKeysParent));
    F08410.ObjectInfoTableWithParent = ObjectInfoTableWithParent;
    var P2Sp2ObjectInfoTable = (function (_super) {
        __extends(P2Sp2ObjectInfoTable, _super);
        function P2Sp2ObjectInfoTable() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P2Sp2ObjectInfoTable.prototype.AddEventHandler = function (tableId) {
            var investTable = this._document.P2Sp2InvestInfoTable;
            investTable.AddRow();
            investTable.PostRow();
        };
        return P2Sp2ObjectInfoTable;
    }(ObjectInfoTable));
    F08410.P2Sp2ObjectInfoTable = P2Sp2ObjectInfoTable;
    var P2Sp3InvestProjectInfoTable = (function (_super) {
        __extends(P2Sp3InvestProjectInfoTable, _super);
        function P2Sp3InvestProjectInfoTable() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P2Sp3InvestProjectInfoTable.prototype.AddEventHandler = function (tableId) {
            var investTable = this._document.P2Sp3Sp1InvestInfoTable;
            investTable.AddRow();
            investTable.PostRow();
        };
        return P2Sp3InvestProjectInfoTable;
    }(InvestProjectInfoTable));
    F08410.P2Sp3InvestProjectInfoTable = P2Sp3InvestProjectInfoTable;
    var P2Sp3Sp2InvestInfoTable = (function (_super) {
        __extends(P2Sp3Sp2InvestInfoTable, _super);
        function P2Sp3Sp2InvestInfoTable() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        P2Sp3Sp2InvestInfoTable.prototype.SumChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
            this._sumTable.ChangeSum(tableId, oldValue, newValue, fieldId);
        };
        return P2Sp3Sp2InvestInfoTable;
    }(InvestInfoTable));
    F08410.P2Sp3Sp2InvestInfoTable = P2Sp3Sp2InvestInfoTable;
})(F08410 || (F08410 = {}));
